<?php

namespace PHPMaker2024\cidp24;

use Doctrine\DBAL\ParameterType;
use Doctrine\DBAL\Connection;
use Doctrine\DBAL\Query\QueryBuilder;
use Psr\Http\Message\ServerRequestInterface as Request;
use Psr\Http\Message\ResponseInterface as Response;
use Psr\Container\ContainerInterface;
use Slim\Routing\RouteCollectorProxy;
use Slim\App;
use PhpOffice\PhpSpreadsheet\Style\NumberFormat;
use Closure;

/**
 * Page class
 */
class Season2021List extends Season2021
{
    use MessagesTrait;

    // Page ID
    public $PageID = "list";

    // Project ID
    public $ProjectID = PROJECT_ID;

    // Page object name
    public $PageObjName = "Season2021List";

    // View file path
    public $View = null;

    // Title
    public $Title = null; // Title for <title> tag

    // Rendering View
    public $RenderingView = false;

    // Grid form hidden field names
    public $FormName = "fseason20_21list";
    public $FormActionName = "";
    public $FormBlankRowName = "";
    public $FormKeyCountName = "";

    // CSS class/style
    public $CurrentPageName = "Season2021List";

    // Page URLs
    public $AddUrl;
    public $EditUrl;
    public $DeleteUrl;
    public $ViewUrl;
    public $CopyUrl;
    public $ListUrl;

    // Update URLs
    public $InlineAddUrl;
    public $InlineCopyUrl;
    public $InlineEditUrl;
    public $GridAddUrl;
    public $GridEditUrl;
    public $MultiEditUrl;
    public $MultiDeleteUrl;
    public $MultiUpdateUrl;

    // Page headings
    public $Heading = "";
    public $Subheading = "";
    public $PageHeader;
    public $PageFooter;

    // Page layout
    public $UseLayout = true;

    // Page terminated
    private $terminated = false;

    // Page heading
    public function pageHeading()
    {
        global $Language;
        if ($this->Heading != "") {
            return $this->Heading;
        }
        if (method_exists($this, "tableCaption")) {
            return $this->tableCaption();
        }
        return "";
    }

    // Page subheading
    public function pageSubheading()
    {
        global $Language;
        if ($this->Subheading != "") {
            return $this->Subheading;
        }
        if ($this->TableName) {
            return $Language->phrase($this->PageID);
        }
        return "";
    }

    // Page name
    public function pageName()
    {
        return CurrentPageName();
    }

    // Page URL
    public function pageUrl($withArgs = true)
    {
        $route = GetRoute();
        $args = RemoveXss($route->getArguments());
        if (!$withArgs) {
            foreach ($args as $key => &$val) {
                $val = "";
            }
            unset($val);
        }
        return rtrim(UrlFor($route->getName(), $args), "/") . "?";
    }

    // Show Page Header
    public function showPageHeader()
    {
        $header = $this->PageHeader;
        $this->pageDataRendering($header);
        if ($header != "") { // Header exists, display
            echo '<div id="ew-page-header">' . $header . '</div>';
        }
    }

    // Show Page Footer
    public function showPageFooter()
    {
        $footer = $this->PageFooter;
        $this->pageDataRendered($footer);
        if ($footer != "") { // Footer exists, display
            echo '<div id="ew-page-footer">' . $footer . '</div>';
        }
    }

    // Set field visibility
    public function setVisibility()
    {
        $this->SerialNo->setVisibility();
        $this->IPC->setVisibility();
        $this->PageNo->setVisibility();
        $this->Activity->setVisibility();
        $this->District->setVisibility();
        $this->Block->setVisibility();
        $this->Camp->setVisibility();
        $this->NurseryArea->setVisibility();
        $this->Zone->setVisibility();
        $this->ChiefArea->setVisibility();
        $this->Date->setVisibility();
        $this->Village->setVisibility();
        $this->NameOfFarmer->setVisibility();
        $this->YearOfBirth->setVisibility();
        $this->Gender->setVisibility();
        $this->NRC->setVisibility();
        $this->SeedlingsReceived20_21->setVisibility();
        $this->FieldType->setVisibility();
        $this->Contact->setVisibility();
    }

    // Constructor
    public function __construct()
    {
        parent::__construct();
        global $Language, $DashboardReport, $DebugTimer, $UserTable;
        $this->FormActionName = Config("FORM_ROW_ACTION_NAME");
        $this->FormBlankRowName = Config("FORM_BLANK_ROW_NAME");
        $this->FormKeyCountName = Config("FORM_KEY_COUNT_NAME");
        $this->TableVar = 'season20_21';
        $this->TableName = 'season20_21';

        // Table CSS class
        $this->TableClass = "table table-bordered table-hover table-sm ew-table";

        // CSS class name as context
        $this->ContextClass = CheckClassName($this->TableVar);
        AppendClass($this->TableGridClass, $this->ContextClass);

        // Fixed header table
        if (!$this->UseCustomTemplate) {
            $this->setFixedHeaderTable(Config("USE_FIXED_HEADER_TABLE"), Config("FIXED_HEADER_TABLE_HEIGHT"));
        }

        // Initialize
        $GLOBALS["Page"] = &$this;

        // Language object
        $Language = Container("app.language");

        // Table object (season20_21)
        if (!isset($GLOBALS["season20_21"]) || $GLOBALS["season20_21"]::class == PROJECT_NAMESPACE . "season20_21") {
            $GLOBALS["season20_21"] = &$this;
        }

        // Page URL
        $pageUrl = $this->pageUrl(false);

        // Initialize URLs
        $this->AddUrl = "Season2021Add";
        $this->InlineAddUrl = $pageUrl . "action=add";
        $this->GridAddUrl = $pageUrl . "action=gridadd";
        $this->GridEditUrl = $pageUrl . "action=gridedit";
        $this->MultiEditUrl = $pageUrl . "action=multiedit";
        $this->MultiDeleteUrl = "Season2021Delete";
        $this->MultiUpdateUrl = "Season2021Update";

        // Table name (for backward compatibility only)
        if (!defined(PROJECT_NAMESPACE . "TABLE_NAME")) {
            define(PROJECT_NAMESPACE . "TABLE_NAME", 'season20_21');
        }

        // Start timer
        $DebugTimer = Container("debug.timer");

        // Debug message
        LoadDebugMessage();

        // Open connection
        $GLOBALS["Conn"] ??= $this->getConnection();

        // User table object
        $UserTable = Container("usertable");

        // List options
        $this->ListOptions = new ListOptions(Tag: "td", TableVar: $this->TableVar);

        // Export options
        $this->ExportOptions = new ListOptions(TagClassName: "ew-export-option");

        // Import options
        $this->ImportOptions = new ListOptions(TagClassName: "ew-import-option");

        // Other options
        $this->OtherOptions = new ListOptionsArray();

        // Grid-Add/Edit
        $this->OtherOptions["addedit"] = new ListOptions(
            TagClassName: "ew-add-edit-option",
            UseDropDownButton: false,
            DropDownButtonPhrase: $Language->phrase("ButtonAddEdit"),
            UseButtonGroup: true
        );

        // Detail tables
        $this->OtherOptions["detail"] = new ListOptions(TagClassName: "ew-detail-option");
        // Actions
        $this->OtherOptions["action"] = new ListOptions(TagClassName: "ew-action-option");

        // Column visibility
        $this->OtherOptions["column"] = new ListOptions(
            TableVar: $this->TableVar,
            TagClassName: "ew-column-option",
            ButtonGroupClass: "ew-column-dropdown",
            UseDropDownButton: true,
            DropDownButtonPhrase: $Language->phrase("Columns"),
            DropDownAutoClose: "outside",
            UseButtonGroup: false
        );

        // Filter options
        $this->FilterOptions = new ListOptions(TagClassName: "ew-filter-option");

        // List actions
        $this->ListActions = new ListActions();
    }

    // Get content from stream
    public function getContents(): string
    {
        global $Response;
        return $Response?->getBody() ?? ob_get_clean();
    }

    // Is lookup
    public function isLookup()
    {
        return SameText(Route(0), Config("API_LOOKUP_ACTION"));
    }

    // Is AutoFill
    public function isAutoFill()
    {
        return $this->isLookup() && SameText(Post("ajax"), "autofill");
    }

    // Is AutoSuggest
    public function isAutoSuggest()
    {
        return $this->isLookup() && SameText(Post("ajax"), "autosuggest");
    }

    // Is modal lookup
    public function isModalLookup()
    {
        return $this->isLookup() && SameText(Post("ajax"), "modal");
    }

    // Is terminated
    public function isTerminated()
    {
        return $this->terminated;
    }

    /**
     * Terminate page
     *
     * @param string $url URL for direction
     * @return void
     */
    public function terminate($url = "")
    {
        if ($this->terminated) {
            return;
        }
        global $TempImages, $DashboardReport, $Response;

        // Page is terminated
        $this->terminated = true;

        // Page Unload event
        if (method_exists($this, "pageUnload")) {
            $this->pageUnload();
        }
        DispatchEvent(new PageUnloadedEvent($this), PageUnloadedEvent::NAME);
        if (!IsApi() && method_exists($this, "pageRedirecting")) {
            $this->pageRedirecting($url);
        }

        // Close connection
        CloseConnections();

        // Return for API
        if (IsApi()) {
            $res = $url === true;
            if (!$res) { // Show response for API
                $ar = array_merge($this->getMessages(), $url ? ["url" => GetUrl($url)] : []);
                WriteJson($ar);
            }
            $this->clearMessages(); // Clear messages for API request
            return;
        } else { // Check if response is JSON
            if (WithJsonResponse()) { // With JSON response
                $this->clearMessages();
                return;
            }
        }

        // Go to URL if specified
        if ($url != "") {
            if (!Config("DEBUG") && ob_get_length()) {
                ob_end_clean();
            }

            // Handle modal response
            if ($this->IsModal) { // Show as modal
                $pageName = GetPageName($url);
                $result = ["url" => GetUrl($url), "modal" => "1"];  // Assume return to modal for simplicity
                if (!SameString($pageName, GetPageName($this->getListUrl()))) { // Not List page
                    $result["caption"] = $this->getModalCaption($pageName);
                    $result["view"] = SameString($pageName, "Season2021View"); // If View page, no primary button
                } else { // List page
                    $result["error"] = $this->getFailureMessage(); // List page should not be shown as modal => error
                    $this->clearFailureMessage();
                }
                WriteJson($result);
            } else {
                SaveDebugMessage();
                Redirect(GetUrl($url));
            }
        }
        return; // Return to controller
    }

    // Get records from result set
    protected function getRecordsFromRecordset($rs, $current = false)
    {
        $rows = [];
        if (is_object($rs)) { // Result set
            while ($row = $rs->fetch()) {
                $this->loadRowValues($row); // Set up DbValue/CurrentValue
                $row = $this->getRecordFromArray($row);
                if ($current) {
                    return $row;
                } else {
                    $rows[] = $row;
                }
            }
        } elseif (is_array($rs)) {
            foreach ($rs as $ar) {
                $row = $this->getRecordFromArray($ar);
                if ($current) {
                    return $row;
                } else {
                    $rows[] = $row;
                }
            }
        }
        return $rows;
    }

    // Get record from array
    protected function getRecordFromArray($ar)
    {
        $row = [];
        if (is_array($ar)) {
            foreach ($ar as $fldname => $val) {
                if (array_key_exists($fldname, $this->Fields) && ($this->Fields[$fldname]->Visible || $this->Fields[$fldname]->IsPrimaryKey)) { // Primary key or Visible
                    $fld = &$this->Fields[$fldname];
                    if ($fld->HtmlTag == "FILE") { // Upload field
                        if (EmptyValue($val)) {
                            $row[$fldname] = null;
                        } else {
                            if ($fld->DataType == DataType::BLOB) {
                                $url = FullUrl(GetApiUrl(Config("API_FILE_ACTION") .
                                    "/" . $fld->TableVar . "/" . $fld->Param . "/" . rawurlencode($this->getRecordKeyValue($ar))));
                                $row[$fldname] = ["type" => ContentType($val), "url" => $url, "name" => $fld->Param . ContentExtension($val)];
                            } elseif (!$fld->UploadMultiple || !ContainsString($val, Config("MULTIPLE_UPLOAD_SEPARATOR"))) { // Single file
                                $url = FullUrl(GetApiUrl(Config("API_FILE_ACTION") .
                                    "/" . $fld->TableVar . "/" . Encrypt($fld->physicalUploadPath() . $val)));
                                $row[$fldname] = ["type" => MimeContentType($val), "url" => $url, "name" => $val];
                            } else { // Multiple files
                                $files = explode(Config("MULTIPLE_UPLOAD_SEPARATOR"), $val);
                                $ar = [];
                                foreach ($files as $file) {
                                    $url = FullUrl(GetApiUrl(Config("API_FILE_ACTION") .
                                        "/" . $fld->TableVar . "/" . Encrypt($fld->physicalUploadPath() . $file)));
                                    if (!EmptyValue($file)) {
                                        $ar[] = ["type" => MimeContentType($file), "url" => $url, "name" => $file];
                                    }
                                }
                                $row[$fldname] = $ar;
                            }
                        }
                    } else {
                        if ($fld->DataType == DataType::MEMO && $fld->MemoMaxLength > 0) {
                            $val = TruncateMemo($val, $fld->MemoMaxLength, $fld->TruncateMemoRemoveHtml);
                        }
                        $row[$fldname] = $val;
                    }
                }
            }
        }
        return $row;
    }

    // Get record key value from array
    protected function getRecordKeyValue($ar)
    {
        $key = "";
        if (is_array($ar)) {
        }
        return $key;
    }

    /**
     * Hide fields for add/edit
     *
     * @return void
     */
    protected function hideFieldsForAddEdit()
    {
    }

    // Lookup data
    public function lookup(array $req = [], bool $response = true)
    {
        global $Language, $Security;

        // Get lookup object
        $fieldName = $req["field"] ?? null;
        if (!$fieldName) {
            return [];
        }
        $fld = $this->Fields[$fieldName];
        $lookup = $fld->Lookup;
        $name = $req["name"] ?? "";
        if (ContainsString($name, "query_builder_rule")) {
            $lookup->FilterFields = []; // Skip parent fields if any
        }

        // Get lookup parameters
        $lookupType = $req["ajax"] ?? "unknown";
        $pageSize = -1;
        $offset = -1;
        $searchValue = "";
        if (SameText($lookupType, "modal") || SameText($lookupType, "filter")) {
            $searchValue = $req["q"] ?? $req["sv"] ?? "";
            $pageSize = $req["n"] ?? $req["recperpage"] ?? 10;
        } elseif (SameText($lookupType, "autosuggest")) {
            $searchValue = $req["q"] ?? "";
            $pageSize = $req["n"] ?? -1;
            $pageSize = is_numeric($pageSize) ? (int)$pageSize : -1;
            if ($pageSize <= 0) {
                $pageSize = Config("AUTO_SUGGEST_MAX_ENTRIES");
            }
        }
        $start = $req["start"] ?? -1;
        $start = is_numeric($start) ? (int)$start : -1;
        $page = $req["page"] ?? -1;
        $page = is_numeric($page) ? (int)$page : -1;
        $offset = $start >= 0 ? $start : ($page > 0 && $pageSize > 0 ? ($page - 1) * $pageSize : 0);
        $userSelect = Decrypt($req["s"] ?? "");
        $userFilter = Decrypt($req["f"] ?? "");
        $userOrderBy = Decrypt($req["o"] ?? "");
        $keys = $req["keys"] ?? null;
        $lookup->LookupType = $lookupType; // Lookup type
        $lookup->FilterValues = []; // Clear filter values first
        if ($keys !== null) { // Selected records from modal
            if (is_array($keys)) {
                $keys = implode(Config("MULTIPLE_OPTION_SEPARATOR"), $keys);
            }
            $lookup->FilterFields = []; // Skip parent fields if any
            $lookup->FilterValues[] = $keys; // Lookup values
            $pageSize = -1; // Show all records
        } else { // Lookup values
            $lookup->FilterValues[] = $req["v0"] ?? $req["lookupValue"] ?? "";
        }
        $cnt = is_array($lookup->FilterFields) ? count($lookup->FilterFields) : 0;
        for ($i = 1; $i <= $cnt; $i++) {
            $lookup->FilterValues[] = $req["v" . $i] ?? "";
        }
        $lookup->SearchValue = $searchValue;
        $lookup->PageSize = $pageSize;
        $lookup->Offset = $offset;
        if ($userSelect != "") {
            $lookup->UserSelect = $userSelect;
        }
        if ($userFilter != "") {
            $lookup->UserFilter = $userFilter;
        }
        if ($userOrderBy != "") {
            $lookup->UserOrderBy = $userOrderBy;
        }
        return $lookup->toJson($this, $response); // Use settings from current page
    }

    // Class variables
    public $ListOptions; // List options
    public $ExportOptions; // Export options
    public $SearchOptions; // Search options
    public $OtherOptions; // Other options
    public $HeaderOptions; // Header options
    public $FooterOptions; // Footer options
    public $FilterOptions; // Filter options
    public $ImportOptions; // Import options
    public $ListActions; // List actions
    public $SelectedCount = 0;
    public $SelectedIndex = 0;
    public $DisplayRecords = 20;
    public $StartRecord;
    public $StopRecord;
    public $TotalRecords = 0;
    public $RecordRange = 10;
    public $PageSizes = ""; // Page sizes (comma separated)
    public $DefaultSearchWhere = ""; // Default search WHERE clause
    public $SearchWhere = ""; // Search WHERE clause
    public $SearchPanelClass = "ew-search-panel collapse"; // Search Panel class
    public $SearchColumnCount = 0; // For extended search
    public $SearchFieldsPerRow = 1; // For extended search
    public $RecordCount = 0; // Record count
    public $InlineRowCount = 0;
    public $StartRowCount = 1;
    public $Attrs = []; // Row attributes and cell attributes
    public $RowIndex = 0; // Row index
    public $KeyCount = 0; // Key count
    public $MultiColumnGridClass = "row-cols-md";
    public $MultiColumnEditClass = "col-12 w-100";
    public $MultiColumnCardClass = "card h-100 ew-card";
    public $MultiColumnListOptionsPosition = "bottom-start";
    public $DbMasterFilter = ""; // Master filter
    public $DbDetailFilter = ""; // Detail filter
    public $MasterRecordExists;
    public $MultiSelectKey;
    public $Command;
    public $UserAction; // User action
    public $RestoreSearch = false;
    public $HashValue; // Hash value
    public $DetailPages;
    public $TopContentClass = "ew-top";
    public $MiddleContentClass = "ew-middle";
    public $BottomContentClass = "ew-bottom";
    public $PageAction;
    public $RecKeys = [];
    public $IsModal = false;
    protected $FilterForModalActions = "";
    private $UseInfiniteScroll = false;

    /**
     * Load result set from filter
     *
     * @return void
     */
    public function loadRecordsetFromFilter($filter)
    {
        // Set up list options
        $this->setupListOptions();

        // Search options
        $this->setupSearchOptions();

        // Other options
        $this->setupOtherOptions();

        // Set visibility
        $this->setVisibility();

        // Load result set
        $this->TotalRecords = $this->loadRecordCount($filter);
        $this->StartRecord = 1;
        $this->StopRecord = $this->DisplayRecords;
        $this->CurrentFilter = $filter;
        $this->Recordset = $this->loadRecordset();

        // Set up pager
        $this->Pager = new PrevNextPager($this, $this->StartRecord, $this->DisplayRecords, $this->TotalRecords, $this->PageSizes, $this->RecordRange, $this->AutoHidePager, $this->AutoHidePageSizeSelector);
    }

    /**
     * Page run
     *
     * @return void
     */
    public function run()
    {
        global $ExportType, $Language, $Security, $CurrentForm, $DashboardReport;

        // Multi column button position
        $this->MultiColumnListOptionsPosition = Config("MULTI_COLUMN_LIST_OPTIONS_POSITION");
        $DashboardReport ??= Param(Config("PAGE_DASHBOARD"));

        // Is modal
        $this->IsModal = ConvertToBool(Param("modal"));

        // Use layout
        $this->UseLayout = $this->UseLayout && ConvertToBool(Param(Config("PAGE_LAYOUT"), true));

        // View
        $this->View = Get(Config("VIEW"));

        // Load user profile
        if (IsLoggedIn()) {
            Profile()->setUserName(CurrentUserName())->loadFromStorage();
        }

        // Get export parameters
        $custom = "";
        if (Param("export") !== null) {
            $this->Export = Param("export");
            $custom = Param("custom", "");
        } else {
            $this->setExportReturnUrl(CurrentUrl());
        }
        $ExportType = $this->Export; // Get export parameter, used in header
        if ($ExportType != "") {
            global $SkipHeaderFooter;
            $SkipHeaderFooter = true;
        }
        $this->CurrentAction = Param("action"); // Set up current action

        // Get grid add count
        $gridaddcnt = Get(Config("TABLE_GRID_ADD_ROW_COUNT"), "");
        if (is_numeric($gridaddcnt) && $gridaddcnt > 0) {
            $this->GridAddRowCount = $gridaddcnt;
        }

        // Set up list options
        $this->setupListOptions();

        // Setup export options
        $this->setupExportOptions();

        // Setup import options
        $this->setupImportOptions();
        $this->setVisibility();

        // Set lookup cache
        if (!in_array($this->PageID, Config("LOOKUP_CACHE_PAGE_IDS"))) {
            $this->setUseLookupCache(false);
        }

        // Global Page Loading event (in userfn*.php)
        DispatchEvent(new PageLoadingEvent($this), PageLoadingEvent::NAME);

        // Page Load event
        if (method_exists($this, "pageLoad")) {
            $this->pageLoad();
        }

        // Hide fields for add/edit
        if (!$this->UseAjaxActions) {
            $this->hideFieldsForAddEdit();
        }
        // Use inline delete
        if ($this->UseAjaxActions) {
            $this->InlineDelete = true;
        }

        // Setup other options
        $this->setupOtherOptions();

        // Update form name to avoid conflict
        if ($this->IsModal) {
            $this->FormName = "fseason20_21grid";
        }

        // Set up page action
        $this->PageAction = CurrentPageUrl(false);

        // Set up infinite scroll
        $this->UseInfiniteScroll = ConvertToBool(Param("infinitescroll"));

        // Search filters
        $srchAdvanced = ""; // Advanced search filter
        $srchBasic = ""; // Basic search filter
        $query = ""; // Query builder

        // Set up Dashboard Filter
        if ($DashboardReport) {
            AddFilter($this->Filter, $this->getDashboardFilter($DashboardReport, $this->TableVar));
        }

        // Get command
        $this->Command = strtolower(Get("cmd", ""));

        // Process list action first
        if ($this->processListAction()) { // Ajax request
            $this->terminate();
            return;
        }

        // Set up records per page
        $this->setupDisplayRecords();

        // Handle reset command
        $this->resetCmd();

        // Set up Breadcrumb
        if (!$this->isExport()) {
            $this->setupBreadcrumb();
        }

        // Process import
        if ($this->isImport()) {
            $this->import(Param(Config("API_FILE_TOKEN_NAME")), ConvertToBool(Param("rollback")));
            $this->terminate();
            return;
        }

        // Hide list options
        if ($this->isExport()) {
            $this->ListOptions->hideAllOptions(["sequence"]);
            $this->ListOptions->UseDropDownButton = false; // Disable drop down button
            $this->ListOptions->UseButtonGroup = false; // Disable button group
        } elseif ($this->isGridAdd() || $this->isGridEdit() || $this->isMultiEdit() || $this->isConfirm()) {
            $this->ListOptions->hideAllOptions();
            $this->ListOptions->UseDropDownButton = false; // Disable drop down button
            $this->ListOptions->UseButtonGroup = false; // Disable button group
        }

        // Hide options
        if ($this->isExport() || !(EmptyValue($this->CurrentAction) || $this->isSearch())) {
            $this->ExportOptions->hideAllOptions();
            $this->FilterOptions->hideAllOptions();
            $this->ImportOptions->hideAllOptions();
        }

        // Hide other options
        if ($this->isExport()) {
            $this->OtherOptions->hideAllOptions();
        }

        // Get default search criteria
        AddFilter($this->DefaultSearchWhere, $this->basicSearchWhere(true));
        AddFilter($this->DefaultSearchWhere, $this->advancedSearchWhere(true));

        // Get basic search values
        $this->loadBasicSearchValues();

        // Get and validate search values for advanced search
        if (EmptyValue($this->UserAction)) { // Skip if user action
            $this->loadSearchValues();
        }

        // Process filter list
        if ($this->processFilterList()) {
            $this->terminate();
            return;
        }
        if (!$this->validateSearch()) {
            // Nothing to do
        }

        // Restore search parms from Session if not searching / reset / export
        if (($this->isExport() || $this->Command != "search" && $this->Command != "reset" && $this->Command != "resetall") && $this->Command != "json" && $this->checkSearchParms()) {
            $this->restoreSearchParms();
        }

        // Call Recordset SearchValidated event
        $this->recordsetSearchValidated();

        // Set up sorting order
        $this->setupSortOrder();

        // Get basic search criteria
        if (!$this->hasInvalidFields()) {
            $srchBasic = $this->basicSearchWhere();
        }

        // Get advanced search criteria
        if (!$this->hasInvalidFields()) {
            $srchAdvanced = $this->advancedSearchWhere();
        }

        // Get query builder criteria
        $query = $DashboardReport ? "" : $this->queryBuilderWhere();

        // Restore display records
        if ($this->Command != "json" && $this->getRecordsPerPage() != "") {
            $this->DisplayRecords = $this->getRecordsPerPage(); // Restore from Session
        } else {
            $this->DisplayRecords = 20; // Load default
            $this->setRecordsPerPage($this->DisplayRecords); // Save default to Session
        }

        // Load search default if no existing search criteria
        if (!$this->checkSearchParms() && !$query) {
            // Load basic search from default
            $this->BasicSearch->loadDefault();
            if ($this->BasicSearch->Keyword != "") {
                $srchBasic = $this->basicSearchWhere(); // Save to session
            }

            // Load advanced search from default
            if ($this->loadAdvancedSearchDefault()) {
                $srchAdvanced = $this->advancedSearchWhere(); // Save to session
            }
        }

        // Restore search settings from Session
        if (!$this->hasInvalidFields()) {
            $this->loadAdvancedSearch();
        }

        // Build search criteria
        if ($query) {
            AddFilter($this->SearchWhere, $query);
        } else {
            AddFilter($this->SearchWhere, $srchAdvanced);
            AddFilter($this->SearchWhere, $srchBasic);
        }

        // Call Recordset_Searching event
        $this->recordsetSearching($this->SearchWhere);

        // Save search criteria
        if ($this->Command == "search" && !$this->RestoreSearch) {
            $this->setSearchWhere($this->SearchWhere); // Save to Session
            $this->StartRecord = 1; // Reset start record counter
            $this->setStartRecordNumber($this->StartRecord);
        } elseif ($this->Command != "json" && !$query) {
            $this->SearchWhere = $this->getSearchWhere();
        }

        // Build filter
        if (!$Security->canList()) {
            $this->Filter = "(0=1)"; // Filter all records
        }
        AddFilter($this->Filter, $this->DbDetailFilter);
        AddFilter($this->Filter, $this->SearchWhere);

        // Set up filter
        if ($this->Command == "json") {
            $this->UseSessionForListSql = false; // Do not use session for ListSQL
            $this->CurrentFilter = $this->Filter;
        } else {
            $this->setSessionWhere($this->Filter);
            $this->CurrentFilter = "";
        }
        $this->Filter = $this->applyUserIDFilters($this->Filter);
        if ($this->isGridAdd()) {
            $this->CurrentFilter = "0=1";
            $this->StartRecord = 1;
            $this->DisplayRecords = $this->GridAddRowCount;
            $this->TotalRecords = $this->DisplayRecords;
            $this->StopRecord = $this->DisplayRecords;
        } elseif (($this->isEdit() || $this->isCopy() || $this->isInlineInserted() || $this->isInlineUpdated()) && $this->UseInfiniteScroll) { // Get current record only
            $this->CurrentFilter = $this->isInlineUpdated() ? $this->getRecordFilter() : $this->getFilterFromRecordKeys();
            $this->TotalRecords = $this->listRecordCount();
            $this->StartRecord = 1;
            $this->StopRecord = $this->DisplayRecords;
            $this->Recordset = $this->loadRecordset();
        } elseif (
            $this->UseInfiniteScroll && $this->isGridInserted() ||
            $this->UseInfiniteScroll && ($this->isGridEdit() || $this->isGridUpdated()) ||
            $this->isMultiEdit() ||
            $this->UseInfiniteScroll && $this->isMultiUpdated()
        ) { // Get current records only
            $this->CurrentFilter = $this->FilterForModalActions; // Restore filter
            $this->TotalRecords = $this->listRecordCount();
            $this->StartRecord = 1;
            $this->StopRecord = $this->DisplayRecords;
            $this->Recordset = $this->loadRecordset();
        } else {
            $this->TotalRecords = $this->listRecordCount();
            $this->StartRecord = 1;
            if ($this->DisplayRecords <= 0 || ($this->isExport() && $this->ExportAll)) { // Display all records
                $this->DisplayRecords = $this->TotalRecords;
            }
            if (!($this->isExport() && $this->ExportAll)) { // Set up start record position
                $this->setupStartRecord();
            }
            $this->Recordset = $this->loadRecordset($this->StartRecord - 1, $this->DisplayRecords);

            // Set no record found message
            if ((EmptyValue($this->CurrentAction) || $this->isSearch()) && $this->TotalRecords == 0) {
                if (!$Security->canList()) {
                    $this->setWarningMessage(DeniedMessage());
                }
                if ($this->SearchWhere == "0=101") {
                    $this->setWarningMessage($Language->phrase("EnterSearchCriteria"));
                } else {
                    $this->setWarningMessage($Language->phrase("NoRecord"));
                }
            }
        }

        // Set up list action columns
        foreach ($this->ListActions as $listAction) {
            if ($listAction->Allowed) {
                if ($listAction->Select == ACTION_MULTIPLE) { // Show checkbox column if multiple action
                    $this->ListOptions["checkbox"]->Visible = true;
                } elseif ($listAction->Select == ACTION_SINGLE) { // Show list action column
                        $this->ListOptions["listactions"]->Visible = true; // Set visible if any list action is allowed
                }
            }
        }

        // Search options
        $this->setupSearchOptions();

        // Set up search panel class
        if ($this->SearchWhere != "") {
            if ($query) { // Hide search panel if using QueryBuilder
                RemoveClass($this->SearchPanelClass, "show");
            } else {
                AppendClass($this->SearchPanelClass, "show");
            }
        }

        // API list action
        if (IsApi()) {
            if (Route(0) == Config("API_LIST_ACTION")) {
                if (!$this->isExport()) {
                    $rows = $this->getRecordsFromRecordset($this->Recordset);
                    $this->Recordset?->free();
                    WriteJson([
                        "success" => true,
                        "action" => Config("API_LIST_ACTION"),
                        $this->TableVar => $rows,
                        "totalRecordCount" => $this->TotalRecords
                    ]);
                    $this->terminate(true);
                }
                return;
            } elseif ($this->getFailureMessage() != "") {
                WriteJson(["error" => $this->getFailureMessage()]);
                $this->clearFailureMessage();
                $this->terminate(true);
                return;
            }
        }

        // Render other options
        $this->renderOtherOptions();

        // Set up pager
        $this->Pager = new PrevNextPager($this, $this->StartRecord, $this->DisplayRecords, $this->TotalRecords, $this->PageSizes, $this->RecordRange, $this->AutoHidePager, $this->AutoHidePageSizeSelector);

        // Set ReturnUrl in header if necessary
        if ($returnUrl = Container("app.flash")->getFirstMessage("Return-Url")) {
            AddHeader("Return-Url", GetUrl($returnUrl));
        }

        // Set LoginStatus / Page_Rendering / Page_Render
        if (!IsApi() && !$this->isTerminated()) {
            // Setup login status
            SetupLoginStatus();

            // Pass login status to client side
            SetClientVar("login", LoginStatus());

            // Global Page Rendering event (in userfn*.php)
            DispatchEvent(new PageRenderingEvent($this), PageRenderingEvent::NAME);

            // Page Render event
            if (method_exists($this, "pageRender")) {
                $this->pageRender();
            }

            // Render search option
            if (method_exists($this, "renderSearchOptions")) {
                $this->renderSearchOptions();
            }
        }
    }

    // Get page number
    public function getPageNumber()
    {
        return ($this->DisplayRecords > 0 && $this->StartRecord > 0) ? ceil($this->StartRecord / $this->DisplayRecords) : 1;
    }

    // Set up number of records displayed per page
    protected function setupDisplayRecords()
    {
        $wrk = Get(Config("TABLE_REC_PER_PAGE"), "");
        if ($wrk != "") {
            if (is_numeric($wrk)) {
                $this->DisplayRecords = (int)$wrk;
            } else {
                if (SameText($wrk, "all")) { // Display all records
                    $this->DisplayRecords = -1;
                } else {
                    $this->DisplayRecords = 20; // Non-numeric, load default
                }
            }
            $this->setRecordsPerPage($this->DisplayRecords); // Save to Session
            // Reset start position
            $this->StartRecord = 1;
            $this->setStartRecordNumber($this->StartRecord);
        }
    }

    // Build filter for all keys
    protected function buildKeyFilter()
    {
        global $CurrentForm;
        $wrkFilter = "";

        // Update row index and get row key
        $rowindex = 1;
        $CurrentForm->Index = $rowindex;
        $thisKey = strval($CurrentForm->getValue($this->OldKeyName));
        while ($thisKey != "") {
            $this->setKey($thisKey);
            if ($this->OldKey != "") {
                $filter = $this->getRecordFilter();
                if ($wrkFilter != "") {
                    $wrkFilter .= " OR ";
                }
                $wrkFilter .= $filter;
            } else {
                $wrkFilter = "0=1";
                break;
            }

            // Update row index and get row key
            $rowindex++; // Next row
            $CurrentForm->Index = $rowindex;
            $thisKey = strval($CurrentForm->getValue($this->OldKeyName));
        }
        return $wrkFilter;
    }

    // Get list of filters
    public function getFilterList()
    {
        // Initialize
        $filterList = "";
        $savedFilterList = "";

        // Load server side filters
        if (Config("SEARCH_FILTER_OPTION") == "Server") {
            $savedFilterList = Profile()->getSearchFilters("fseason20_21srch");
        }
        $filterList = Concat($filterList, $this->SerialNo->AdvancedSearch->toJson(), ","); // Field SerialNo
        $filterList = Concat($filterList, $this->IPC->AdvancedSearch->toJson(), ","); // Field IPC
        $filterList = Concat($filterList, $this->PageNo->AdvancedSearch->toJson(), ","); // Field PageNo
        $filterList = Concat($filterList, $this->Activity->AdvancedSearch->toJson(), ","); // Field Activity
        $filterList = Concat($filterList, $this->District->AdvancedSearch->toJson(), ","); // Field District
        $filterList = Concat($filterList, $this->Block->AdvancedSearch->toJson(), ","); // Field Block
        $filterList = Concat($filterList, $this->Camp->AdvancedSearch->toJson(), ","); // Field Camp
        $filterList = Concat($filterList, $this->NurseryArea->AdvancedSearch->toJson(), ","); // Field NurseryArea
        $filterList = Concat($filterList, $this->Zone->AdvancedSearch->toJson(), ","); // Field Zone
        $filterList = Concat($filterList, $this->ChiefArea->AdvancedSearch->toJson(), ","); // Field ChiefArea
        $filterList = Concat($filterList, $this->Date->AdvancedSearch->toJson(), ","); // Field Date
        $filterList = Concat($filterList, $this->Village->AdvancedSearch->toJson(), ","); // Field Village
        $filterList = Concat($filterList, $this->NameOfFarmer->AdvancedSearch->toJson(), ","); // Field NameOfFarmer
        $filterList = Concat($filterList, $this->YearOfBirth->AdvancedSearch->toJson(), ","); // Field YearOfBirth
        $filterList = Concat($filterList, $this->Gender->AdvancedSearch->toJson(), ","); // Field Gender
        $filterList = Concat($filterList, $this->NRC->AdvancedSearch->toJson(), ","); // Field NRC
        $filterList = Concat($filterList, $this->SeedlingsReceived20_21->AdvancedSearch->toJson(), ","); // Field SeedlingsReceived20_21
        $filterList = Concat($filterList, $this->FieldType->AdvancedSearch->toJson(), ","); // Field FieldType
        $filterList = Concat($filterList, $this->Contact->AdvancedSearch->toJson(), ","); // Field Contact
        if ($this->BasicSearch->Keyword != "") {
            $wrk = "\"" . Config("TABLE_BASIC_SEARCH") . "\":\"" . JsEncode($this->BasicSearch->Keyword) . "\",\"" . Config("TABLE_BASIC_SEARCH_TYPE") . "\":\"" . JsEncode($this->BasicSearch->Type) . "\"";
            $filterList = Concat($filterList, $wrk, ",");
        }

        // Query Builder rules
        $rules = $this->queryBuilderRules();
        if ($rules) {
            $filterList = Concat($filterList, "\"" . Config("TABLE_RULES") . "\":\"" . JsEncode($rules) . "\"", ",");
        }

        // Return filter list in JSON
        if ($filterList != "") {
            $filterList = "\"data\":{" . $filterList . "}";
        }
        if ($savedFilterList != "") {
            $filterList = Concat($filterList, "\"filters\":" . $savedFilterList, ",");
        }
        return ($filterList != "") ? "{" . $filterList . "}" : "null";
    }

    // Process filter list
    protected function processFilterList()
    {
        if (Post("ajax") == "savefilters") { // Save filter request (Ajax)
            $filters = Post("filters");
            Profile()->setSearchFilters("fseason20_21srch", $filters);
            WriteJson([["success" => true]]); // Success
            return true;
        } elseif (Post("cmd") == "resetfilter") {
            $this->restoreFilterList();
        }
        return false;
    }

    // Restore list of filters
    protected function restoreFilterList()
    {
        // Return if not reset filter
        if (Post("cmd") !== "resetfilter") {
            return false;
        }
        $filter = json_decode(Post("filter"), true);
        $this->Command = "search";

        // Field SerialNo
        $this->SerialNo->AdvancedSearch->SearchValue = @$filter["x_SerialNo"];
        $this->SerialNo->AdvancedSearch->SearchOperator = @$filter["z_SerialNo"];
        $this->SerialNo->AdvancedSearch->SearchCondition = @$filter["v_SerialNo"];
        $this->SerialNo->AdvancedSearch->SearchValue2 = @$filter["y_SerialNo"];
        $this->SerialNo->AdvancedSearch->SearchOperator2 = @$filter["w_SerialNo"];
        $this->SerialNo->AdvancedSearch->save();

        // Field IPC
        $this->IPC->AdvancedSearch->SearchValue = @$filter["x_IPC"];
        $this->IPC->AdvancedSearch->SearchOperator = @$filter["z_IPC"];
        $this->IPC->AdvancedSearch->SearchCondition = @$filter["v_IPC"];
        $this->IPC->AdvancedSearch->SearchValue2 = @$filter["y_IPC"];
        $this->IPC->AdvancedSearch->SearchOperator2 = @$filter["w_IPC"];
        $this->IPC->AdvancedSearch->save();

        // Field PageNo
        $this->PageNo->AdvancedSearch->SearchValue = @$filter["x_PageNo"];
        $this->PageNo->AdvancedSearch->SearchOperator = @$filter["z_PageNo"];
        $this->PageNo->AdvancedSearch->SearchCondition = @$filter["v_PageNo"];
        $this->PageNo->AdvancedSearch->SearchValue2 = @$filter["y_PageNo"];
        $this->PageNo->AdvancedSearch->SearchOperator2 = @$filter["w_PageNo"];
        $this->PageNo->AdvancedSearch->save();

        // Field Activity
        $this->Activity->AdvancedSearch->SearchValue = @$filter["x_Activity"];
        $this->Activity->AdvancedSearch->SearchOperator = @$filter["z_Activity"];
        $this->Activity->AdvancedSearch->SearchCondition = @$filter["v_Activity"];
        $this->Activity->AdvancedSearch->SearchValue2 = @$filter["y_Activity"];
        $this->Activity->AdvancedSearch->SearchOperator2 = @$filter["w_Activity"];
        $this->Activity->AdvancedSearch->save();

        // Field District
        $this->District->AdvancedSearch->SearchValue = @$filter["x_District"];
        $this->District->AdvancedSearch->SearchOperator = @$filter["z_District"];
        $this->District->AdvancedSearch->SearchCondition = @$filter["v_District"];
        $this->District->AdvancedSearch->SearchValue2 = @$filter["y_District"];
        $this->District->AdvancedSearch->SearchOperator2 = @$filter["w_District"];
        $this->District->AdvancedSearch->save();

        // Field Block
        $this->Block->AdvancedSearch->SearchValue = @$filter["x_Block"];
        $this->Block->AdvancedSearch->SearchOperator = @$filter["z_Block"];
        $this->Block->AdvancedSearch->SearchCondition = @$filter["v_Block"];
        $this->Block->AdvancedSearch->SearchValue2 = @$filter["y_Block"];
        $this->Block->AdvancedSearch->SearchOperator2 = @$filter["w_Block"];
        $this->Block->AdvancedSearch->save();

        // Field Camp
        $this->Camp->AdvancedSearch->SearchValue = @$filter["x_Camp"];
        $this->Camp->AdvancedSearch->SearchOperator = @$filter["z_Camp"];
        $this->Camp->AdvancedSearch->SearchCondition = @$filter["v_Camp"];
        $this->Camp->AdvancedSearch->SearchValue2 = @$filter["y_Camp"];
        $this->Camp->AdvancedSearch->SearchOperator2 = @$filter["w_Camp"];
        $this->Camp->AdvancedSearch->save();

        // Field NurseryArea
        $this->NurseryArea->AdvancedSearch->SearchValue = @$filter["x_NurseryArea"];
        $this->NurseryArea->AdvancedSearch->SearchOperator = @$filter["z_NurseryArea"];
        $this->NurseryArea->AdvancedSearch->SearchCondition = @$filter["v_NurseryArea"];
        $this->NurseryArea->AdvancedSearch->SearchValue2 = @$filter["y_NurseryArea"];
        $this->NurseryArea->AdvancedSearch->SearchOperator2 = @$filter["w_NurseryArea"];
        $this->NurseryArea->AdvancedSearch->save();

        // Field Zone
        $this->Zone->AdvancedSearch->SearchValue = @$filter["x_Zone"];
        $this->Zone->AdvancedSearch->SearchOperator = @$filter["z_Zone"];
        $this->Zone->AdvancedSearch->SearchCondition = @$filter["v_Zone"];
        $this->Zone->AdvancedSearch->SearchValue2 = @$filter["y_Zone"];
        $this->Zone->AdvancedSearch->SearchOperator2 = @$filter["w_Zone"];
        $this->Zone->AdvancedSearch->save();

        // Field ChiefArea
        $this->ChiefArea->AdvancedSearch->SearchValue = @$filter["x_ChiefArea"];
        $this->ChiefArea->AdvancedSearch->SearchOperator = @$filter["z_ChiefArea"];
        $this->ChiefArea->AdvancedSearch->SearchCondition = @$filter["v_ChiefArea"];
        $this->ChiefArea->AdvancedSearch->SearchValue2 = @$filter["y_ChiefArea"];
        $this->ChiefArea->AdvancedSearch->SearchOperator2 = @$filter["w_ChiefArea"];
        $this->ChiefArea->AdvancedSearch->save();

        // Field Date
        $this->Date->AdvancedSearch->SearchValue = @$filter["x_Date"];
        $this->Date->AdvancedSearch->SearchOperator = @$filter["z_Date"];
        $this->Date->AdvancedSearch->SearchCondition = @$filter["v_Date"];
        $this->Date->AdvancedSearch->SearchValue2 = @$filter["y_Date"];
        $this->Date->AdvancedSearch->SearchOperator2 = @$filter["w_Date"];
        $this->Date->AdvancedSearch->save();

        // Field Village
        $this->Village->AdvancedSearch->SearchValue = @$filter["x_Village"];
        $this->Village->AdvancedSearch->SearchOperator = @$filter["z_Village"];
        $this->Village->AdvancedSearch->SearchCondition = @$filter["v_Village"];
        $this->Village->AdvancedSearch->SearchValue2 = @$filter["y_Village"];
        $this->Village->AdvancedSearch->SearchOperator2 = @$filter["w_Village"];
        $this->Village->AdvancedSearch->save();

        // Field NameOfFarmer
        $this->NameOfFarmer->AdvancedSearch->SearchValue = @$filter["x_NameOfFarmer"];
        $this->NameOfFarmer->AdvancedSearch->SearchOperator = @$filter["z_NameOfFarmer"];
        $this->NameOfFarmer->AdvancedSearch->SearchCondition = @$filter["v_NameOfFarmer"];
        $this->NameOfFarmer->AdvancedSearch->SearchValue2 = @$filter["y_NameOfFarmer"];
        $this->NameOfFarmer->AdvancedSearch->SearchOperator2 = @$filter["w_NameOfFarmer"];
        $this->NameOfFarmer->AdvancedSearch->save();

        // Field YearOfBirth
        $this->YearOfBirth->AdvancedSearch->SearchValue = @$filter["x_YearOfBirth"];
        $this->YearOfBirth->AdvancedSearch->SearchOperator = @$filter["z_YearOfBirth"];
        $this->YearOfBirth->AdvancedSearch->SearchCondition = @$filter["v_YearOfBirth"];
        $this->YearOfBirth->AdvancedSearch->SearchValue2 = @$filter["y_YearOfBirth"];
        $this->YearOfBirth->AdvancedSearch->SearchOperator2 = @$filter["w_YearOfBirth"];
        $this->YearOfBirth->AdvancedSearch->save();

        // Field Gender
        $this->Gender->AdvancedSearch->SearchValue = @$filter["x_Gender"];
        $this->Gender->AdvancedSearch->SearchOperator = @$filter["z_Gender"];
        $this->Gender->AdvancedSearch->SearchCondition = @$filter["v_Gender"];
        $this->Gender->AdvancedSearch->SearchValue2 = @$filter["y_Gender"];
        $this->Gender->AdvancedSearch->SearchOperator2 = @$filter["w_Gender"];
        $this->Gender->AdvancedSearch->save();

        // Field NRC
        $this->NRC->AdvancedSearch->SearchValue = @$filter["x_NRC"];
        $this->NRC->AdvancedSearch->SearchOperator = @$filter["z_NRC"];
        $this->NRC->AdvancedSearch->SearchCondition = @$filter["v_NRC"];
        $this->NRC->AdvancedSearch->SearchValue2 = @$filter["y_NRC"];
        $this->NRC->AdvancedSearch->SearchOperator2 = @$filter["w_NRC"];
        $this->NRC->AdvancedSearch->save();

        // Field SeedlingsReceived20_21
        $this->SeedlingsReceived20_21->AdvancedSearch->SearchValue = @$filter["x_SeedlingsReceived20_21"];
        $this->SeedlingsReceived20_21->AdvancedSearch->SearchOperator = @$filter["z_SeedlingsReceived20_21"];
        $this->SeedlingsReceived20_21->AdvancedSearch->SearchCondition = @$filter["v_SeedlingsReceived20_21"];
        $this->SeedlingsReceived20_21->AdvancedSearch->SearchValue2 = @$filter["y_SeedlingsReceived20_21"];
        $this->SeedlingsReceived20_21->AdvancedSearch->SearchOperator2 = @$filter["w_SeedlingsReceived20_21"];
        $this->SeedlingsReceived20_21->AdvancedSearch->save();

        // Field FieldType
        $this->FieldType->AdvancedSearch->SearchValue = @$filter["x_FieldType"];
        $this->FieldType->AdvancedSearch->SearchOperator = @$filter["z_FieldType"];
        $this->FieldType->AdvancedSearch->SearchCondition = @$filter["v_FieldType"];
        $this->FieldType->AdvancedSearch->SearchValue2 = @$filter["y_FieldType"];
        $this->FieldType->AdvancedSearch->SearchOperator2 = @$filter["w_FieldType"];
        $this->FieldType->AdvancedSearch->save();

        // Field Contact
        $this->Contact->AdvancedSearch->SearchValue = @$filter["x_Contact"];
        $this->Contact->AdvancedSearch->SearchOperator = @$filter["z_Contact"];
        $this->Contact->AdvancedSearch->SearchCondition = @$filter["v_Contact"];
        $this->Contact->AdvancedSearch->SearchValue2 = @$filter["y_Contact"];
        $this->Contact->AdvancedSearch->SearchOperator2 = @$filter["w_Contact"];
        $this->Contact->AdvancedSearch->save();
        $this->BasicSearch->setKeyword(@$filter[Config("TABLE_BASIC_SEARCH")]);
        $this->BasicSearch->setType(@$filter[Config("TABLE_BASIC_SEARCH_TYPE")]);
        if ($filter[Config("TABLE_RULES")] ?? false) {
            $this->Command = "query"; // Set command for query builder
            $this->setSessionRules($filter[Config("TABLE_RULES")]);
        }
    }

    // Advanced search WHERE clause based on QueryString
    public function advancedSearchWhere($default = false)
    {
        global $Security;
        $where = "";
        if (!$Security->canSearch()) {
            return "";
        }
        $this->buildSearchSql($where, $this->SerialNo, $default, false); // SerialNo
        $this->buildSearchSql($where, $this->IPC, $default, false); // IPC
        $this->buildSearchSql($where, $this->PageNo, $default, false); // PageNo
        $this->buildSearchSql($where, $this->Activity, $default, true); // Activity
        $this->buildSearchSql($where, $this->District, $default, true); // District
        $this->buildSearchSql($where, $this->Block, $default, true); // Block
        $this->buildSearchSql($where, $this->Camp, $default, true); // Camp
        $this->buildSearchSql($where, $this->NurseryArea, $default, true); // NurseryArea
        $this->buildSearchSql($where, $this->Zone, $default, true); // Zone
        $this->buildSearchSql($where, $this->ChiefArea, $default, true); // ChiefArea
        $this->buildSearchSql($where, $this->Date, $default, false); // Date
        $this->buildSearchSql($where, $this->Village, $default, true); // Village
        $this->buildSearchSql($where, $this->NameOfFarmer, $default, true); // NameOfFarmer
        $this->buildSearchSql($where, $this->YearOfBirth, $default, true); // YearOfBirth
        $this->buildSearchSql($where, $this->Gender, $default, true); // Gender
        $this->buildSearchSql($where, $this->NRC, $default, true); // NRC
        $this->buildSearchSql($where, $this->SeedlingsReceived20_21, $default, false); // SeedlingsReceived20_21
        $this->buildSearchSql($where, $this->FieldType, $default, true); // FieldType
        $this->buildSearchSql($where, $this->Contact, $default, false); // Contact

        // Set up search command
        if (!$default && $where != "" && in_array($this->Command, ["", "reset", "resetall"])) {
            $this->Command = "search";
        }
        if (!$default && $this->Command == "search") {
            $this->SerialNo->AdvancedSearch->save(); // SerialNo
            $this->IPC->AdvancedSearch->save(); // IPC
            $this->PageNo->AdvancedSearch->save(); // PageNo
            $this->Activity->AdvancedSearch->save(); // Activity
            $this->District->AdvancedSearch->save(); // District
            $this->Block->AdvancedSearch->save(); // Block
            $this->Camp->AdvancedSearch->save(); // Camp
            $this->NurseryArea->AdvancedSearch->save(); // NurseryArea
            $this->Zone->AdvancedSearch->save(); // Zone
            $this->ChiefArea->AdvancedSearch->save(); // ChiefArea
            $this->Date->AdvancedSearch->save(); // Date
            $this->Village->AdvancedSearch->save(); // Village
            $this->NameOfFarmer->AdvancedSearch->save(); // NameOfFarmer
            $this->YearOfBirth->AdvancedSearch->save(); // YearOfBirth
            $this->Gender->AdvancedSearch->save(); // Gender
            $this->NRC->AdvancedSearch->save(); // NRC
            $this->SeedlingsReceived20_21->AdvancedSearch->save(); // SeedlingsReceived20_21
            $this->FieldType->AdvancedSearch->save(); // FieldType
            $this->Contact->AdvancedSearch->save(); // Contact

            // Clear rules for QueryBuilder
            $this->setSessionRules("");
        }
        return $where;
    }

    // Query builder rules
    public function queryBuilderRules()
    {
        return Post("rules") ?? $this->getSessionRules();
    }

    // Quey builder WHERE clause
    public function queryBuilderWhere($fieldName = "")
    {
        global $Security;
        if (!$Security->canSearch()) {
            return "";
        }

        // Get rules by query builder
        $rules = $this->queryBuilderRules();

        // Decode and parse rules
        $where = $rules ? $this->parseRules(json_decode($rules, true), $fieldName) : "";

        // Clear other search and save rules to session
        if ($where && $fieldName == "") { // Skip if get query for specific field
            $this->resetSearchParms();
            $this->setSessionRules($rules);
        }

        // Return query
        return $where;
    }

    // Build search SQL
    protected function buildSearchSql(&$where, $fld, $default, $multiValue)
    {
        $fldParm = $fld->Param;
        $fldVal = $default ? $fld->AdvancedSearch->SearchValueDefault : $fld->AdvancedSearch->SearchValue;
        $fldOpr = $default ? $fld->AdvancedSearch->SearchOperatorDefault : $fld->AdvancedSearch->SearchOperator;
        $fldCond = $default ? $fld->AdvancedSearch->SearchConditionDefault : $fld->AdvancedSearch->SearchCondition;
        $fldVal2 = $default ? $fld->AdvancedSearch->SearchValue2Default : $fld->AdvancedSearch->SearchValue2;
        $fldOpr2 = $default ? $fld->AdvancedSearch->SearchOperator2Default : $fld->AdvancedSearch->SearchOperator2;
        $fldVal = ConvertSearchValue($fldVal, $fldOpr, $fld);
        $fldVal2 = ConvertSearchValue($fldVal2, $fldOpr2, $fld);
        $fldOpr = ConvertSearchOperator($fldOpr, $fld, $fldVal);
        $fldOpr2 = ConvertSearchOperator($fldOpr2, $fld, $fldVal2);
        $wrk = "";
        $sep = $fld->UseFilter ? Config("FILTER_OPTION_SEPARATOR") : Config("MULTIPLE_OPTION_SEPARATOR");
        if (is_array($fldVal)) {
            $fldVal = implode($sep, $fldVal);
        }
        if (is_array($fldVal2)) {
            $fldVal2 = implode($sep, $fldVal2);
        }
        if (Config("SEARCH_MULTI_VALUE_OPTION") == 1 && !$fld->UseFilter || !IsMultiSearchOperator($fldOpr)) {
            $multiValue = false;
        }
        if ($multiValue) {
            $wrk = $fldVal != "" ? GetMultiSearchSql($fld, $fldOpr, $fldVal, $this->Dbid) : ""; // Field value 1
            $wrk2 = $fldVal2 != "" ? GetMultiSearchSql($fld, $fldOpr2, $fldVal2, $this->Dbid) : ""; // Field value 2
            AddFilter($wrk, $wrk2, $fldCond);
        } else {
            $wrk = GetSearchSql($fld, $fldVal, $fldOpr, $fldCond, $fldVal2, $fldOpr2, $this->Dbid);
        }
        if ($this->SearchOption == "AUTO" && in_array($this->BasicSearch->getType(), ["AND", "OR"])) {
            $cond = $this->BasicSearch->getType();
        } else {
            $cond = SameText($this->SearchOption, "OR") ? "OR" : "AND";
        }
        AddFilter($where, $wrk, $cond);
    }

    // Show list of filters
    public function showFilterList()
    {
        global $Language;

        // Initialize
        $filterList = "";
        $captionClass = $this->isExport("email") ? "ew-filter-caption-email" : "ew-filter-caption";
        $captionSuffix = $this->isExport("email") ? ": " : "";

        // Field SerialNo
        $filter = $this->queryBuilderWhere("SerialNo");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->SerialNo, false, false);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->SerialNo->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field IPC
        $filter = $this->queryBuilderWhere("IPC");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->IPC, false, false);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->IPC->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field PageNo
        $filter = $this->queryBuilderWhere("PageNo");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->PageNo, false, false);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->PageNo->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field Activity
        $filter = $this->queryBuilderWhere("Activity");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->Activity, false, true);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->Activity->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field District
        $filter = $this->queryBuilderWhere("District");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->District, false, true);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->District->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field Block
        $filter = $this->queryBuilderWhere("Block");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->Block, false, true);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->Block->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field Camp
        $filter = $this->queryBuilderWhere("Camp");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->Camp, false, true);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->Camp->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field NurseryArea
        $filter = $this->queryBuilderWhere("NurseryArea");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->NurseryArea, false, true);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->NurseryArea->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field Zone
        $filter = $this->queryBuilderWhere("Zone");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->Zone, false, true);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->Zone->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field ChiefArea
        $filter = $this->queryBuilderWhere("ChiefArea");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->ChiefArea, false, true);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->ChiefArea->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field Date
        $filter = $this->queryBuilderWhere("Date");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->Date, false, false);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->Date->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field Village
        $filter = $this->queryBuilderWhere("Village");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->Village, false, true);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->Village->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field NameOfFarmer
        $filter = $this->queryBuilderWhere("NameOfFarmer");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->NameOfFarmer, false, true);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->NameOfFarmer->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field YearOfBirth
        $filter = $this->queryBuilderWhere("YearOfBirth");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->YearOfBirth, false, true);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->YearOfBirth->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field Gender
        $filter = $this->queryBuilderWhere("Gender");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->Gender, false, true);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->Gender->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field NRC
        $filter = $this->queryBuilderWhere("NRC");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->NRC, false, true);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->NRC->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field SeedlingsReceived20_21
        $filter = $this->queryBuilderWhere("SeedlingsReceived20_21");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->SeedlingsReceived20_21, false, false);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->SeedlingsReceived20_21->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field FieldType
        $filter = $this->queryBuilderWhere("FieldType");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->FieldType, false, true);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->FieldType->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }

        // Field Contact
        $filter = $this->queryBuilderWhere("Contact");
        if (!$filter) {
            $this->buildSearchSql($filter, $this->Contact, false, false);
        }
        if ($filter != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $this->Contact->caption() . "</span>" . $captionSuffix . $filter . "</div>";
        }
        if ($this->BasicSearch->Keyword != "") {
            $filterList .= "<div><span class=\"" . $captionClass . "\">" . $Language->phrase("BasicSearchKeyword") . "</span>" . $captionSuffix . $this->BasicSearch->Keyword . "</div>";
        }

        // Show Filters
        if ($filterList != "") {
            $message = "<div id=\"ew-filter-list\" class=\"callout callout-info d-table\"><div id=\"ew-current-filters\">" .
                $Language->phrase("CurrentFilters") . "</div>" . $filterList . "</div>";
            $this->messageShowing($message, "");
            Write($message);
        } else { // Output empty tag
            Write("<div id=\"ew-filter-list\"></div>");
        }
    }

    // Return basic search WHERE clause based on search keyword and type
    public function basicSearchWhere($default = false)
    {
        global $Security;
        $searchStr = "";
        if (!$Security->canSearch()) {
            return "";
        }

        // Fields to search
        $searchFlds = [];
        $searchFlds[] = &$this->IPC;
        $searchFlds[] = &$this->Activity;
        $searchFlds[] = &$this->District;
        $searchFlds[] = &$this->Block;
        $searchFlds[] = &$this->Camp;
        $searchFlds[] = &$this->NurseryArea;
        $searchFlds[] = &$this->Zone;
        $searchFlds[] = &$this->ChiefArea;
        $searchFlds[] = &$this->Date;
        $searchFlds[] = &$this->Village;
        $searchFlds[] = &$this->NameOfFarmer;
        $searchFlds[] = &$this->Gender;
        $searchFlds[] = &$this->NRC;
        $searchFlds[] = &$this->FieldType;
        $searchFlds[] = &$this->Contact;
        $searchKeyword = $default ? $this->BasicSearch->KeywordDefault : $this->BasicSearch->Keyword;
        $searchType = $default ? $this->BasicSearch->TypeDefault : $this->BasicSearch->Type;

        // Get search SQL
        if ($searchKeyword != "") {
            $ar = $this->BasicSearch->keywordList($default);
            $searchStr = GetQuickSearchFilter($searchFlds, $ar, $searchType, Config("BASIC_SEARCH_ANY_FIELDS"), $this->Dbid);
            if (!$default && in_array($this->Command, ["", "reset", "resetall"])) {
                $this->Command = "search";
            }
        }
        if (!$default && $this->Command == "search") {
            $this->BasicSearch->setKeyword($searchKeyword);
            $this->BasicSearch->setType($searchType);

            // Clear rules for QueryBuilder
            $this->setSessionRules("");
        }
        return $searchStr;
    }

    // Check if search parm exists
    protected function checkSearchParms()
    {
        // Check basic search
        if ($this->BasicSearch->issetSession()) {
            return true;
        }
        if ($this->SerialNo->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->IPC->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->PageNo->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->Activity->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->District->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->Block->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->Camp->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->NurseryArea->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->Zone->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->ChiefArea->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->Date->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->Village->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->NameOfFarmer->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->YearOfBirth->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->Gender->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->NRC->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->SeedlingsReceived20_21->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->FieldType->AdvancedSearch->issetSession()) {
            return true;
        }
        if ($this->Contact->AdvancedSearch->issetSession()) {
            return true;
        }
        return false;
    }

    // Clear all search parameters
    protected function resetSearchParms()
    {
        // Clear search WHERE clause
        $this->SearchWhere = "";
        $this->setSearchWhere($this->SearchWhere);

        // Clear basic search parameters
        $this->resetBasicSearchParms();

        // Clear advanced search parameters
        $this->resetAdvancedSearchParms();

        // Clear queryBuilder
        $this->setSessionRules("");
    }

    // Load advanced search default values
    protected function loadAdvancedSearchDefault()
    {
        return false;
    }

    // Clear all basic search parameters
    protected function resetBasicSearchParms()
    {
        $this->BasicSearch->unsetSession();
    }

    // Clear all advanced search parameters
    protected function resetAdvancedSearchParms()
    {
        $this->SerialNo->AdvancedSearch->unsetSession();
        $this->IPC->AdvancedSearch->unsetSession();
        $this->PageNo->AdvancedSearch->unsetSession();
        $this->Activity->AdvancedSearch->unsetSession();
        $this->District->AdvancedSearch->unsetSession();
        $this->Block->AdvancedSearch->unsetSession();
        $this->Camp->AdvancedSearch->unsetSession();
        $this->NurseryArea->AdvancedSearch->unsetSession();
        $this->Zone->AdvancedSearch->unsetSession();
        $this->ChiefArea->AdvancedSearch->unsetSession();
        $this->Date->AdvancedSearch->unsetSession();
        $this->Village->AdvancedSearch->unsetSession();
        $this->NameOfFarmer->AdvancedSearch->unsetSession();
        $this->YearOfBirth->AdvancedSearch->unsetSession();
        $this->Gender->AdvancedSearch->unsetSession();
        $this->NRC->AdvancedSearch->unsetSession();
        $this->SeedlingsReceived20_21->AdvancedSearch->unsetSession();
        $this->FieldType->AdvancedSearch->unsetSession();
        $this->Contact->AdvancedSearch->unsetSession();
    }

    // Restore all search parameters
    protected function restoreSearchParms()
    {
        $this->RestoreSearch = true;

        // Restore basic search values
        $this->BasicSearch->load();

        // Restore advanced search values
        $this->SerialNo->AdvancedSearch->load();
        $this->IPC->AdvancedSearch->load();
        $this->PageNo->AdvancedSearch->load();
        $this->Activity->AdvancedSearch->load();
        $this->District->AdvancedSearch->load();
        $this->Block->AdvancedSearch->load();
        $this->Camp->AdvancedSearch->load();
        $this->NurseryArea->AdvancedSearch->load();
        $this->Zone->AdvancedSearch->load();
        $this->ChiefArea->AdvancedSearch->load();
        $this->Date->AdvancedSearch->load();
        $this->Village->AdvancedSearch->load();
        $this->NameOfFarmer->AdvancedSearch->load();
        $this->YearOfBirth->AdvancedSearch->load();
        $this->Gender->AdvancedSearch->load();
        $this->NRC->AdvancedSearch->load();
        $this->SeedlingsReceived20_21->AdvancedSearch->load();
        $this->FieldType->AdvancedSearch->load();
        $this->Contact->AdvancedSearch->load();
    }

    // Set up sort parameters
    protected function setupSortOrder()
    {
        // Load default Sorting Order
        if ($this->Command != "json") {
            $defaultSort = ""; // Set up default sort
            if ($this->getSessionOrderBy() == "" && $defaultSort != "") {
                $this->setSessionOrderBy($defaultSort);
            }
        }

        // Check for "order" parameter
        if (Get("order") !== null) {
            $this->CurrentOrder = Get("order");
            $this->CurrentOrderType = Get("ordertype", "");
            $this->updateSort($this->SerialNo); // SerialNo
            $this->updateSort($this->IPC); // IPC
            $this->updateSort($this->PageNo); // PageNo
            $this->updateSort($this->Activity); // Activity
            $this->updateSort($this->District); // District
            $this->updateSort($this->Block); // Block
            $this->updateSort($this->Camp); // Camp
            $this->updateSort($this->NurseryArea); // NurseryArea
            $this->updateSort($this->Zone); // Zone
            $this->updateSort($this->ChiefArea); // ChiefArea
            $this->updateSort($this->Date); // Date
            $this->updateSort($this->Village); // Village
            $this->updateSort($this->NameOfFarmer); // NameOfFarmer
            $this->updateSort($this->YearOfBirth); // YearOfBirth
            $this->updateSort($this->Gender); // Gender
            $this->updateSort($this->NRC); // NRC
            $this->updateSort($this->SeedlingsReceived20_21); // SeedlingsReceived20_21
            $this->updateSort($this->FieldType); // FieldType
            $this->updateSort($this->Contact); // Contact
            $this->setStartRecordNumber(1); // Reset start position
        }

        // Update field sort
        $this->updateFieldSort();
    }

    // Reset command
    // - cmd=reset (Reset search parameters)
    // - cmd=resetall (Reset search and master/detail parameters)
    // - cmd=resetsort (Reset sort parameters)
    protected function resetCmd()
    {
        // Check if reset command
        if (StartsString("reset", $this->Command)) {
            // Reset search criteria
            if ($this->Command == "reset" || $this->Command == "resetall") {
                $this->resetSearchParms();
            }

            // Reset (clear) sorting order
            if ($this->Command == "resetsort") {
                $orderBy = "";
                $this->setSessionOrderBy($orderBy);
                $this->SerialNo->setSort("");
                $this->IPC->setSort("");
                $this->PageNo->setSort("");
                $this->Activity->setSort("");
                $this->District->setSort("");
                $this->Block->setSort("");
                $this->Camp->setSort("");
                $this->NurseryArea->setSort("");
                $this->Zone->setSort("");
                $this->ChiefArea->setSort("");
                $this->Date->setSort("");
                $this->Village->setSort("");
                $this->NameOfFarmer->setSort("");
                $this->YearOfBirth->setSort("");
                $this->Gender->setSort("");
                $this->NRC->setSort("");
                $this->SeedlingsReceived20_21->setSort("");
                $this->FieldType->setSort("");
                $this->Contact->setSort("");
            }

            // Reset start position
            $this->StartRecord = 1;
            $this->setStartRecordNumber($this->StartRecord);
        }
    }

    // Set up list options
    protected function setupListOptions()
    {
        global $Security, $Language;

        // Add group option item ("button")
        $item = &$this->ListOptions->addGroupOption();
        $item->Body = "";
        $item->OnLeft = true;
        $item->Visible = false;

        // List actions
        $item = &$this->ListOptions->add("listactions");
        $item->CssClass = "text-nowrap";
        $item->OnLeft = true;
        $item->Visible = false;
        $item->ShowInButtonGroup = false;
        $item->ShowInDropDown = false;

        // "checkbox"
        $item = &$this->ListOptions->add("checkbox");
        $item->Visible = false;
        $item->OnLeft = true;
        $item->Header = "<div class=\"form-check\"><input type=\"checkbox\" name=\"key\" id=\"key\" class=\"form-check-input\" data-ew-action=\"select-all-keys\"></div>";
        if ($item->OnLeft) {
            $item->moveTo(0);
        }
        $item->ShowInDropDown = false;
        $item->ShowInButtonGroup = false;

        // Drop down button for ListOptions
        $this->ListOptions->UseDropDownButton = true;
        $this->ListOptions->DropDownButtonPhrase = $Language->phrase("ButtonListOptions");
        $this->ListOptions->UseButtonGroup = true;
        if ($this->ListOptions->UseButtonGroup && IsMobile()) {
            $this->ListOptions->UseDropDownButton = true;
        }

        //$this->ListOptions->ButtonClass = ""; // Class for button group

        // Call ListOptions_Load event
        $this->listOptionsLoad();
        $this->setupListOptionsExt();
        $item = $this->ListOptions[$this->ListOptions->GroupOptionName];
        $item->Visible = $this->ListOptions->groupOptionVisible();
    }

    // Set up list options (extensions)
    protected function setupListOptionsExt()
    {
        // Preview extension
        $this->ListOptions->hideDetailItemsForDropDown(); // Hide detail items for dropdown if necessary
    }

    // Add "hash" parameter to URL
    public function urlAddHash($url, $hash)
    {
        return $this->UseAjaxActions ? $url : UrlAddQuery($url, "hash=" . $hash);
    }

    // Render list options
    public function renderListOptions()
    {
        global $Security, $Language, $CurrentForm;
        $this->ListOptions->loadDefault();

        // Call ListOptions_Rendering event
        $this->listOptionsRendering();
        $pageUrl = $this->pageUrl(false);
        if ($this->CurrentMode == "view") { // Check view mode
        } // End View mode

        // Set up list action buttons
        $opt = $this->ListOptions["listactions"];
        if ($opt && !$this->isExport() && !$this->CurrentAction) {
            $body = "";
            $links = [];
            foreach ($this->ListActions as $listAction) {
                $action = $listAction->Action;
                $allowed = $listAction->Allowed;
                $disabled = false;
                if ($listAction->Select == ACTION_SINGLE && $allowed) {
                    $caption = $listAction->Caption;
                    $title = HtmlTitle($caption);
                    if ($action != "") {
                        $icon = ($listAction->Icon != "") ? "<i class=\"" . HtmlEncode(str_replace(" ew-icon", "", $listAction->Icon)) . "\" data-caption=\"" . $title . "\"></i> " : "";
                        $link = $disabled
                            ? "<li><div class=\"alert alert-light\">" . $icon . " " . $caption . "</div></li>"
                            : "<li><button type=\"button\" class=\"dropdown-item ew-action ew-list-action\" data-caption=\"" . $title . "\" data-ew-action=\"submit\" form=\"fseason20_21list\" data-key=\"" . $this->keyToJson(true) . "\"" . $listAction->toDataAttributes() . ">" . $icon . " " . $caption . "</button></li>";
                        $links[] = $link;
                        if ($body == "") { // Setup first button
                            $body = $disabled
                            ? "<div class=\"alert alert-light\">" . $icon . " " . $caption . "</div>"
                            : "<button type=\"button\" class=\"btn btn-default ew-action ew-list-action\" title=\"" . $title . "\" data-caption=\"" . $title . "\" data-ew-action=\"submit\" form=\"fseason20_21list\" data-key=\"" . $this->keyToJson(true) . "\"" . $listAction->toDataAttributes() . ">" . $icon . " " . $caption . "</button>";
                        }
                    }
                }
            }
            if (count($links) > 1) { // More than one buttons, use dropdown
                $body = "<button type=\"button\" class=\"dropdown-toggle btn btn-default ew-actions\" title=\"" . HtmlTitle($Language->phrase("ListActionButton")) . "\" data-bs-toggle=\"dropdown\">" . $Language->phrase("ListActionButton") . "</button>";
                $content = "";
                foreach ($links as $link) {
                    $content .= "<li>" . $link . "</li>";
                }
                $body .= "<ul class=\"dropdown-menu" . ($opt->OnLeft ? "" : " dropdown-menu-right") . "\">" . $content . "</ul>";
                $body = "<div class=\"btn-group btn-group-sm\">" . $body . "</div>";
            }
            if (count($links) > 0) {
                $opt->Body = $body;
            }
        }

        // "checkbox"
        $opt = $this->ListOptions["checkbox"];
        $this->renderListOptionsExt();

        // Call ListOptions_Rendered event
        $this->listOptionsRendered();
    }

    // Render list options (extensions)
    protected function renderListOptionsExt()
    {
        // Render list options (to be implemented by extensions)
        global $Security, $Language;
    }

    // Set up other options
    protected function setupOtherOptions()
    {
        global $Language, $Security;
        $options = &$this->OtherOptions;
        $option = $options["action"];

        // Show column list for column visibility
        if ($this->UseColumnVisibility) {
            $option = $this->OtherOptions["column"];
            $item = &$option->addGroupOption();
            $item->Body = "";
            $item->Visible = $this->UseColumnVisibility;
            $this->createColumnOption($option, "SerialNo");
            $this->createColumnOption($option, "IPC");
            $this->createColumnOption($option, "PageNo");
            $this->createColumnOption($option, "Activity");
            $this->createColumnOption($option, "District");
            $this->createColumnOption($option, "Block");
            $this->createColumnOption($option, "Camp");
            $this->createColumnOption($option, "NurseryArea");
            $this->createColumnOption($option, "Zone");
            $this->createColumnOption($option, "ChiefArea");
            $this->createColumnOption($option, "Date");
            $this->createColumnOption($option, "Village");
            $this->createColumnOption($option, "NameOfFarmer");
            $this->createColumnOption($option, "YearOfBirth");
            $this->createColumnOption($option, "Gender");
            $this->createColumnOption($option, "NRC");
            $this->createColumnOption($option, "SeedlingsReceived20_21");
            $this->createColumnOption($option, "FieldType");
            $this->createColumnOption($option, "Contact");
        }

        // Set up custom actions
        foreach ($this->CustomActions as $name => $action) {
            $this->ListActions[$name] = $action;
        }

        // Set up options default
        foreach ($options as $name => $option) {
            if ($name != "column") { // Always use dropdown for column
                $option->UseDropDownButton = true;
                $option->UseButtonGroup = true;
            }
            //$option->ButtonClass = ""; // Class for button group
            $item = &$option->addGroupOption();
            $item->Body = "";
            $item->Visible = false;
        }
        $options["addedit"]->DropDownButtonPhrase = $Language->phrase("ButtonAddEdit");
        $options["detail"]->DropDownButtonPhrase = $Language->phrase("ButtonDetails");
        $options["action"]->DropDownButtonPhrase = $Language->phrase("ButtonActions");

        // Filter button
        $item = &$this->FilterOptions->add("savecurrentfilter");
        $item->Body = "<a class=\"ew-save-filter\" data-form=\"fseason20_21srch\" data-ew-action=\"none\">" . $Language->phrase("SaveCurrentFilter") . "</a>";
        $item->Visible = true;
        $item = &$this->FilterOptions->add("deletefilter");
        $item->Body = "<a class=\"ew-delete-filter\" data-form=\"fseason20_21srch\" data-ew-action=\"none\">" . $Language->phrase("DeleteFilter") . "</a>";
        $item->Visible = true;
        $this->FilterOptions->UseDropDownButton = true;
        $this->FilterOptions->UseButtonGroup = !$this->FilterOptions->UseDropDownButton;
        $this->FilterOptions->DropDownButtonPhrase = $Language->phrase("Filters");

        // Add group option item
        $item = &$this->FilterOptions->addGroupOption();
        $item->Body = "";
        $item->Visible = false;

        // Page header/footer options
        $this->HeaderOptions = new ListOptions(TagClassName: "ew-header-option", UseDropDownButton: false, UseButtonGroup: false);
        $item = &$this->HeaderOptions->addGroupOption();
        $item->Body = "";
        $item->Visible = false;
        $this->FooterOptions = new ListOptions(TagClassName: "ew-footer-option", UseDropDownButton: false, UseButtonGroup: false);
        $item = &$this->FooterOptions->addGroupOption();
        $item->Body = "";
        $item->Visible = false;

        // Show active user count from SQL
    }

    // Active user filter
    // - Get active users by SQL (SELECT COUNT(*) FROM UserTable WHERE ProfileField LIKE '%"SessionID":%')
    protected function activeUserFilter()
    {
        if (UserProfile::$FORCE_LOGOUT_USER) {
            $userProfileField = $this->Fields[Config("USER_PROFILE_FIELD_NAME")];
            return $userProfileField->Expression . " LIKE '%\"" . UserProfile::$SESSION_ID . "\":%'";
        }
        return "0=1"; // No active users
    }

    // Create new column option
    protected function createColumnOption($option, $name)
    {
        $field = $this->Fields[$name] ?? null;
        if ($field?->Visible) {
            $item = $option->add($field->Name);
            $item->Body = '<button class="dropdown-item">' .
                '<div class="form-check ew-dropdown-checkbox">' .
                '<div class="form-check-input ew-dropdown-check-input" data-field="' . $field->Param . '"></div>' .
                '<label class="form-check-label ew-dropdown-check-label">' . $field->caption() . '</label></div></button>';
        }
    }

    // Render other options
    public function renderOtherOptions()
    {
        global $Language, $Security;
        $options = &$this->OtherOptions;
        $option = $options["action"];
        // Set up list action buttons
        foreach ($this->ListActions as $listAction) {
            if ($listAction->Select == ACTION_MULTIPLE) {
                $item = &$option->add("custom_" . $listAction->Action);
                $caption = $listAction->Caption;
                $icon = ($listAction->Icon != "") ? '<i class="' . HtmlEncode($listAction->Icon) . '" data-caption="' . HtmlEncode($caption) . '"></i>' . $caption : $caption;
                $item->Body = '<button type="button" class="btn btn-default ew-action ew-list-action" title="' . HtmlEncode($caption) . '" data-caption="' . HtmlEncode($caption) . '" data-ew-action="submit" form="fseason20_21list"' . $listAction->toDataAttributes() . '>' . $icon . '</button>';
                $item->Visible = $listAction->Allowed;
            }
        }

        // Hide multi edit, grid edit and other options
        if ($this->TotalRecords <= 0) {
            $option = $options["addedit"];
            $item = $option["gridedit"];
            if ($item) {
                $item->Visible = false;
            }
            $option = $options["action"];
            $option->hideAllOptions();
        }
    }

    // Process list action
    protected function processListAction()
    {
        global $Language, $Security, $Response;
        $users = [];
        $user = "";
        $filter = $this->getFilterFromRecordKeys();
        $userAction = Post("action", "");
        if ($filter != "" && $userAction != "") {
            $conn = $this->getConnection();
            // Clear current action
            $this->CurrentAction = "";
            // Check permission first
            $actionCaption = $userAction;
            $listAction = $this->ListActions[$userAction] ?? null;
            if ($listAction) {
                $this->UserAction = $userAction;
                $actionCaption = $listAction->Caption ?: $listAction->Action;
                if (!$listAction->Allowed) {
                    $errmsg = str_replace('%s', $actionCaption, $Language->phrase("CustomActionNotAllowed"));
                    if (Post("ajax") == $userAction) { // Ajax
                        echo "<p class=\"text-danger\">" . $errmsg . "</p>";
                        return true;
                    } else {
                        $this->setFailureMessage($errmsg);
                        return false;
                    }
                }
            } else {
                $errmsg = str_replace('%s', $userAction, $Language->phrase("CustomActionNotFound"));
                if (Post("ajax") == $userAction) { // Ajax
                    echo "<p class=\"text-danger\">" . $errmsg . "</p>";
                    return true;
                } else {
                    $this->setFailureMessage($errmsg);
                    return false;
                }
            }
            $rows = $this->loadRs($filter)->fetchAllAssociative();
            $this->SelectedCount = count($rows);
            $this->ActionValue = Post("actionvalue");

            // Call row action event
            if ($this->SelectedCount > 0) {
                if ($this->UseTransaction) {
                    $conn->beginTransaction();
                }
                $this->SelectedIndex = 0;
                foreach ($rows as $row) {
                    $this->SelectedIndex++;
                    $processed = $listAction->handle($row, $this);
                    if (!$processed) {
                        break;
                    }
                    $processed = $this->rowCustomAction($userAction, $row);
                    if (!$processed) {
                        break;
                    }
                }
                if ($processed) {
                    if ($this->UseTransaction) { // Commit transaction
                        if ($conn->isTransactionActive()) {
                            $conn->commit();
                        }
                    }
                    if ($this->getSuccessMessage() == "") {
                        $this->setSuccessMessage($listAction->SuccessMessage);
                    }
                    if ($this->getSuccessMessage() == "") {
                        $this->setSuccessMessage(str_replace("%s", $actionCaption, $Language->phrase("CustomActionCompleted"))); // Set up success message
                    }
                } else {
                    if ($this->UseTransaction) { // Rollback transaction
                        if ($conn->isTransactionActive()) {
                            $conn->rollback();
                        }
                    }
                    if ($this->getFailureMessage() == "") {
                        $this->setFailureMessage($listAction->FailureMessage);
                    }

                    // Set up error message
                    if ($this->getSuccessMessage() != "" || $this->getFailureMessage() != "") {
                        // Use the message, do nothing
                    } elseif ($this->CancelMessage != "") {
                        $this->setFailureMessage($this->CancelMessage);
                        $this->CancelMessage = "";
                    } else {
                        $this->setFailureMessage(str_replace('%s', $actionCaption, $Language->phrase("CustomActionFailed")));
                    }
                }
            }
            if (Post("ajax") == $userAction) { // Ajax
                if (WithJsonResponse()) { // List action returns JSON
                    $this->clearSuccessMessage(); // Clear success message
                    $this->clearFailureMessage(); // Clear failure message
                } else {
                    if ($this->getSuccessMessage() != "") {
                        echo "<p class=\"text-success\">" . $this->getSuccessMessage() . "</p>";
                        $this->clearSuccessMessage(); // Clear success message
                    }
                    if ($this->getFailureMessage() != "") {
                        echo "<p class=\"text-danger\">" . $this->getFailureMessage() . "</p>";
                        $this->clearFailureMessage(); // Clear failure message
                    }
                }
                return true;
            }
        }
        return false; // Not ajax request
    }

    // Set up Grid
    public function setupGrid()
    {
        global $CurrentForm;
        if ($this->ExportAll && $this->isExport()) {
            $this->StopRecord = $this->TotalRecords;
        } else {
            // Set the last record to display
            if ($this->TotalRecords > $this->StartRecord + $this->DisplayRecords - 1) {
                $this->StopRecord = $this->StartRecord + $this->DisplayRecords - 1;
            } else {
                $this->StopRecord = $this->TotalRecords;
            }
        }
        $this->RecordCount = $this->StartRecord - 1;
        if ($this->CurrentRow !== false) {
            // Nothing to do
        } elseif ($this->isGridAdd() && !$this->AllowAddDeleteRow && $this->StopRecord == 0) { // Grid-Add with no records
            $this->StopRecord = $this->GridAddRowCount;
        } elseif ($this->isAdd() && $this->TotalRecords == 0) { // Inline-Add with no records
            $this->StopRecord = 1;
        }

        // Initialize aggregate
        $this->RowType = RowType::AGGREGATEINIT;
        $this->resetAttributes();
        $this->renderRow();
        if (($this->isGridAdd() || $this->isGridEdit())) { // Render template row first
            $this->RowIndex = '$rowindex$';
        }
    }

    // Set up Row
    public function setupRow()
    {
        global $CurrentForm;
        if ($this->isGridAdd() || $this->isGridEdit()) {
            if ($this->RowIndex === '$rowindex$') { // Render template row first
                $this->loadRowValues();

                // Set row properties
                $this->resetAttributes();
                $this->RowAttrs->merge(["data-rowindex" => $this->RowIndex, "id" => "r0_season20_21", "data-rowtype" => RowType::ADD]);
                $this->RowAttrs->appendClass("ew-template");
                // Render row
                $this->RowType = RowType::ADD;
                $this->renderRow();

                // Render list options
                $this->renderListOptions();

                // Reset record count for template row
                $this->RecordCount--;
                return;
            }
        }

        // Set up key count
        $this->KeyCount = $this->RowIndex;

        // Init row class and style
        $this->resetAttributes();
        $this->CssClass = "";
        if ($this->isCopy() && $this->InlineRowCount == 0 && !$this->loadRow()) { // Inline copy
            $this->CurrentAction = "add";
        }
        if ($this->isAdd() && $this->InlineRowCount == 0 || $this->isGridAdd()) {
            $this->loadRowValues(); // Load default values
            $this->OldKey = "";
            $this->setKey($this->OldKey);
        } elseif ($this->isInlineInserted() && $this->UseInfiniteScroll) {
            // Nothing to do, just use current values
        } elseif (!($this->isCopy() && $this->InlineRowCount == 0)) {
            $this->loadRowValues($this->CurrentRow); // Load row values
            if ($this->isGridEdit() || $this->isMultiEdit()) {
                $this->OldKey = $this->getKey(true); // Get from CurrentValue
                $this->setKey($this->OldKey);
            }
        }
        $this->RowType = RowType::VIEW; // Render view
        if (($this->isAdd() || $this->isCopy()) && $this->InlineRowCount == 0 || $this->isGridAdd()) { // Add
            $this->RowType = RowType::ADD; // Render add
        }

        // Inline Add/Copy row (row 0)
        if ($this->RowType == RowType::ADD && ($this->isAdd() || $this->isCopy())) {
            $this->InlineRowCount++;
            $this->RecordCount--; // Reset record count for inline add/copy row
            if ($this->TotalRecords == 0) { // Reset stop record if no records
                $this->StopRecord = 0;
            }
        } else {
            // Inline Edit row
            if ($this->RowType == RowType::EDIT && $this->isEdit()) {
                $this->InlineRowCount++;
            }
            $this->RowCount++; // Increment row count
        }

        // Set up row attributes
        $this->RowAttrs->merge([
            "data-rowindex" => $this->RowCount,
            "data-key" => $this->getKey(true),
            "id" => "r" . $this->RowCount . "_season20_21",
            "data-rowtype" => $this->RowType,
            "data-inline" => ($this->isAdd() || $this->isCopy() || $this->isEdit()) ? "true" : "false", // Inline-Add/Copy/Edit
            "class" => ($this->RowCount % 2 != 1) ? "ew-table-alt-row" : "",
        ]);
        if ($this->isAdd() && $this->RowType == RowType::ADD || $this->isEdit() && $this->RowType == RowType::EDIT) { // Inline-Add/Edit row
            $this->RowAttrs->appendClass("table-active");
        }

        // Render row
        $this->renderRow();

        // Render list options
        $this->renderListOptions();
    }

    // Load basic search values
    protected function loadBasicSearchValues()
    {
        $this->BasicSearch->setKeyword(Get(Config("TABLE_BASIC_SEARCH"), ""), false);
        if ($this->BasicSearch->Keyword != "" && $this->Command == "") {
            $this->Command = "search";
        }
        $this->BasicSearch->setType(Get(Config("TABLE_BASIC_SEARCH_TYPE"), ""), false);
    }

    // Load search values for validation
    protected function loadSearchValues()
    {
        // Load search values
        $hasValue = false;

        // Load query builder rules
        $rules = Post("rules");
        if ($rules && $this->Command == "") {
            $this->QueryRules = $rules;
            $this->Command = "search";
        }

        // SerialNo
        if ($this->SerialNo->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->SerialNo->AdvancedSearch->SearchValue != "" || $this->SerialNo->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // IPC
        if ($this->IPC->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->IPC->AdvancedSearch->SearchValue != "" || $this->IPC->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // PageNo
        if ($this->PageNo->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->PageNo->AdvancedSearch->SearchValue != "" || $this->PageNo->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // Activity
        if ($this->Activity->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->Activity->AdvancedSearch->SearchValue != "" || $this->Activity->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // District
        if ($this->District->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->District->AdvancedSearch->SearchValue != "" || $this->District->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // Block
        if ($this->Block->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->Block->AdvancedSearch->SearchValue != "" || $this->Block->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // Camp
        if ($this->Camp->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->Camp->AdvancedSearch->SearchValue != "" || $this->Camp->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // NurseryArea
        if ($this->NurseryArea->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->NurseryArea->AdvancedSearch->SearchValue != "" || $this->NurseryArea->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // Zone
        if ($this->Zone->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->Zone->AdvancedSearch->SearchValue != "" || $this->Zone->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // ChiefArea
        if ($this->ChiefArea->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->ChiefArea->AdvancedSearch->SearchValue != "" || $this->ChiefArea->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // Date
        if ($this->Date->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->Date->AdvancedSearch->SearchValue != "" || $this->Date->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // Village
        if ($this->Village->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->Village->AdvancedSearch->SearchValue != "" || $this->Village->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // NameOfFarmer
        if ($this->NameOfFarmer->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->NameOfFarmer->AdvancedSearch->SearchValue != "" || $this->NameOfFarmer->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // YearOfBirth
        if ($this->YearOfBirth->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->YearOfBirth->AdvancedSearch->SearchValue != "" || $this->YearOfBirth->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // Gender
        if ($this->Gender->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->Gender->AdvancedSearch->SearchValue != "" || $this->Gender->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // NRC
        if ($this->NRC->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->NRC->AdvancedSearch->SearchValue != "" || $this->NRC->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // SeedlingsReceived20_21
        if ($this->SeedlingsReceived20_21->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->SeedlingsReceived20_21->AdvancedSearch->SearchValue != "" || $this->SeedlingsReceived20_21->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // FieldType
        if ($this->FieldType->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->FieldType->AdvancedSearch->SearchValue != "" || $this->FieldType->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }

        // Contact
        if ($this->Contact->AdvancedSearch->get()) {
            $hasValue = true;
            if (($this->Contact->AdvancedSearch->SearchValue != "" || $this->Contact->AdvancedSearch->SearchValue2 != "") && $this->Command == "") {
                $this->Command = "search";
            }
        }
        return $hasValue;
    }

    /**
     * Load result set
     *
     * @param int $offset Offset
     * @param int $rowcnt Maximum number of rows
     * @return Doctrine\DBAL\Result Result
     */
    public function loadRecordset($offset = -1, $rowcnt = -1)
    {
        // Load List page SQL (QueryBuilder)
        $sql = $this->getListSql();

        // Load result set
        if ($offset > -1) {
            $sql->setFirstResult($offset);
        }
        if ($rowcnt > 0) {
            $sql->setMaxResults($rowcnt);
        }
        $result = $sql->executeQuery();
        if (property_exists($this, "TotalRecords") && $rowcnt < 0) {
            $this->TotalRecords = $result->rowCount();
            if ($this->TotalRecords <= 0) { // Handle database drivers that does not return rowCount()
                $this->TotalRecords = $this->getRecordCount($this->getListSql());
            }
        }

        // Call Recordset Selected event
        $this->recordsetSelected($result);
        return $result;
    }

    /**
     * Load records as associative array
     *
     * @param int $offset Offset
     * @param int $rowcnt Maximum number of rows
     * @return void
     */
    public function loadRows($offset = -1, $rowcnt = -1)
    {
        // Load List page SQL (QueryBuilder)
        $sql = $this->getListSql();

        // Load result set
        if ($offset > -1) {
            $sql->setFirstResult($offset);
        }
        if ($rowcnt > 0) {
            $sql->setMaxResults($rowcnt);
        }
        $result = $sql->executeQuery();
        return $result->fetchAllAssociative();
    }

    /**
     * Load row based on key values
     *
     * @return void
     */
    public function loadRow()
    {
        global $Security, $Language;
        $filter = $this->getRecordFilter();

        // Call Row Selecting event
        $this->rowSelecting($filter);

        // Load SQL based on filter
        $this->CurrentFilter = $filter;
        $sql = $this->getCurrentSql();
        $conn = $this->getConnection();
        $res = false;
        $row = $conn->fetchAssociative($sql);
        if ($row) {
            $res = true;
            $this->loadRowValues($row); // Load row values
        }
        return $res;
    }

    /**
     * Load row values from result set or record
     *
     * @param array $row Record
     * @return void
     */
    public function loadRowValues($row = null)
    {
        $row = is_array($row) ? $row : $this->newRow();

        // Call Row Selected event
        $this->rowSelected($row);
        $this->SerialNo->setDbValue($row['SerialNo']);
        $this->IPC->setDbValue($row['IPC']);
        $this->PageNo->setDbValue($row['PageNo']);
        $this->Activity->setDbValue($row['Activity']);
        $this->District->setDbValue($row['District']);
        $this->Block->setDbValue($row['Block']);
        $this->Camp->setDbValue($row['Camp']);
        $this->NurseryArea->setDbValue($row['NurseryArea']);
        $this->Zone->setDbValue($row['Zone']);
        $this->ChiefArea->setDbValue($row['ChiefArea']);
        $this->Date->setDbValue($row['Date']);
        $this->Village->setDbValue($row['Village']);
        $this->NameOfFarmer->setDbValue($row['NameOfFarmer']);
        $this->YearOfBirth->setDbValue($row['YearOfBirth']);
        $this->Gender->setDbValue($row['Gender']);
        $this->NRC->setDbValue($row['NRC']);
        $this->SeedlingsReceived20_21->setDbValue($row['SeedlingsReceived20_21']);
        $this->FieldType->setDbValue($row['FieldType']);
        $this->Contact->setDbValue($row['Contact']);
    }

    // Return a row with default values
    protected function newRow()
    {
        $row = [];
        $row['SerialNo'] = $this->SerialNo->DefaultValue;
        $row['IPC'] = $this->IPC->DefaultValue;
        $row['PageNo'] = $this->PageNo->DefaultValue;
        $row['Activity'] = $this->Activity->DefaultValue;
        $row['District'] = $this->District->DefaultValue;
        $row['Block'] = $this->Block->DefaultValue;
        $row['Camp'] = $this->Camp->DefaultValue;
        $row['NurseryArea'] = $this->NurseryArea->DefaultValue;
        $row['Zone'] = $this->Zone->DefaultValue;
        $row['ChiefArea'] = $this->ChiefArea->DefaultValue;
        $row['Date'] = $this->Date->DefaultValue;
        $row['Village'] = $this->Village->DefaultValue;
        $row['NameOfFarmer'] = $this->NameOfFarmer->DefaultValue;
        $row['YearOfBirth'] = $this->YearOfBirth->DefaultValue;
        $row['Gender'] = $this->Gender->DefaultValue;
        $row['NRC'] = $this->NRC->DefaultValue;
        $row['SeedlingsReceived20_21'] = $this->SeedlingsReceived20_21->DefaultValue;
        $row['FieldType'] = $this->FieldType->DefaultValue;
        $row['Contact'] = $this->Contact->DefaultValue;
        return $row;
    }

    // Load old record
    protected function loadOldRecord()
    {
        $this->loadRowValues(); // Load default row values
        return null;
    }

    // Render row values based on field settings
    public function renderRow()
    {
        global $Security, $Language, $CurrentLanguage;

        // Initialize URLs
        $this->ViewUrl = $this->getViewUrl();
        $this->EditUrl = $this->getEditUrl();
        $this->InlineEditUrl = $this->getInlineEditUrl();
        $this->CopyUrl = $this->getCopyUrl();
        $this->InlineCopyUrl = $this->getInlineCopyUrl();
        $this->DeleteUrl = $this->getDeleteUrl();

        // Call Row_Rendering event
        $this->rowRendering();

        // Common render codes for all row types

        // SerialNo

        // IPC

        // PageNo

        // Activity

        // District

        // Block

        // Camp

        // NurseryArea

        // Zone

        // ChiefArea

        // Date

        // Village

        // NameOfFarmer

        // YearOfBirth

        // Gender

        // NRC

        // SeedlingsReceived20_21

        // FieldType

        // Contact

        // View row
        if ($this->RowType == RowType::VIEW) {
            // SerialNo
            $this->SerialNo->ViewValue = $this->SerialNo->CurrentValue;
            $this->SerialNo->ViewValue = FormatNumber($this->SerialNo->ViewValue, $this->SerialNo->formatPattern());

            // IPC
            $this->IPC->ViewValue = $this->IPC->CurrentValue;

            // PageNo
            $this->PageNo->ViewValue = $this->PageNo->CurrentValue;
            $this->PageNo->ViewValue = FormatNumber($this->PageNo->ViewValue, $this->PageNo->formatPattern());

            // Activity
            $this->Activity->ViewValue = $this->Activity->CurrentValue;

            // District
            $this->District->ViewValue = $this->District->CurrentValue;

            // Block
            $this->Block->ViewValue = $this->Block->CurrentValue;

            // Camp
            $this->Camp->ViewValue = $this->Camp->CurrentValue;

            // NurseryArea
            $this->NurseryArea->ViewValue = $this->NurseryArea->CurrentValue;

            // Zone
            $this->Zone->ViewValue = $this->Zone->CurrentValue;

            // ChiefArea
            $this->ChiefArea->ViewValue = $this->ChiefArea->CurrentValue;

            // Date
            $this->Date->ViewValue = $this->Date->CurrentValue;

            // Village
            $this->Village->ViewValue = $this->Village->CurrentValue;

            // NameOfFarmer
            $this->NameOfFarmer->ViewValue = $this->NameOfFarmer->CurrentValue;

            // YearOfBirth
            $this->YearOfBirth->ViewValue = $this->YearOfBirth->CurrentValue;

            // Gender
            $this->Gender->ViewValue = $this->Gender->CurrentValue;

            // NRC
            $this->NRC->ViewValue = $this->NRC->CurrentValue;

            // SeedlingsReceived20_21
            $this->SeedlingsReceived20_21->ViewValue = $this->SeedlingsReceived20_21->CurrentValue;
            $this->SeedlingsReceived20_21->ViewValue = FormatNumber($this->SeedlingsReceived20_21->ViewValue, $this->SeedlingsReceived20_21->formatPattern());

            // FieldType
            $this->FieldType->ViewValue = $this->FieldType->CurrentValue;

            // Contact
            $this->Contact->ViewValue = $this->Contact->CurrentValue;

            // SerialNo
            $this->SerialNo->HrefValue = "";
            $this->SerialNo->TooltipValue = "";

            // IPC
            $this->IPC->HrefValue = "";
            $this->IPC->TooltipValue = "";
            if (!$this->isExport()) {
                $this->IPC->ViewValue = $this->highlightValue($this->IPC);
            }

            // PageNo
            $this->PageNo->HrefValue = "";
            $this->PageNo->TooltipValue = "";

            // Activity
            $this->Activity->HrefValue = "";
            $this->Activity->TooltipValue = "";
            if (!$this->isExport()) {
                $this->Activity->ViewValue = $this->highlightValue($this->Activity);
            }

            // District
            $this->District->HrefValue = "";
            $this->District->TooltipValue = "";
            if (!$this->isExport()) {
                $this->District->ViewValue = $this->highlightValue($this->District);
            }

            // Block
            $this->Block->HrefValue = "";
            $this->Block->TooltipValue = "";
            if (!$this->isExport()) {
                $this->Block->ViewValue = $this->highlightValue($this->Block);
            }

            // Camp
            $this->Camp->HrefValue = "";
            $this->Camp->TooltipValue = "";
            if (!$this->isExport()) {
                $this->Camp->ViewValue = $this->highlightValue($this->Camp);
            }

            // NurseryArea
            $this->NurseryArea->HrefValue = "";
            $this->NurseryArea->TooltipValue = "";
            if (!$this->isExport()) {
                $this->NurseryArea->ViewValue = $this->highlightValue($this->NurseryArea);
            }

            // Zone
            $this->Zone->HrefValue = "";
            $this->Zone->TooltipValue = "";
            if (!$this->isExport()) {
                $this->Zone->ViewValue = $this->highlightValue($this->Zone);
            }

            // ChiefArea
            $this->ChiefArea->HrefValue = "";
            $this->ChiefArea->TooltipValue = "";
            if (!$this->isExport()) {
                $this->ChiefArea->ViewValue = $this->highlightValue($this->ChiefArea);
            }

            // Date
            $this->Date->HrefValue = "";
            $this->Date->TooltipValue = "";
            if (!$this->isExport()) {
                $this->Date->ViewValue = $this->highlightValue($this->Date);
            }

            // Village
            $this->Village->HrefValue = "";
            $this->Village->TooltipValue = "";
            if (!$this->isExport()) {
                $this->Village->ViewValue = $this->highlightValue($this->Village);
            }

            // NameOfFarmer
            $this->NameOfFarmer->HrefValue = "";
            $this->NameOfFarmer->TooltipValue = "";
            if (!$this->isExport()) {
                $this->NameOfFarmer->ViewValue = $this->highlightValue($this->NameOfFarmer);
            }

            // YearOfBirth
            $this->YearOfBirth->HrefValue = "";
            $this->YearOfBirth->TooltipValue = "";
            if (!$this->isExport()) {
                $this->YearOfBirth->ViewValue = $this->highlightValue($this->YearOfBirth);
            }

            // Gender
            $this->Gender->HrefValue = "";
            $this->Gender->TooltipValue = "";
            if (!$this->isExport()) {
                $this->Gender->ViewValue = $this->highlightValue($this->Gender);
            }

            // NRC
            $this->NRC->HrefValue = "";
            $this->NRC->TooltipValue = "";
            if (!$this->isExport()) {
                $this->NRC->ViewValue = $this->highlightValue($this->NRC);
            }

            // SeedlingsReceived20_21
            $this->SeedlingsReceived20_21->HrefValue = "";
            $this->SeedlingsReceived20_21->TooltipValue = "";

            // FieldType
            $this->FieldType->HrefValue = "";
            $this->FieldType->TooltipValue = "";
            if (!$this->isExport()) {
                $this->FieldType->ViewValue = $this->highlightValue($this->FieldType);
            }

            // Contact
            $this->Contact->HrefValue = "";
            $this->Contact->TooltipValue = "";
            if (!$this->isExport()) {
                $this->Contact->ViewValue = $this->highlightValue($this->Contact);
            }
        } elseif ($this->RowType == RowType::SEARCH) {
            // SerialNo
            $this->SerialNo->setupEditAttributes();
            $this->SerialNo->EditValue = $this->SerialNo->AdvancedSearch->SearchValue;
            $this->SerialNo->PlaceHolder = RemoveHtml($this->SerialNo->caption());

            // IPC
            $this->IPC->setupEditAttributes();
            if (!$this->IPC->Raw) {
                $this->IPC->AdvancedSearch->SearchValue = HtmlDecode($this->IPC->AdvancedSearch->SearchValue);
            }
            $this->IPC->EditValue = HtmlEncode($this->IPC->AdvancedSearch->SearchValue);
            $this->IPC->PlaceHolder = RemoveHtml($this->IPC->caption());

            // PageNo
            $this->PageNo->setupEditAttributes();
            $this->PageNo->EditValue = $this->PageNo->AdvancedSearch->SearchValue;
            $this->PageNo->PlaceHolder = RemoveHtml($this->PageNo->caption());

            // Activity
            if ($this->Activity->UseFilter && !EmptyValue($this->Activity->AdvancedSearch->SearchValue)) {
                if (is_array($this->Activity->AdvancedSearch->SearchValue)) {
                    $this->Activity->AdvancedSearch->SearchValue = implode(Config("FILTER_OPTION_SEPARATOR"), $this->Activity->AdvancedSearch->SearchValue);
                }
                $this->Activity->EditValue = explode(Config("FILTER_OPTION_SEPARATOR"), $this->Activity->AdvancedSearch->SearchValue);
            }

            // District
            if ($this->District->UseFilter && !EmptyValue($this->District->AdvancedSearch->SearchValue)) {
                if (is_array($this->District->AdvancedSearch->SearchValue)) {
                    $this->District->AdvancedSearch->SearchValue = implode(Config("FILTER_OPTION_SEPARATOR"), $this->District->AdvancedSearch->SearchValue);
                }
                $this->District->EditValue = explode(Config("FILTER_OPTION_SEPARATOR"), $this->District->AdvancedSearch->SearchValue);
            }

            // Block
            if ($this->Block->UseFilter && !EmptyValue($this->Block->AdvancedSearch->SearchValue)) {
                if (is_array($this->Block->AdvancedSearch->SearchValue)) {
                    $this->Block->AdvancedSearch->SearchValue = implode(Config("FILTER_OPTION_SEPARATOR"), $this->Block->AdvancedSearch->SearchValue);
                }
                $this->Block->EditValue = explode(Config("FILTER_OPTION_SEPARATOR"), $this->Block->AdvancedSearch->SearchValue);
            }

            // Camp
            if ($this->Camp->UseFilter && !EmptyValue($this->Camp->AdvancedSearch->SearchValue)) {
                if (is_array($this->Camp->AdvancedSearch->SearchValue)) {
                    $this->Camp->AdvancedSearch->SearchValue = implode(Config("FILTER_OPTION_SEPARATOR"), $this->Camp->AdvancedSearch->SearchValue);
                }
                $this->Camp->EditValue = explode(Config("FILTER_OPTION_SEPARATOR"), $this->Camp->AdvancedSearch->SearchValue);
            }

            // NurseryArea
            if ($this->NurseryArea->UseFilter && !EmptyValue($this->NurseryArea->AdvancedSearch->SearchValue)) {
                if (is_array($this->NurseryArea->AdvancedSearch->SearchValue)) {
                    $this->NurseryArea->AdvancedSearch->SearchValue = implode(Config("FILTER_OPTION_SEPARATOR"), $this->NurseryArea->AdvancedSearch->SearchValue);
                }
                $this->NurseryArea->EditValue = explode(Config("FILTER_OPTION_SEPARATOR"), $this->NurseryArea->AdvancedSearch->SearchValue);
            }

            // Zone
            if ($this->Zone->UseFilter && !EmptyValue($this->Zone->AdvancedSearch->SearchValue)) {
                if (is_array($this->Zone->AdvancedSearch->SearchValue)) {
                    $this->Zone->AdvancedSearch->SearchValue = implode(Config("FILTER_OPTION_SEPARATOR"), $this->Zone->AdvancedSearch->SearchValue);
                }
                $this->Zone->EditValue = explode(Config("FILTER_OPTION_SEPARATOR"), $this->Zone->AdvancedSearch->SearchValue);
            }

            // ChiefArea
            if ($this->ChiefArea->UseFilter && !EmptyValue($this->ChiefArea->AdvancedSearch->SearchValue)) {
                if (is_array($this->ChiefArea->AdvancedSearch->SearchValue)) {
                    $this->ChiefArea->AdvancedSearch->SearchValue = implode(Config("FILTER_OPTION_SEPARATOR"), $this->ChiefArea->AdvancedSearch->SearchValue);
                }
                $this->ChiefArea->EditValue = explode(Config("FILTER_OPTION_SEPARATOR"), $this->ChiefArea->AdvancedSearch->SearchValue);
            }

            // Date
            $this->Date->setupEditAttributes();
            if (!$this->Date->Raw) {
                $this->Date->AdvancedSearch->SearchValue = HtmlDecode($this->Date->AdvancedSearch->SearchValue);
            }
            $this->Date->EditValue = HtmlEncode($this->Date->AdvancedSearch->SearchValue);
            $this->Date->PlaceHolder = RemoveHtml($this->Date->caption());

            // Village
            if ($this->Village->UseFilter && !EmptyValue($this->Village->AdvancedSearch->SearchValue)) {
                if (is_array($this->Village->AdvancedSearch->SearchValue)) {
                    $this->Village->AdvancedSearch->SearchValue = implode(Config("FILTER_OPTION_SEPARATOR"), $this->Village->AdvancedSearch->SearchValue);
                }
                $this->Village->EditValue = explode(Config("FILTER_OPTION_SEPARATOR"), $this->Village->AdvancedSearch->SearchValue);
            }

            // NameOfFarmer
            if ($this->NameOfFarmer->UseFilter && !EmptyValue($this->NameOfFarmer->AdvancedSearch->SearchValue)) {
                if (is_array($this->NameOfFarmer->AdvancedSearch->SearchValue)) {
                    $this->NameOfFarmer->AdvancedSearch->SearchValue = implode(Config("FILTER_OPTION_SEPARATOR"), $this->NameOfFarmer->AdvancedSearch->SearchValue);
                }
                $this->NameOfFarmer->EditValue = explode(Config("FILTER_OPTION_SEPARATOR"), $this->NameOfFarmer->AdvancedSearch->SearchValue);
            }

            // YearOfBirth
            if ($this->YearOfBirth->UseFilter && !EmptyValue($this->YearOfBirth->AdvancedSearch->SearchValue)) {
                if (is_array($this->YearOfBirth->AdvancedSearch->SearchValue)) {
                    $this->YearOfBirth->AdvancedSearch->SearchValue = implode(Config("FILTER_OPTION_SEPARATOR"), $this->YearOfBirth->AdvancedSearch->SearchValue);
                }
                $this->YearOfBirth->EditValue = explode(Config("FILTER_OPTION_SEPARATOR"), $this->YearOfBirth->AdvancedSearch->SearchValue);
            }

            // Gender
            if ($this->Gender->UseFilter && !EmptyValue($this->Gender->AdvancedSearch->SearchValue)) {
                if (is_array($this->Gender->AdvancedSearch->SearchValue)) {
                    $this->Gender->AdvancedSearch->SearchValue = implode(Config("FILTER_OPTION_SEPARATOR"), $this->Gender->AdvancedSearch->SearchValue);
                }
                $this->Gender->EditValue = explode(Config("FILTER_OPTION_SEPARATOR"), $this->Gender->AdvancedSearch->SearchValue);
            }

            // NRC
            if ($this->NRC->UseFilter && !EmptyValue($this->NRC->AdvancedSearch->SearchValue)) {
                if (is_array($this->NRC->AdvancedSearch->SearchValue)) {
                    $this->NRC->AdvancedSearch->SearchValue = implode(Config("FILTER_OPTION_SEPARATOR"), $this->NRC->AdvancedSearch->SearchValue);
                }
                $this->NRC->EditValue = explode(Config("FILTER_OPTION_SEPARATOR"), $this->NRC->AdvancedSearch->SearchValue);
            }

            // SeedlingsReceived20_21
            $this->SeedlingsReceived20_21->setupEditAttributes();
            $this->SeedlingsReceived20_21->EditValue = $this->SeedlingsReceived20_21->AdvancedSearch->SearchValue;
            $this->SeedlingsReceived20_21->PlaceHolder = RemoveHtml($this->SeedlingsReceived20_21->caption());

            // FieldType
            if ($this->FieldType->UseFilter && !EmptyValue($this->FieldType->AdvancedSearch->SearchValue)) {
                if (is_array($this->FieldType->AdvancedSearch->SearchValue)) {
                    $this->FieldType->AdvancedSearch->SearchValue = implode(Config("FILTER_OPTION_SEPARATOR"), $this->FieldType->AdvancedSearch->SearchValue);
                }
                $this->FieldType->EditValue = explode(Config("FILTER_OPTION_SEPARATOR"), $this->FieldType->AdvancedSearch->SearchValue);
            }

            // Contact
            $this->Contact->setupEditAttributes();
            if (!$this->Contact->Raw) {
                $this->Contact->AdvancedSearch->SearchValue = HtmlDecode($this->Contact->AdvancedSearch->SearchValue);
            }
            $this->Contact->EditValue = HtmlEncode($this->Contact->AdvancedSearch->SearchValue);
            $this->Contact->PlaceHolder = RemoveHtml($this->Contact->caption());
        }

        // Call Row Rendered event
        if ($this->RowType != RowType::AGGREGATEINIT) {
            $this->rowRendered();
        }
    }

    // Validate search
    protected function validateSearch()
    {
        // Check if validation required
        if (!Config("SERVER_VALIDATE")) {
            return true;
        }

        // Return validate result
        $validateSearch = !$this->hasInvalidFields();

        // Call Form_CustomValidate event
        $formCustomError = "";
        $validateSearch = $validateSearch && $this->formCustomValidate($formCustomError);
        if ($formCustomError != "") {
            $this->setFailureMessage($formCustomError);
        }
        return $validateSearch;
    }

    /**
     * Import file
     *
     * @param string $filetoken File token to locate the uploaded import file
     * @param bool $rollback Try import and then rollback
     * @return bool
     */
    public function import($filetoken, $rollback = false)
    {
        global $Security, $Language;
        if (!$Security->canImport()) {
            return false; // Import not allowed
        }

        // Check if valid token
        if (EmptyValue($filetoken)) {
            return false;
        }

        // Get uploaded files by token
        $files = GetUploadedFileNames($filetoken);
        $exts = explode(",", Config("IMPORT_FILE_ALLOWED_EXTENSIONS"));
        $result = [Config("API_FILE_TOKEN_NAME") => $filetoken, "files" => []];

        // Set header
        if (ob_get_length()) {
            ob_clean();
        }
        header("Cache-Control: no-store");
        header("Content-Type: text/event-stream");

        // Import records
        try {
            foreach ($files as $file) {
                $res = ["file" => basename($file)];
                $ext = strtolower(pathinfo($file, PATHINFO_EXTENSION));

                // Ignore log file
                if ($ext == "txt") {
                    continue;
                }

                // Check file extension
                if (!in_array($ext, $exts)) {
                    $res = array_merge($res, ["error" => str_replace("%e", $ext, $Language->phrase("ImportInvalidFileExtension"))]);
                    SendEvent($res, "error");
                    return false;
                }

                // Set up options
                $options = [
                    "file" => $file,
                    "inputEncoding" => "", // For CSV only
                    "delimiter" => ",", // For CSV only
                    "enclosure" => "\"", // For CSV only
                    "escape" => "\\", // For CSV only
                    "activeSheet" => null, // For PhpSpreadsheet only
                    "readOnly" => true, // For PhpSpreadsheet only
                    "maxRows" => null, // For PhpSpreadsheet only
                    "headerRowNumber" => 0,
                    "headers" => [],
                    "offset" => 0,
                    "limit" => null,
                ];
                foreach ($_GET as $key => $value) {
                    if (!in_array($key, [Config("API_ACTION_NAME"), Config("API_FILE_TOKEN_NAME")])) {
                        $options[$key] = $value;
                    }
                }

                // Workflow builder
                $builder = fn($workflow) => $workflow;

                // Call Page Importing server event
                if (!$this->pageImporting($builder, $options)) {
                    SendEvent($res, "error");
                    return false;
                }

                // Set max execution time
                if (Config("IMPORT_MAX_EXECUTION_TIME") > 0) {
                    ini_set("max_execution_time", Config("IMPORT_MAX_EXECUTION_TIME"));
                }

                // Reader
                try {
                    if ($ext == "csv") {
                        $csv = file_get_contents($file);
                        if ($csv !== false) {
                            if (StartsString("\xEF\xBB\xBF", $csv)) { // UTF-8 BOM
                                $csv = substr($csv, 3);
                            } elseif ($options["inputEncoding"] != "" && !SameText($options["inputEncoding"], "UTF-8")) {
                                $csv = Convert($options["inputEncoding"], "UTF-8", $csv);
                            }
                            file_put_contents($file, $csv);
                        }
                        $reader = new \Port\Csv\CsvReader(new \SplFileObject($file), $options["delimiter"], $options["enclosure"], $options["escape"]);
                    } else {
                        $reader = new \Port\Spreadsheet\SpreadsheetReader(new \SplFileObject($file), $options["headerRowNumber"], $options["activeSheet"], $options["readOnly"], $options["maxRows"]);
                    }
                    if (is_array($options["headers"]) && count($options["headers"]) > 0) {
                        $reader->setColumnHeaders($options["headers"]);
                    } elseif (is_int($options["headerRowNumber"])) {
                        $reader->setHeaderRowNumber($options["headerRowNumber"]);
                    }
                } catch (\Exception $e) {
                    $res = array_merge($res, ["error" => $e->getMessage()]);
                    SendEvent($res, "error");
                    return false;
                }

                // Column headers
                $headers = $reader->getColumnHeaders();
                if (count($headers) == 0) { // Missing headers
                    $res["error"] = $Language->phrase("ImportNoHeaderRow");
                    SendEvent($res, "error");
                    return false;
                }

                // Counts
                $recordCnt = $reader->count();
                if ($options["offset"] > 0) {
                    $recordCnt -= $options["offset"];
                    if ($options["limit"] > 0) {
                        $recordCnt = min($recordCnt, $options["limit"]);
                    }
                    if ($recordCnt < 0) {
                        $recordCnt = 0;
                    }
                }
                $cnt = 0;
                $successCnt = 0;
                $failCnt = 0;
                $res = array_merge($res, ["totalCount" => $recordCnt, "count" => $cnt, "successCount" => 0, "failCount" => 0]);

                // Writer
                $writer = new \Port\Writer\CallbackWriter(function ($row) use (&$res, &$cnt, &$successCnt, &$failCnt) {
                    try {
                        $row = array_filter($row, fn($k) => $k !== "", ARRAY_FILTER_USE_KEY); // Remove fields without field name
                        $success = $this->importRow($row, ++$cnt); // Import row
                        $err = "";
                        if ($success) {
                            $successCnt++;
                        } else {
                            if (!EmptyValue($this->DbErrorMessage)) {
                                $err = $this->DbErrorMessage;
                                Log("import error for record " . $cnt . ": " . $err); // Log error to log file
                            }
                            $failCnt++;
                        }
                    } catch (\Port\Exception $e) { // Catch exception so the workflow continues
                        $failCnt++;
                        $err = $e->getMessage();
                        Log("import error for record " . $cnt . ": " . $err); // Log error to log file
                        if ($failCnt > $this->ImportMaxFailures) {
                            throw $e; // Throw \Port\Exception to terminate the workflow
                        }
                    } finally {
                        $res = array_merge($res, [
                            "row" => $row, // Current row
                            "success" => $success, // For current row
                            "error" => $err, // For current row
                            "count" => $cnt,
                            "successCount" => $successCnt,
                            "failCount" => $failCnt
                        ]);
                        $this->clearMessages();
                        SendEvent($res);
                    }
                });

                // Connection
                $conn = $this->getConnection();

                // Begin transaction
                if ($this->ImportUseTransaction) {
                    $conn->beginTransaction();
                }

                // Workflow
                $workflow = new \Port\Steps\StepAggregator($reader);
                $workflow->setLogger(Logger());
                $workflow->setSkipItemOnFailure(false); // Stop on exception
                $workflow = $builder($workflow);

                // Filter step
                $step = new \Port\Steps\Step\FilterStep();
                $step->add(new \Port\Filter\OffsetFilter($options["offset"], $options["limit"]));
                try {
                    $info = @$workflow->addWriter($writer)->addStep($step)->process();
                } finally {
                    // Rollback transaction
                    if ($this->ImportUseTransaction) {
                        if ($rollback || $failCnt > $this->ImportMaxFailures) {
                            if ($conn->isTransactionActive()) {
                                $res["rollbacked"] = $conn->rollback();
                            }
                        } else {
                            if ($conn->isTransactionActive()) {
                                $conn->commit();
                            }
                        }
                    }
                    unset($res["row"], $res["error"]); // Remove current row info
                    $res["success"] = $cnt > 0 && $failCnt <= $this->ImportMaxFailures; // Set success status of current file
                    SendEvent($res); // Current file imported
                    $result["files"][] = $res;

                    // Call Page Imported server event
                    if (($res["rollbacked"] ?? false) === false) { // Not rollbacked
                        $this->pageImported($info, $res);
                    }
                }
            }
        } finally {
            $result["failCount"] = array_reduce($result["files"], fn($carry, $item) => $carry + $item["failCount"], 0); // For client side
            $result["success"] = array_reduce($result["files"], fn($carry, $item) => $carry && $item["success"], true); // All files successful
            $result["rollbacked"] = array_reduce($result["files"], fn($carry, $item) => $carry && $item["success"] && ($item["rollbacked"] ?? false), true); // All file rollbacked successfully
            if ($result["success"] && !$result["rollbacked"]) {
                CleanUploadTempPaths($filetoken);
            }
            SendEvent($result, "complete"); // All files imported
            return $result["success"];
        }
    }

    /**
     * Import a row
     *
     * @param array $row Row to be imported
     * @param int $cnt Index of the row (1-based)
     * @return bool
     */
    protected function importRow(&$row, $cnt)
    {
        global $Language;

        // Call Row Import server event
        if (!$this->rowImport($row, $cnt)) {
            return false;
        }

        // Check field names and values
        foreach ($row as $name => $value) {
            $fld = $this->Fields[$name];
            if (!$fld) {
                throw new \Port\Exception\UnexpectedValueException(str_replace("%f", $name, $Language->phrase("ImportInvalidFieldName")));
            }
            if (!$this->checkValue($fld, $value)) {
                throw new \Port\Exception\UnexpectedValueException(str_replace(["%f", "%v"], [$name, $value], $Language->phrase("ImportInvalidFieldValue")));
            }
        }

        // Insert/Update to database
        $res = false;
        if (!$this->ImportInsertOnly && $oldrow = $this->load($row)) {
            if (!method_exists($this, "rowUpdating") || $this->rowUpdating($oldrow, $row)) {
                if ($res = $this->update($row, "", $oldrow)) {
                    if (method_exists($this, "rowUpdated")) {
                        $this->rowUpdated($oldrow, $row);
                    }
                }
            }
        } else {
            if (!method_exists($this, "rowInserting") || $this->rowInserting(null, $row)) {
                if ($res = $this->insert($row)) {
                    if (method_exists($this, "rowInserted")) {
                        $this->rowInserted(null, $row);
                    }
                }
            }
        }
        return $res;
    }

    /**
     * Check field value
     *
     * @param object $fld Field object
     * @param object $value
     * @return bool
     */
    protected function checkValue($fld, $value)
    {
        if ($fld->DataType == DataType::NUMBER && !is_numeric($value)) {
            return false;
        } elseif ($fld->DataType == DataType::DATE && !CheckDate($value, $fld->formatPattern())) {
            return false;
        }
        return true;
    }

    // Load row
    protected function load($row)
    {
        $filter = $this->getRecordFilter($row);
        if (!$filter) {
            return null;
        }
        $this->CurrentFilter = $filter;
        $sql = $this->getCurrentSql();
        $conn = $this->getConnection();
        return $conn->fetchAssociative($sql);
    }

    // Load advanced search
    public function loadAdvancedSearch()
    {
        $this->SerialNo->AdvancedSearch->load();
        $this->IPC->AdvancedSearch->load();
        $this->PageNo->AdvancedSearch->load();
        $this->Activity->AdvancedSearch->load();
        $this->District->AdvancedSearch->load();
        $this->Block->AdvancedSearch->load();
        $this->Camp->AdvancedSearch->load();
        $this->NurseryArea->AdvancedSearch->load();
        $this->Zone->AdvancedSearch->load();
        $this->ChiefArea->AdvancedSearch->load();
        $this->Date->AdvancedSearch->load();
        $this->Village->AdvancedSearch->load();
        $this->NameOfFarmer->AdvancedSearch->load();
        $this->YearOfBirth->AdvancedSearch->load();
        $this->Gender->AdvancedSearch->load();
        $this->NRC->AdvancedSearch->load();
        $this->SeedlingsReceived20_21->AdvancedSearch->load();
        $this->FieldType->AdvancedSearch->load();
        $this->Contact->AdvancedSearch->load();
    }

    // Get export HTML tag
    protected function getExportTag($type, $custom = false)
    {
        global $Language;
        if ($type == "print" || $custom) { // Printer friendly / custom export
            $pageUrl = $this->pageUrl(false);
            $exportUrl = GetUrl($pageUrl . "export=" . $type . ($custom ? "&amp;custom=1" : ""));
        } else { // Export API URL
            $exportUrl = GetApiUrl(Config("API_EXPORT_ACTION") . "/" . $type . "/" . $this->TableVar);
        }
        if (SameText($type, "excel")) {
            if ($custom) {
                return "<button type=\"button\" class=\"btn btn-default ew-export-link ew-excel\" title=\"" . HtmlEncode($Language->phrase("ExportToExcel", true)) . "\" data-caption=\"" . HtmlEncode($Language->phrase("ExportToExcel", true)) . "\" form=\"fseason20_21list\" data-url=\"$exportUrl\" data-ew-action=\"export\" data-export=\"excel\" data-custom=\"true\" data-export-selected=\"false\">" . $Language->phrase("ExportToExcel") . "</button>";
            } else {
                return "<a href=\"$exportUrl\" class=\"btn btn-default ew-export-link ew-excel\" title=\"" . HtmlEncode($Language->phrase("ExportToExcel", true)) . "\" data-caption=\"" . HtmlEncode($Language->phrase("ExportToExcel", true)) . "\">" . $Language->phrase("ExportToExcel") . "</a>";
            }
        } elseif (SameText($type, "word")) {
            if ($custom) {
                return "<button type=\"button\" class=\"btn btn-default ew-export-link ew-word\" title=\"" . HtmlEncode($Language->phrase("ExportToWord", true)) . "\" data-caption=\"" . HtmlEncode($Language->phrase("ExportToWord", true)) . "\" form=\"fseason20_21list\" data-url=\"$exportUrl\" data-ew-action=\"export\" data-export=\"word\" data-custom=\"true\" data-export-selected=\"false\">" . $Language->phrase("ExportToWord") . "</button>";
            } else {
                return "<a href=\"$exportUrl\" class=\"btn btn-default ew-export-link ew-word\" title=\"" . HtmlEncode($Language->phrase("ExportToWord", true)) . "\" data-caption=\"" . HtmlEncode($Language->phrase("ExportToWord", true)) . "\">" . $Language->phrase("ExportToWord") . "</a>";
            }
        } elseif (SameText($type, "pdf")) {
            if ($custom) {
                return "<button type=\"button\" class=\"btn btn-default ew-export-link ew-pdf\" title=\"" . HtmlEncode($Language->phrase("ExportToPdf", true)) . "\" data-caption=\"" . HtmlEncode($Language->phrase("ExportToPdf", true)) . "\" form=\"fseason20_21list\" data-url=\"$exportUrl\" data-ew-action=\"export\" data-export=\"pdf\" data-custom=\"true\" data-export-selected=\"false\">" . $Language->phrase("ExportToPdf") . "</button>";
            } else {
                return "<a href=\"$exportUrl\" class=\"btn btn-default ew-export-link ew-pdf\" title=\"" . HtmlEncode($Language->phrase("ExportToPdf", true)) . "\" data-caption=\"" . HtmlEncode($Language->phrase("ExportToPdf", true)) . "\">" . $Language->phrase("ExportToPdf") . "</a>";
            }
        } elseif (SameText($type, "html")) {
            return "<a href=\"$exportUrl\" class=\"btn btn-default ew-export-link ew-html\" title=\"" . HtmlEncode($Language->phrase("ExportToHtml", true)) . "\" data-caption=\"" . HtmlEncode($Language->phrase("ExportToHtml", true)) . "\">" . $Language->phrase("ExportToHtml") . "</a>";
        } elseif (SameText($type, "xml")) {
            return "<a href=\"$exportUrl\" class=\"btn btn-default ew-export-link ew-xml\" title=\"" . HtmlEncode($Language->phrase("ExportToXml", true)) . "\" data-caption=\"" . HtmlEncode($Language->phrase("ExportToXml", true)) . "\">" . $Language->phrase("ExportToXml") . "</a>";
        } elseif (SameText($type, "csv")) {
            return "<a href=\"$exportUrl\" class=\"btn btn-default ew-export-link ew-csv\" title=\"" . HtmlEncode($Language->phrase("ExportToCsv", true)) . "\" data-caption=\"" . HtmlEncode($Language->phrase("ExportToCsv", true)) . "\">" . $Language->phrase("ExportToCsv") . "</a>";
        } elseif (SameText($type, "email")) {
            $url = $custom ? ' data-url="' . $exportUrl . '"' : '';
            return '<button type="button" class="btn btn-default ew-export-link ew-email" title="' . $Language->phrase("ExportToEmail", true) . '" data-caption="' . $Language->phrase("ExportToEmail", true) . '" form="fseason20_21list" data-ew-action="email" data-custom="false" data-hdr="' . $Language->phrase("ExportToEmail", true) . '" data-exported-selected="false"' . $url . '>' . $Language->phrase("ExportToEmail") . '</button>';
        } elseif (SameText($type, "print")) {
            return "<a href=\"$exportUrl\" class=\"btn btn-default ew-export-link ew-print\" title=\"" . HtmlEncode($Language->phrase("PrinterFriendly", true)) . "\" data-caption=\"" . HtmlEncode($Language->phrase("PrinterFriendly", true)) . "\">" . $Language->phrase("PrinterFriendly") . "</a>";
        }
    }

    // Set up export options
    protected function setupExportOptions()
    {
        global $Language, $Security;

        // Printer friendly
        $item = &$this->ExportOptions->add("print");
        $item->Body = $this->getExportTag("print");
        $item->Visible = true;

        // Export to Excel
        $item = &$this->ExportOptions->add("excel");
        $item->Body = $this->getExportTag("excel");
        $item->Visible = true;

        // Export to Word
        $item = &$this->ExportOptions->add("word");
        $item->Body = $this->getExportTag("word");
        $item->Visible = true;

        // Export to HTML
        $item = &$this->ExportOptions->add("html");
        $item->Body = $this->getExportTag("html");
        $item->Visible = false;

        // Export to XML
        $item = &$this->ExportOptions->add("xml");
        $item->Body = $this->getExportTag("xml");
        $item->Visible = false;

        // Export to CSV
        $item = &$this->ExportOptions->add("csv");
        $item->Body = $this->getExportTag("csv");
        $item->Visible = true;

        // Export to PDF
        $item = &$this->ExportOptions->add("pdf");
        $item->Body = $this->getExportTag("pdf");
        $item->Visible = false;

        // Export to Email
        $item = &$this->ExportOptions->add("email");
        $item->Body = $this->getExportTag("email");
        $item->Visible = false;

        // Drop down button for export
        $this->ExportOptions->UseButtonGroup = true;
        $this->ExportOptions->UseDropDownButton = false;
        if ($this->ExportOptions->UseButtonGroup && IsMobile()) {
            $this->ExportOptions->UseDropDownButton = true;
        }
        $this->ExportOptions->DropDownButtonPhrase = $Language->phrase("ButtonExport");

        // Add group option item
        $item = &$this->ExportOptions->addGroupOption();
        $item->Body = "";
        $item->Visible = false;
        if (!$Security->canExport()) { // Export not allowed
            $this->ExportOptions->hideAllOptions();
        }
    }

    // Set up search options
    protected function setupSearchOptions()
    {
        global $Language, $Security;
        $pageUrl = $this->pageUrl(false);
        $this->SearchOptions = new ListOptions(TagClassName: "ew-search-option");

        // Search button
        $item = &$this->SearchOptions->add("searchtoggle");
        $searchToggleClass = ($this->SearchWhere != "") ? " active" : "";
        $item->Body = "<a class=\"btn btn-default ew-search-toggle" . $searchToggleClass . "\" role=\"button\" title=\"" . $Language->phrase("SearchPanel") . "\" data-caption=\"" . $Language->phrase("SearchPanel") . "\" data-ew-action=\"search-toggle\" data-form=\"fseason20_21srch\" aria-pressed=\"" . ($searchToggleClass == " active" ? "true" : "false") . "\">" . $Language->phrase("SearchLink") . "</a>";
        $item->Visible = true;

        // Show all button
        $item = &$this->SearchOptions->add("showall");
        if ($this->UseCustomTemplate || !$this->UseAjaxActions) {
            $item->Body = "<a class=\"btn btn-default ew-show-all\" role=\"button\" title=\"" . $Language->phrase("ShowAll") . "\" data-caption=\"" . $Language->phrase("ShowAll") . "\" href=\"" . $pageUrl . "cmd=reset\">" . $Language->phrase("ShowAllBtn") . "</a>";
        } else {
            $item->Body = "<a class=\"btn btn-default ew-show-all\" role=\"button\" title=\"" . $Language->phrase("ShowAll") . "\" data-caption=\"" . $Language->phrase("ShowAll") . "\" data-ew-action=\"refresh\" data-url=\"" . $pageUrl . "cmd=reset\">" . $Language->phrase("ShowAllBtn") . "</a>";
        }
        $item->Visible = ($this->SearchWhere != $this->DefaultSearchWhere && $this->SearchWhere != "0=101");

        // Advanced search button
        $item = &$this->SearchOptions->add("advancedsearch");
        if ($this->ModalSearch && !IsMobile()) {
            $item->Body = "<a class=\"btn btn-default ew-advanced-search\" title=\"" . $Language->phrase("AdvancedSearch", true) . "\" data-table=\"season20_21\" data-caption=\"" . $Language->phrase("AdvancedSearch", true) . "\" data-ew-action=\"modal\" data-url=\"Season2021Search\" data-btn=\"SearchBtn\">" . $Language->phrase("AdvancedSearch", false) . "</a>";
        } else {
            $item->Body = "<a class=\"btn btn-default ew-advanced-search\" title=\"" . $Language->phrase("AdvancedSearch", true) . "\" data-caption=\"" . $Language->phrase("AdvancedSearch", true) . "\" href=\"Season2021Search\">" . $Language->phrase("AdvancedSearch", false) . "</a>";
        }
        $item->Visible = true;

        // Query builder button
        $item = &$this->SearchOptions->add("querybuilder");
        if ($this->ModalSearch && !IsMobile()) {
            $item->Body = "<a class=\"btn btn-default ew-query-builder\" title=\"" . $Language->phrase("QueryBuilder", true) . "\" data-table=\"season20_21\" data-caption=\"" . $Language->phrase("QueryBuilder", true) . "\" data-ew-action=\"modal\" data-url=\"Season2021Query\" data-btn=\"SearchBtn\">" . $Language->phrase("QueryBuilder", false) . "</a>";
        } else {
            $item->Body = "<a class=\"btn btn-default ew-query-builder\" title=\"" . $Language->phrase("QueryBuilder", true) . "\" data-caption=\"" . $Language->phrase("QueryBuilder", true) . "\" href=\"Season2021Query\">" . $Language->phrase("QueryBuilder", false) . "</a>";
        }
        $item->Visible = true;

        // Search highlight button
        $item = &$this->SearchOptions->add("searchhighlight");
        $item->Body = "<a class=\"btn btn-default ew-highlight active\" role=\"button\" title=\"" . $Language->phrase("Highlight") . "\" data-caption=\"" . $Language->phrase("Highlight") . "\" data-ew-action=\"highlight\" data-form=\"fseason20_21srch\" data-name=\"" . $this->highlightName() . "\">" . $Language->phrase("HighlightBtn") . "</a>";
        $item->Visible = ($this->SearchWhere != "" && $this->TotalRecords > 0);

        // Button group for search
        $this->SearchOptions->UseDropDownButton = false;
        $this->SearchOptions->UseButtonGroup = true;
        $this->SearchOptions->DropDownButtonPhrase = $Language->phrase("ButtonSearch");

        // Add group option item
        $item = &$this->SearchOptions->addGroupOption();
        $item->Body = "";
        $item->Visible = false;

        // Hide search options
        if ($this->isExport() || $this->CurrentAction && $this->CurrentAction != "search") {
            $this->SearchOptions->hideAllOptions();
        }
        if (!$Security->canSearch()) {
            $this->SearchOptions->hideAllOptions();
            $this->FilterOptions->hideAllOptions();
        }
    }

    // Check if any search fields
    public function hasSearchFields()
    {
        return true;
    }

    // Render search options
    protected function renderSearchOptions()
    {
        if (!$this->hasSearchFields() && $this->SearchOptions["searchtoggle"]) {
            $this->SearchOptions["searchtoggle"]->Visible = false;
        }
    }

    // Set up import options
    protected function setupImportOptions()
    {
        global $Security, $Language;

        // Import
        $item = &$this->ImportOptions->add("import");
        $item->Body = "<a class=\"ew-import-link ew-import\" role=\"button\" title=\"" . $Language->phrase("Import", true) . "\" data-caption=\"" . $Language->phrase("Import", true) . "\" data-ew-action=\"import\" data-hdr=\"" . $Language->phrase("Import", true) . "\">" . $Language->phrase("Import") . "</a>";
        $item->Visible = $Security->canImport();
        $this->ImportOptions->UseButtonGroup = true;
        $this->ImportOptions->UseDropDownButton = false;
        $this->ImportOptions->DropDownButtonPhrase = $Language->phrase("Import");

        // Add group option item
        $item = &$this->ImportOptions->addGroupOption();
        $item->Body = "";
        $item->Visible = false;
    }

    /**
    * Export data in HTML/CSV/Word/Excel/XML/Email/PDF format
    *
    * @param bool $return Return the data rather than output it
    * @return mixed
    */
    public function exportData($doc)
    {
        global $Language;
        $rs = null;
        $this->TotalRecords = $this->listRecordCount();

        // Export all
        if ($this->ExportAll) {
            if (Config("EXPORT_ALL_TIME_LIMIT") >= 0) {
                @set_time_limit(Config("EXPORT_ALL_TIME_LIMIT"));
            }
            $this->DisplayRecords = $this->TotalRecords;
            $this->StopRecord = $this->TotalRecords;
        } else { // Export one page only
            $this->setupStartRecord(); // Set up start record position
            // Set the last record to display
            if ($this->DisplayRecords <= 0) {
                $this->StopRecord = $this->TotalRecords;
            } else {
                $this->StopRecord = $this->StartRecord + $this->DisplayRecords - 1;
            }
        }
        $rs = $this->loadRecordset($this->StartRecord - 1, $this->DisplayRecords <= 0 ? $this->TotalRecords : $this->DisplayRecords);
        if (!$rs || !$doc) {
            RemoveHeader("Content-Type"); // Remove header
            RemoveHeader("Content-Disposition");
            $this->showMessage();
            return;
        }
        $this->StartRecord = 1;
        $this->StopRecord = $this->DisplayRecords <= 0 ? $this->TotalRecords : $this->DisplayRecords;

        // Call Page Exporting server event
        $doc->ExportCustom = !$this->pageExporting($doc);

        // Page header
        $header = $this->PageHeader;
        $this->pageDataRendering($header);
        $doc->Text .= $header;
        $this->exportDocument($doc, $rs, $this->StartRecord, $this->StopRecord, "");
        $rs->free();

        // Page footer
        $footer = $this->PageFooter;
        $this->pageDataRendered($footer);
        $doc->Text .= $footer;

        // Export header and footer
        $doc->exportHeaderAndFooter();

        // Call Page Exported server event
        $this->pageExported($doc);
    }

    // Set up Breadcrumb
    protected function setupBreadcrumb()
    {
        global $Breadcrumb, $Language;
        $Breadcrumb = new Breadcrumb("index");
        $url = CurrentUrl();
        $url = preg_replace('/\?cmd=reset(all){0,1}$/i', '', $url); // Remove cmd=reset(all)
        $Breadcrumb->add("list", $this->TableVar, $url, "", $this->TableVar, true);
    }

    // Setup lookup options
    public function setupLookupOptions($fld)
    {
        if ($fld->Lookup && $fld->Lookup->Options === null) {
            // Get default connection and filter
            $conn = $this->getConnection();
            $lookupFilter = "";

            // No need to check any more
            $fld->Lookup->Options = [];

            // Set up lookup SQL and connection
            switch ($fld->FieldVar) {
                default:
                    $lookupFilter = "";
                    break;
            }

            // Always call to Lookup->getSql so that user can setup Lookup->Options in Lookup_Selecting server event
            $sql = $fld->Lookup->getSql(false, "", $lookupFilter, $this);

            // Set up lookup cache
            if (!$fld->hasLookupOptions() && $fld->UseLookupCache && $sql != "" && count($fld->Lookup->Options) == 0 && count($fld->Lookup->FilterFields) == 0) {
                $totalCnt = $this->getRecordCount($sql, $conn);
                if ($totalCnt > $fld->LookupCacheCount) { // Total count > cache count, do not cache
                    return;
                }
                $rows = $conn->executeQuery($sql)->fetchAll();
                $ar = [];
                foreach ($rows as $row) {
                    $row = $fld->Lookup->renderViewRow($row, Container($fld->Lookup->LinkTable));
                    $key = $row["lf"];
                    if (IsFloatType($fld->Type)) { // Handle float field
                        $key = (float)$key;
                    }
                    $ar[strval($key)] = $row;
                }
                $fld->Lookup->Options = $ar;
            }
        }
    }

    // Set up starting record parameters
    public function setupStartRecord()
    {
        if ($this->DisplayRecords == 0) {
            return;
        }
        $pageNo = Get(Config("TABLE_PAGE_NUMBER"));
        $startRec = Get(Config("TABLE_START_REC"));
        $infiniteScroll = ConvertToBool(Param("infinitescroll"));
        if ($pageNo !== null) { // Check for "pageno" parameter first
            $pageNo = ParseInteger($pageNo);
            if (is_numeric($pageNo)) {
                $this->StartRecord = ($pageNo - 1) * $this->DisplayRecords + 1;
                if ($this->StartRecord <= 0) {
                    $this->StartRecord = 1;
                } elseif ($this->StartRecord >= (int)(($this->TotalRecords - 1) / $this->DisplayRecords) * $this->DisplayRecords + 1) {
                    $this->StartRecord = (int)(($this->TotalRecords - 1) / $this->DisplayRecords) * $this->DisplayRecords + 1;
                }
            }
        } elseif ($startRec !== null && is_numeric($startRec)) { // Check for "start" parameter
            $this->StartRecord = $startRec;
        } elseif (!$infiniteScroll) {
            $this->StartRecord = $this->getStartRecordNumber();
        }

        // Check if correct start record counter
        if (!is_numeric($this->StartRecord) || intval($this->StartRecord) <= 0) { // Avoid invalid start record counter
            $this->StartRecord = 1; // Reset start record counter
        } elseif ($this->StartRecord > $this->TotalRecords) { // Avoid starting record > total records
            $this->StartRecord = (int)(($this->TotalRecords - 1) / $this->DisplayRecords) * $this->DisplayRecords + 1; // Point to last page first record
        } elseif (($this->StartRecord - 1) % $this->DisplayRecords != 0) {
            $this->StartRecord = (int)(($this->StartRecord - 1) / $this->DisplayRecords) * $this->DisplayRecords + 1; // Point to page boundary
        }
        if (!$infiniteScroll) {
            $this->setStartRecordNumber($this->StartRecord);
        }
    }

    // Get page count
    public function pageCount() {
        return ceil($this->TotalRecords / $this->DisplayRecords);
    }

    // Parse query builder rule
    protected function parseRules($group, $fieldName = "", $itemName = "") {
        $group["condition"] ??= "AND";
        if (!in_array($group["condition"], ["AND", "OR"])) {
            throw new \Exception("Unable to build SQL query with condition '" . $group["condition"] . "'");
        }
        if (!is_array($group["rules"] ?? null)) {
            return "";
        }
        $parts = [];
        foreach ($group["rules"] as $rule) {
            if (is_array($rule["rules"] ?? null) && count($rule["rules"]) > 0) {
                $part = $this->parseRules($rule, $fieldName, $itemName);
                if ($part) {
                    $parts[] = "(" . " " . $part . " " . ")" . " ";
                }
            } else {
                $field = $rule["field"];
                $fld = $this->fieldByParam($field);
                $dbid = $this->Dbid;
                if ($fld instanceof ReportField && is_array($fld->DashboardSearchSourceFields)) {
                    $item = $fld->DashboardSearchSourceFields[$itemName] ?? null;
                    if ($item) {
                        $tbl = Container($item["table"]);
                        $dbid = $tbl->Dbid;
                        $fld = $tbl->Fields[$item["field"]];
                    } else {
                        $fld = null;
                    }
                }
                if ($fld && ($fieldName == "" || $fld->Name == $fieldName)) { // Field name not specified or matched field name
                    $fldOpr = array_search($rule["operator"], Config("CLIENT_SEARCH_OPERATORS"));
                    $ope = Config("QUERY_BUILDER_OPERATORS")[$rule["operator"]] ?? null;
                    if (!$ope || !$fldOpr) {
                        throw new \Exception("Unknown SQL operation for operator '" . $rule["operator"] . "'");
                    }
                    if ($ope["nb_inputs"] > 0 && ($rule["value"] ?? false) || IsNullOrEmptyOperator($fldOpr)) {
                        $fldVal = $rule["value"];
                        if (is_array($fldVal)) {
                            $fldVal = $fld->isMultiSelect() ? implode(Config("MULTIPLE_OPTION_SEPARATOR"), $fldVal) : $fldVal[0];
                        }
                        $useFilter = $fld->UseFilter; // Query builder does not use filter
                        try {
                            if ($fld instanceof ReportField) { // Search report fields
                                if ($fld->SearchType == "dropdown") {
                                    if (is_array($fldVal)) {
                                        $sql = "";
                                        foreach ($fldVal as $val) {
                                            AddFilter($sql, DropDownFilter($fld, $val, $fldOpr, $dbid), "OR");
                                        }
                                        $parts[] = $sql;
                                    } else {
                                        $parts[] = DropDownFilter($fld, $fldVal, $fldOpr, $dbid);
                                    }
                                } else {
                                    $fld->AdvancedSearch->SearchOperator = $fldOpr;
                                    $fld->AdvancedSearch->SearchValue = $fldVal;
                                    $parts[] = GetReportFilter($fld, false, $dbid);
                                }
                            } else { // Search normal fields
                                if ($fld->isMultiSelect()) {
                                    $parts[] = $fldVal != "" ? GetMultiSearchSql($fld, $fldOpr, ConvertSearchValue($fldVal, $fldOpr, $fld), $this->Dbid) : "";
                                } else {
                                    $fldVal2 = ContainsString($fldOpr, "BETWEEN") ? $rule["value"][1] : ""; // BETWEEN
                                    if (is_array($fldVal2)) {
                                        $fldVal2 = implode(Config("MULTIPLE_OPTION_SEPARATOR"), $fldVal2);
                                    }
                                    $parts[] = GetSearchSql(
                                        $fld,
                                        ConvertSearchValue($fldVal, $fldOpr, $fld), // $fldVal
                                        $fldOpr,
                                        "", // $fldCond not used
                                        ConvertSearchValue($fldVal2, $fldOpr, $fld), // $fldVal2
                                        "", // $fldOpr2 not used
                                        $this->Dbid
                                    );
                                }
                            }
                        } finally {
                            $fld->UseFilter = $useFilter;
                        }
                    }
                }
            }
        }
        $where = "";
        foreach ($parts as $part) {
            AddFilter($where, $part, $group["condition"]);
        }
        if ($where && ($group["not"] ?? false)) {
            $where = "NOT (" . $where . ")";
        }
        return $where;
    }

    // Page Load event
    public function pageLoad()
    {
        //Log("Page Load");
    }

    // Page Unload event
    public function pageUnload()
    {
        //Log("Page Unload");
    }

    // Page Redirecting event
    public function pageRedirecting(&$url)
    {
        // Example:
        //$url = "your URL";
    }

    // Message Showing event
    // $type = ''|'success'|'failure'|'warning'
    public function messageShowing(&$msg, $type)
    {
        if ($type == "success") {
            //$msg = "your success message";
        } elseif ($type == "failure") {
            //$msg = "your failure message";
        } elseif ($type == "warning") {
            //$msg = "your warning message";
        } else {
            //$msg = "your message";
        }
    }

    // Page Render event
    public function pageRender()
    {
        //Log("Page Render");
    }

    // Page Data Rendering event
    public function pageDataRendering(&$header)
    {
        // Example:
        //$header = "your header";
    }

    // Page Data Rendered event
    public function pageDataRendered(&$footer)
    {
        // Example:
        //$footer = "your footer";
    }

    // Page Breaking event
    public function pageBreaking(&$break, &$content)
    {
        // Example:
        //$break = false; // Skip page break, or
        //$content = "<div style=\"break-after:page;\"></div>"; // Modify page break content
    }

    // Form Custom Validate event
    public function formCustomValidate(&$customError)
    {
        // Return error message in $customError
        return true;
    }

    // ListOptions Load event
    public function listOptionsLoad()
    {
        // Example:
        //$opt = &$this->ListOptions->add("new");
        //$opt->Header = "xxx";
        //$opt->OnLeft = true; // Link on left
        //$opt->moveTo(0); // Move to first column
    }

    // ListOptions Rendering event
    public function listOptionsRendering()
    {
        //Container("DetailTableGrid")->DetailAdd = (...condition...); // Set to true or false conditionally
        //Container("DetailTableGrid")->DetailEdit = (...condition...); // Set to true or false conditionally
        //Container("DetailTableGrid")->DetailView = (...condition...); // Set to true or false conditionally
    }

    // ListOptions Rendered event
    public function listOptionsRendered()
    {
        // Example:
        //$this->ListOptions["new"]->Body = "xxx";
    }

    // Row Custom Action event
    public function rowCustomAction($action, $row)
    {
        // Return false to abort
        return true;
    }

    // Page Exporting event
    // $doc = export object
    public function pageExporting(&$doc)
    {
        //$doc->Text = "my header"; // Export header
        //return false; // Return false to skip default export and use Row_Export event
        return true; // Return true to use default export and skip Row_Export event
    }

    // Row Export event
    // $doc = export document object
    public function rowExport($doc, $rs)
    {
        //$doc->Text .= "my content"; // Build HTML with field value: $rs["MyField"] or $this->MyField->ViewValue
    }

    // Page Exported event
    // $doc = export document object
    public function pageExported($doc)
    {
        //$doc->Text .= "my footer"; // Export footer
        //Log($doc->Text);
    }

    // Page Importing event
    public function pageImporting(&$builder, &$options)
    {
        //var_dump($options); // Show all options for importing
        //$builder = fn($workflow) => $workflow->addStep($myStep);
        //return false; // Return false to skip import
        return true;
    }

    // Row Import event
    public function rowImport(&$row, $cnt)
    {
        //Log($cnt); // Import record count
        //var_dump($row); // Import row
        //return false; // Return false to skip import
        return true;
    }

    // Page Imported event
    public function pageImported($obj, $results)
    {
        //var_dump($obj); // Workflow result object
        //var_dump($results); // Import results
    }
}
