<?php

namespace PHPMaker2024\cidp24\Entity;

use DateTime;
use DateTimeImmutable;
use DateInterval;
use Doctrine\ORM\Mapping\Column;
use Doctrine\ORM\Mapping\Entity;
use Doctrine\ORM\Mapping\GeneratedValue;
use Doctrine\ORM\Mapping\Id;
use Doctrine\ORM\Mapping\Table;
use Doctrine\ORM\Mapping\SequenceGenerator;
use Doctrine\DBAL\Types\Types;
use PHPMaker2024\cidp24\AbstractEntity;
use PHPMaker2024\cidp24\AdvancedSecurity;
use PHPMaker2024\cidp24\UserProfile;
use function PHPMaker2024\cidp24\Config;
use function PHPMaker2024\cidp24\EntityManager;
use function PHPMaker2024\cidp24\RemoveXss;
use function PHPMaker2024\cidp24\HtmlDecode;
use function PHPMaker2024\cidp24\EncryptPassword;

/**
 * Entity class for "yesno" table
 */
#[Entity]
#[Table(name: "yesno")]
class Yesno extends AbstractEntity
{
    public static array $propertyNames = [
        'ChoiceCode' => 'choiceCode',
        'YesNo' => 'yesNo',
    ];

    #[Id]
    #[Column(name: "ChoiceCode", type: "smallint")]
    private int $choiceCode;

    #[Id]
    #[Column(name: "YesNo", type: "string")]
    private string $yesNo = "N";

    public function __construct(int $choiceCode, string $yesNo)
    {
        $this->choiceCode = $choiceCode;
        $this->yesNo = $yesNo;
    }

    public function getChoiceCode(): int
    {
        return $this->choiceCode;
    }

    public function setChoiceCode(int $value): static
    {
        $this->choiceCode = $value;
        return $this;
    }

    public function getYesNo(): string
    {
        return $this->yesNo;
    }

    public function setYesNo(string $value): static
    {
        $this->yesNo = $value;
        return $this;
    }
}
