<?php

namespace PHPMaker2024\cidp24;

// Page object
$FarmOpenBalEdit = &$Page;
?>
<?php $Page->showPageHeader(); ?>
<?php
$Page->showMessage();
?>
<main class="edit">
<?php if (!$Page->IsModal) { ?>
<?= $Page->Pager->render() ?>
<?php } ?>
<form name="ffarm_open_baledit" id="ffarm_open_baledit" class="<?= $Page->FormClassName ?>" action="<?= CurrentPageUrl(false) ?>" method="post" autocomplete="off">
<script>
var currentTable = <?= JsonEncode($Page->toClientVar()) ?>;
ew.deepAssign(ew.vars, { tables: { farm_open_bal: currentTable } });
var currentPageID = ew.PAGE_ID = "edit";
var currentForm;
var ffarm_open_baledit;
loadjs.ready(["wrapper", "head"], function () {
    let $ = jQuery;
    let fields = currentTable.fields;

    // Form object
    let form = new ew.FormBuilder()
        .setId("ffarm_open_baledit")
        .setPageId("edit")

        // Add fields
        .setFields([
            ["ProvinceCode", [fields.ProvinceCode.visible && fields.ProvinceCode.required ? ew.Validators.required(fields.ProvinceCode.caption) : null], fields.ProvinceCode.isInvalid],
            ["DistrictCode", [fields.DistrictCode.visible && fields.DistrictCode.required ? ew.Validators.required(fields.DistrictCode.caption) : null], fields.DistrictCode.isInvalid],
            ["CampCode", [fields.CampCode.visible && fields.CampCode.required ? ew.Validators.required(fields.CampCode.caption) : null], fields.CampCode.isInvalid],
            ["VillageCode", [fields.VillageCode.visible && fields.VillageCode.required ? ew.Validators.required(fields.VillageCode.caption) : null, ew.Validators.integer], fields.VillageCode.isInvalid],
            ["NRC", [fields.NRC.visible && fields.NRC.required ? ew.Validators.required(fields.NRC.caption) : null], fields.NRC.isInvalid],
            ["FarmerNo", [fields.FarmerNo.visible && fields.FarmerNo.required ? ew.Validators.required(fields.FarmerNo.caption) : null, ew.Validators.integer], fields.FarmerNo.isInvalid],
            ["FarmNo", [fields.FarmNo.visible && fields.FarmNo.required ? ew.Validators.required(fields.FarmNo.caption) : null, ew.Validators.integer], fields.FarmNo.isInvalid],
            ["TransNo", [fields.TransNo.visible && fields.TransNo.required ? ew.Validators.required(fields.TransNo.caption) : null], fields.TransNo.isInvalid],
            ["TreesPlanted", [fields.TreesPlanted.visible && fields.TreesPlanted.required ? ew.Validators.required(fields.TreesPlanted.caption) : null, ew.Validators.float], fields.TreesPlanted.isInvalid],
            ["SeedType", [fields.SeedType.visible && fields.SeedType.required ? ew.Validators.required(fields.SeedType.caption) : null], fields.SeedType.isInvalid],
            ["SourcesOfSeedlings", [fields.SourcesOfSeedlings.visible && fields.SourcesOfSeedlings.required ? ew.Validators.required(fields.SourcesOfSeedlings.caption) : null], fields.SourcesOfSeedlings.isInvalid],
            ["InspectionReport", [fields.InspectionReport.visible && fields.InspectionReport.required ? ew.Validators.required(fields.InspectionReport.caption) : null], fields.InspectionReport.isInvalid],
            ["TransDate", [fields.TransDate.visible && fields.TransDate.required ? ew.Validators.required(fields.TransDate.caption) : null, ew.Validators.datetime(fields.TransDate.clientFormatPattern)], fields.TransDate.isInvalid],
            ["PreparedBy", [fields.PreparedBy.visible && fields.PreparedBy.required ? ew.Validators.required(fields.PreparedBy.caption) : null], fields.PreparedBy.isInvalid],
            ["AuthorisedBy", [fields.AuthorisedBy.visible && fields.AuthorisedBy.required ? ew.Validators.required(fields.AuthorisedBy.caption) : null], fields.AuthorisedBy.isInvalid]
        ])

        // Form_CustomValidate
        .setCustomValidate(
            function (fobj) { // DO NOT CHANGE THIS LINE! (except for adding "async" keyword)!
                    // Your custom validation code here, return false if invalid.
                    return true;
                }
        )

        // Use JavaScript validation or not
        .setValidateRequired(ew.CLIENT_VALIDATE)

        // Dynamic selection lists
        .setLists({
            "ProvinceCode": <?= $Page->ProvinceCode->toClientList($Page) ?>,
            "DistrictCode": <?= $Page->DistrictCode->toClientList($Page) ?>,
            "CampCode": <?= $Page->CampCode->toClientList($Page) ?>,
            "NRC": <?= $Page->NRC->toClientList($Page) ?>,
            "SeedType": <?= $Page->SeedType->toClientList($Page) ?>,
            "SourcesOfSeedlings": <?= $Page->SourcesOfSeedlings->toClientList($Page) ?>,
        })
        .build();
    window[form.id] = form;
    currentForm = form;
    loadjs.done(form.id);
});
</script>
<script>
loadjs.ready("head", function () {
    // Write your table-specific client script here, no need to add script tags.
});
</script>
<?php if (Config("CHECK_TOKEN")) { ?>
<input type="hidden" name="<?= $TokenNameKey ?>" value="<?= $TokenName ?>"><!-- CSRF token name -->
<input type="hidden" name="<?= $TokenValueKey ?>" value="<?= $TokenValue ?>"><!-- CSRF token value -->
<?php } ?>
<input type="hidden" name="t" value="farm_open_bal">
<input type="hidden" name="action" id="action" value="update">
<input type="hidden" name="modal" value="<?= (int)$Page->IsModal ?>">
<?php if (IsJsonResponse()) { ?>
<input type="hidden" name="json" value="1">
<?php } ?>
<input type="hidden" name="<?= $Page->OldKeyName ?>" value="<?= $Page->OldKey ?>">
<div class="ew-edit-div"><!-- page* -->
<?php if ($Page->ProvinceCode->Visible) { // ProvinceCode ?>
    <div id="r_ProvinceCode"<?= $Page->ProvinceCode->rowAttributes() ?>>
        <label id="elh_farm_open_bal_ProvinceCode" for="x_ProvinceCode" class="<?= $Page->LeftColumnClass ?>"><?= $Page->ProvinceCode->caption() ?><?= $Page->ProvinceCode->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->ProvinceCode->cellAttributes() ?>>
<span id="el_farm_open_bal_ProvinceCode">
    <select
        id="x_ProvinceCode"
        name="x_ProvinceCode"
        class="form-select ew-select<?= $Page->ProvinceCode->isInvalidClass() ?>"
        <?php if (!$Page->ProvinceCode->IsNativeSelect) { ?>
        data-select2-id="ffarm_open_baledit_x_ProvinceCode"
        <?php } ?>
        data-table="farm_open_bal"
        data-field="x_ProvinceCode"
        data-value-separator="<?= $Page->ProvinceCode->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->ProvinceCode->getPlaceHolder()) ?>"
        data-ew-action="update-options"
        <?= $Page->ProvinceCode->editAttributes() ?>>
        <?= $Page->ProvinceCode->selectOptionListHtml("x_ProvinceCode") ?>
    </select>
    <?= $Page->ProvinceCode->getCustomMessage() ?>
    <div class="invalid-feedback"><?= $Page->ProvinceCode->getErrorMessage() ?></div>
<?= $Page->ProvinceCode->Lookup->getParamTag($Page, "p_x_ProvinceCode") ?>
<?php if (!$Page->ProvinceCode->IsNativeSelect) { ?>
<script>
loadjs.ready("ffarm_open_baledit", function() {
    var options = { name: "x_ProvinceCode", selectId: "ffarm_open_baledit_x_ProvinceCode" },
        el = document.querySelector("select[data-select2-id='" + options.selectId + "']");
    if (!el)
        return;
    options.closeOnSelect = !options.multiple;
    options.dropdownParent = el.closest("#ew-modal-dialog, #ew-add-opt-dialog");
    if (ffarm_open_baledit.lists.ProvinceCode?.lookupOptions.length) {
        options.data = { id: "x_ProvinceCode", form: "ffarm_open_baledit" };
    } else {
        options.ajax = { id: "x_ProvinceCode", form: "ffarm_open_baledit", limit: ew.LOOKUP_PAGE_SIZE };
    }
    options.minimumResultsForSearch = Infinity;
    options = Object.assign({}, ew.selectOptions, options, ew.vars.tables.farm_open_bal.fields.ProvinceCode.selectOptions);
    ew.createSelect(options);
});
</script>
<?php } ?>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->DistrictCode->Visible) { // DistrictCode ?>
    <div id="r_DistrictCode"<?= $Page->DistrictCode->rowAttributes() ?>>
        <label id="elh_farm_open_bal_DistrictCode" for="x_DistrictCode" class="<?= $Page->LeftColumnClass ?>"><?= $Page->DistrictCode->caption() ?><?= $Page->DistrictCode->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->DistrictCode->cellAttributes() ?>>
<span id="el_farm_open_bal_DistrictCode">
    <select
        id="x_DistrictCode"
        name="x_DistrictCode"
        class="form-select ew-select<?= $Page->DistrictCode->isInvalidClass() ?>"
        <?php if (!$Page->DistrictCode->IsNativeSelect) { ?>
        data-select2-id="ffarm_open_baledit_x_DistrictCode"
        <?php } ?>
        data-table="farm_open_bal"
        data-field="x_DistrictCode"
        data-value-separator="<?= $Page->DistrictCode->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->DistrictCode->getPlaceHolder()) ?>"
        data-ew-action="update-options"
        <?= $Page->DistrictCode->editAttributes() ?>>
        <?= $Page->DistrictCode->selectOptionListHtml("x_DistrictCode") ?>
    </select>
    <?= $Page->DistrictCode->getCustomMessage() ?>
    <div class="invalid-feedback"><?= $Page->DistrictCode->getErrorMessage() ?></div>
<?= $Page->DistrictCode->Lookup->getParamTag($Page, "p_x_DistrictCode") ?>
<?php if (!$Page->DistrictCode->IsNativeSelect) { ?>
<script>
loadjs.ready("ffarm_open_baledit", function() {
    var options = { name: "x_DistrictCode", selectId: "ffarm_open_baledit_x_DistrictCode" },
        el = document.querySelector("select[data-select2-id='" + options.selectId + "']");
    if (!el)
        return;
    options.closeOnSelect = !options.multiple;
    options.dropdownParent = el.closest("#ew-modal-dialog, #ew-add-opt-dialog");
    if (ffarm_open_baledit.lists.DistrictCode?.lookupOptions.length) {
        options.data = { id: "x_DistrictCode", form: "ffarm_open_baledit" };
    } else {
        options.ajax = { id: "x_DistrictCode", form: "ffarm_open_baledit", limit: ew.LOOKUP_PAGE_SIZE };
    }
    options.minimumResultsForSearch = Infinity;
    options = Object.assign({}, ew.selectOptions, options, ew.vars.tables.farm_open_bal.fields.DistrictCode.selectOptions);
    ew.createSelect(options);
});
</script>
<?php } ?>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->CampCode->Visible) { // CampCode ?>
    <div id="r_CampCode"<?= $Page->CampCode->rowAttributes() ?>>
        <label id="elh_farm_open_bal_CampCode" for="x_CampCode" class="<?= $Page->LeftColumnClass ?>"><?= $Page->CampCode->caption() ?><?= $Page->CampCode->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->CampCode->cellAttributes() ?>>
<span id="el_farm_open_bal_CampCode">
    <select
        id="x_CampCode"
        name="x_CampCode"
        class="form-select ew-select<?= $Page->CampCode->isInvalidClass() ?>"
        <?php if (!$Page->CampCode->IsNativeSelect) { ?>
        data-select2-id="ffarm_open_baledit_x_CampCode"
        <?php } ?>
        data-table="farm_open_bal"
        data-field="x_CampCode"
        data-value-separator="<?= $Page->CampCode->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->CampCode->getPlaceHolder()) ?>"
        <?= $Page->CampCode->editAttributes() ?>>
        <?= $Page->CampCode->selectOptionListHtml("x_CampCode") ?>
    </select>
    <?= $Page->CampCode->getCustomMessage() ?>
    <div class="invalid-feedback"><?= $Page->CampCode->getErrorMessage() ?></div>
<?= $Page->CampCode->Lookup->getParamTag($Page, "p_x_CampCode") ?>
<?php if (!$Page->CampCode->IsNativeSelect) { ?>
<script>
loadjs.ready("ffarm_open_baledit", function() {
    var options = { name: "x_CampCode", selectId: "ffarm_open_baledit_x_CampCode" },
        el = document.querySelector("select[data-select2-id='" + options.selectId + "']");
    if (!el)
        return;
    options.closeOnSelect = !options.multiple;
    options.dropdownParent = el.closest("#ew-modal-dialog, #ew-add-opt-dialog");
    if (ffarm_open_baledit.lists.CampCode?.lookupOptions.length) {
        options.data = { id: "x_CampCode", form: "ffarm_open_baledit" };
    } else {
        options.ajax = { id: "x_CampCode", form: "ffarm_open_baledit", limit: ew.LOOKUP_PAGE_SIZE };
    }
    options.minimumResultsForSearch = Infinity;
    options = Object.assign({}, ew.selectOptions, options, ew.vars.tables.farm_open_bal.fields.CampCode.selectOptions);
    ew.createSelect(options);
});
</script>
<?php } ?>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->VillageCode->Visible) { // VillageCode ?>
    <div id="r_VillageCode"<?= $Page->VillageCode->rowAttributes() ?>>
        <label id="elh_farm_open_bal_VillageCode" for="x_VillageCode" class="<?= $Page->LeftColumnClass ?>"><?= $Page->VillageCode->caption() ?><?= $Page->VillageCode->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->VillageCode->cellAttributes() ?>>
<span id="el_farm_open_bal_VillageCode">
<input type="<?= $Page->VillageCode->getInputTextType() ?>" name="x_VillageCode" id="x_VillageCode" data-table="farm_open_bal" data-field="x_VillageCode" value="<?= $Page->VillageCode->EditValue ?>" size="30" placeholder="<?= HtmlEncode($Page->VillageCode->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->VillageCode->formatPattern()) ?>"<?= $Page->VillageCode->editAttributes() ?> aria-describedby="x_VillageCode_help">
<?= $Page->VillageCode->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->VillageCode->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->NRC->Visible) { // NRC ?>
    <div id="r_NRC"<?= $Page->NRC->rowAttributes() ?>>
        <label id="elh_farm_open_bal_NRC" class="<?= $Page->LeftColumnClass ?>"><?= $Page->NRC->caption() ?><?= $Page->NRC->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->NRC->cellAttributes() ?>>
<span id="el_farm_open_bal_NRC">
<?php
if (IsRTL()) {
    $Page->NRC->EditAttrs["dir"] = "rtl";
}
?>
<span id="as_x_NRC" class="ew-auto-suggest">
    <input type="<?= $Page->NRC->getInputTextType() ?>" class="form-control" name="sv_x_NRC" id="sv_x_NRC" value="<?= RemoveHtml($Page->NRC->EditValue) ?>" autocomplete="off" size="30" maxlength="255" placeholder="<?= HtmlEncode($Page->NRC->getPlaceHolder()) ?>" data-placeholder="<?= HtmlEncode($Page->NRC->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->NRC->formatPattern()) ?>"<?= $Page->NRC->editAttributes() ?> aria-describedby="x_NRC_help">
</span>
<selection-list hidden class="form-control" data-table="farm_open_bal" data-field="x_NRC" data-input="sv_x_NRC" data-value-separator="<?= $Page->NRC->displayValueSeparatorAttribute() ?>" name="x_NRC" id="x_NRC" value="<?= HtmlEncode($Page->NRC->CurrentValue) ?>"></selection-list>
<?= $Page->NRC->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->NRC->getErrorMessage() ?></div>
<script>
loadjs.ready("ffarm_open_baledit", function() {
    ffarm_open_baledit.createAutoSuggest(Object.assign({"id":"x_NRC","forceSelect":false}, { lookupAllDisplayFields: <?= $Page->NRC->Lookup->LookupAllDisplayFields ? "true" : "false" ?> }, ew.vars.tables.farm_open_bal.fields.NRC.autoSuggestOptions));
});
</script>
<?= $Page->NRC->Lookup->getParamTag($Page, "p_x_NRC") ?>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->FarmerNo->Visible) { // FarmerNo ?>
    <div id="r_FarmerNo"<?= $Page->FarmerNo->rowAttributes() ?>>
        <label id="elh_farm_open_bal_FarmerNo" for="x_FarmerNo" class="<?= $Page->LeftColumnClass ?>"><?= $Page->FarmerNo->caption() ?><?= $Page->FarmerNo->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->FarmerNo->cellAttributes() ?>>
<span id="el_farm_open_bal_FarmerNo">
<input type="<?= $Page->FarmerNo->getInputTextType() ?>" name="x_FarmerNo" id="x_FarmerNo" data-table="farm_open_bal" data-field="x_FarmerNo" value="<?= $Page->FarmerNo->EditValue ?>" size="30" placeholder="<?= HtmlEncode($Page->FarmerNo->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->FarmerNo->formatPattern()) ?>"<?= $Page->FarmerNo->editAttributes() ?> aria-describedby="x_FarmerNo_help">
<?= $Page->FarmerNo->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->FarmerNo->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->FarmNo->Visible) { // FarmNo ?>
    <div id="r_FarmNo"<?= $Page->FarmNo->rowAttributes() ?>>
        <label id="elh_farm_open_bal_FarmNo" for="x_FarmNo" class="<?= $Page->LeftColumnClass ?>"><?= $Page->FarmNo->caption() ?><?= $Page->FarmNo->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->FarmNo->cellAttributes() ?>>
<span id="el_farm_open_bal_FarmNo">
<input type="<?= $Page->FarmNo->getInputTextType() ?>" name="x_FarmNo" id="x_FarmNo" data-table="farm_open_bal" data-field="x_FarmNo" value="<?= $Page->FarmNo->EditValue ?>" size="30" placeholder="<?= HtmlEncode($Page->FarmNo->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->FarmNo->formatPattern()) ?>"<?= $Page->FarmNo->editAttributes() ?> aria-describedby="x_FarmNo_help">
<?= $Page->FarmNo->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->FarmNo->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->TransNo->Visible) { // TransNo ?>
    <div id="r_TransNo"<?= $Page->TransNo->rowAttributes() ?>>
        <label id="elh_farm_open_bal_TransNo" class="<?= $Page->LeftColumnClass ?>"><?= $Page->TransNo->caption() ?><?= $Page->TransNo->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->TransNo->cellAttributes() ?>>
<span id="el_farm_open_bal_TransNo">
<span<?= $Page->TransNo->viewAttributes() ?>>
<input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Page->TransNo->getDisplayValue($Page->TransNo->EditValue))) ?>"></span>
<input type="hidden" data-table="farm_open_bal" data-field="x_TransNo" data-hidden="1" name="x_TransNo" id="x_TransNo" value="<?= HtmlEncode($Page->TransNo->CurrentValue) ?>">
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->TreesPlanted->Visible) { // TreesPlanted ?>
    <div id="r_TreesPlanted"<?= $Page->TreesPlanted->rowAttributes() ?>>
        <label id="elh_farm_open_bal_TreesPlanted" for="x_TreesPlanted" class="<?= $Page->LeftColumnClass ?>"><?= $Page->TreesPlanted->caption() ?><?= $Page->TreesPlanted->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->TreesPlanted->cellAttributes() ?>>
<span id="el_farm_open_bal_TreesPlanted">
<input type="<?= $Page->TreesPlanted->getInputTextType() ?>" name="x_TreesPlanted" id="x_TreesPlanted" data-table="farm_open_bal" data-field="x_TreesPlanted" value="<?= $Page->TreesPlanted->EditValue ?>" size="30" placeholder="<?= HtmlEncode($Page->TreesPlanted->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->TreesPlanted->formatPattern()) ?>"<?= $Page->TreesPlanted->editAttributes() ?> aria-describedby="x_TreesPlanted_help">
<?= $Page->TreesPlanted->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->TreesPlanted->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->SeedType->Visible) { // SeedType ?>
    <div id="r_SeedType"<?= $Page->SeedType->rowAttributes() ?>>
        <label id="elh_farm_open_bal_SeedType" for="x_SeedType" class="<?= $Page->LeftColumnClass ?>"><?= $Page->SeedType->caption() ?><?= $Page->SeedType->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->SeedType->cellAttributes() ?>>
<span id="el_farm_open_bal_SeedType">
    <select
        id="x_SeedType"
        name="x_SeedType"
        class="form-select ew-select<?= $Page->SeedType->isInvalidClass() ?>"
        <?php if (!$Page->SeedType->IsNativeSelect) { ?>
        data-select2-id="ffarm_open_baledit_x_SeedType"
        <?php } ?>
        data-table="farm_open_bal"
        data-field="x_SeedType"
        data-value-separator="<?= $Page->SeedType->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->SeedType->getPlaceHolder()) ?>"
        <?= $Page->SeedType->editAttributes() ?>>
        <?= $Page->SeedType->selectOptionListHtml("x_SeedType") ?>
    </select>
    <?= $Page->SeedType->getCustomMessage() ?>
    <div class="invalid-feedback"><?= $Page->SeedType->getErrorMessage() ?></div>
<?= $Page->SeedType->Lookup->getParamTag($Page, "p_x_SeedType") ?>
<?php if (!$Page->SeedType->IsNativeSelect) { ?>
<script>
loadjs.ready("ffarm_open_baledit", function() {
    var options = { name: "x_SeedType", selectId: "ffarm_open_baledit_x_SeedType" },
        el = document.querySelector("select[data-select2-id='" + options.selectId + "']");
    if (!el)
        return;
    options.closeOnSelect = !options.multiple;
    options.dropdownParent = el.closest("#ew-modal-dialog, #ew-add-opt-dialog");
    if (ffarm_open_baledit.lists.SeedType?.lookupOptions.length) {
        options.data = { id: "x_SeedType", form: "ffarm_open_baledit" };
    } else {
        options.ajax = { id: "x_SeedType", form: "ffarm_open_baledit", limit: ew.LOOKUP_PAGE_SIZE };
    }
    options.minimumResultsForSearch = Infinity;
    options = Object.assign({}, ew.selectOptions, options, ew.vars.tables.farm_open_bal.fields.SeedType.selectOptions);
    ew.createSelect(options);
});
</script>
<?php } ?>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->SourcesOfSeedlings->Visible) { // SourcesOfSeedlings ?>
    <div id="r_SourcesOfSeedlings"<?= $Page->SourcesOfSeedlings->rowAttributes() ?>>
        <label id="elh_farm_open_bal_SourcesOfSeedlings" for="x_SourcesOfSeedlings" class="<?= $Page->LeftColumnClass ?>"><?= $Page->SourcesOfSeedlings->caption() ?><?= $Page->SourcesOfSeedlings->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->SourcesOfSeedlings->cellAttributes() ?>>
<span id="el_farm_open_bal_SourcesOfSeedlings">
    <select
        id="x_SourcesOfSeedlings"
        name="x_SourcesOfSeedlings"
        class="form-select ew-select<?= $Page->SourcesOfSeedlings->isInvalidClass() ?>"
        <?php if (!$Page->SourcesOfSeedlings->IsNativeSelect) { ?>
        data-select2-id="ffarm_open_baledit_x_SourcesOfSeedlings"
        <?php } ?>
        data-table="farm_open_bal"
        data-field="x_SourcesOfSeedlings"
        data-value-separator="<?= $Page->SourcesOfSeedlings->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->SourcesOfSeedlings->getPlaceHolder()) ?>"
        <?= $Page->SourcesOfSeedlings->editAttributes() ?>>
        <?= $Page->SourcesOfSeedlings->selectOptionListHtml("x_SourcesOfSeedlings") ?>
    </select>
    <?= $Page->SourcesOfSeedlings->getCustomMessage() ?>
    <div class="invalid-feedback"><?= $Page->SourcesOfSeedlings->getErrorMessage() ?></div>
<?= $Page->SourcesOfSeedlings->Lookup->getParamTag($Page, "p_x_SourcesOfSeedlings") ?>
<?php if (!$Page->SourcesOfSeedlings->IsNativeSelect) { ?>
<script>
loadjs.ready("ffarm_open_baledit", function() {
    var options = { name: "x_SourcesOfSeedlings", selectId: "ffarm_open_baledit_x_SourcesOfSeedlings" },
        el = document.querySelector("select[data-select2-id='" + options.selectId + "']");
    if (!el)
        return;
    options.closeOnSelect = !options.multiple;
    options.dropdownParent = el.closest("#ew-modal-dialog, #ew-add-opt-dialog");
    if (ffarm_open_baledit.lists.SourcesOfSeedlings?.lookupOptions.length) {
        options.data = { id: "x_SourcesOfSeedlings", form: "ffarm_open_baledit" };
    } else {
        options.ajax = { id: "x_SourcesOfSeedlings", form: "ffarm_open_baledit", limit: ew.LOOKUP_PAGE_SIZE };
    }
    options.minimumResultsForSearch = Infinity;
    options = Object.assign({}, ew.selectOptions, options, ew.vars.tables.farm_open_bal.fields.SourcesOfSeedlings.selectOptions);
    ew.createSelect(options);
});
</script>
<?php } ?>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->InspectionReport->Visible) { // InspectionReport ?>
    <div id="r_InspectionReport"<?= $Page->InspectionReport->rowAttributes() ?>>
        <label id="elh_farm_open_bal_InspectionReport" for="x_InspectionReport" class="<?= $Page->LeftColumnClass ?>"><?= $Page->InspectionReport->caption() ?><?= $Page->InspectionReport->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->InspectionReport->cellAttributes() ?>>
<span id="el_farm_open_bal_InspectionReport">
<textarea data-table="farm_open_bal" data-field="x_InspectionReport" name="x_InspectionReport" id="x_InspectionReport" cols="35" rows="4" placeholder="<?= HtmlEncode($Page->InspectionReport->getPlaceHolder()) ?>"<?= $Page->InspectionReport->editAttributes() ?> aria-describedby="x_InspectionReport_help"><?= $Page->InspectionReport->EditValue ?></textarea>
<?= $Page->InspectionReport->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->InspectionReport->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->TransDate->Visible) { // TransDate ?>
    <div id="r_TransDate"<?= $Page->TransDate->rowAttributes() ?>>
        <label id="elh_farm_open_bal_TransDate" for="x_TransDate" class="<?= $Page->LeftColumnClass ?>"><?= $Page->TransDate->caption() ?><?= $Page->TransDate->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->TransDate->cellAttributes() ?>>
<span id="el_farm_open_bal_TransDate">
<input type="<?= $Page->TransDate->getInputTextType() ?>" name="x_TransDate" id="x_TransDate" data-table="farm_open_bal" data-field="x_TransDate" value="<?= $Page->TransDate->EditValue ?>" placeholder="<?= HtmlEncode($Page->TransDate->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->TransDate->formatPattern()) ?>"<?= $Page->TransDate->editAttributes() ?> aria-describedby="x_TransDate_help">
<?= $Page->TransDate->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->TransDate->getErrorMessage() ?></div>
<?php if (!$Page->TransDate->ReadOnly && !$Page->TransDate->Disabled && !isset($Page->TransDate->EditAttrs["readonly"]) && !isset($Page->TransDate->EditAttrs["disabled"])) { ?>
<script>
loadjs.ready(["ffarm_open_baledit", "datetimepicker"], function () {
    let format = "<?= DateFormat(0) ?>",
        options = {
            localization: {
                locale: ew.LANGUAGE_ID + "-u-nu-" + ew.getNumberingSystem(),
                hourCycle: format.match(/H/) ? "h24" : "h12",
                format,
                ...ew.language.phrase("datetimepicker")
            },
            display: {
                icons: {
                    previous: ew.IS_RTL ? "fa-solid fa-chevron-right" : "fa-solid fa-chevron-left",
                    next: ew.IS_RTL ? "fa-solid fa-chevron-left" : "fa-solid fa-chevron-right"
                },
                components: {
                    hours: !!format.match(/h/i),
                    minutes: !!format.match(/m/),
                    seconds: !!format.match(/s/i)
                },
                theme: ew.getPreferredTheme()
            }
        };
    ew.createDateTimePicker("ffarm_open_baledit", "x_TransDate", ew.deepAssign({"useCurrent":false,"display":{"sideBySide":false}}, options));
});
</script>
<?php } ?>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->PreparedBy->Visible) { // PreparedBy ?>
    <div id="r_PreparedBy"<?= $Page->PreparedBy->rowAttributes() ?>>
        <label id="elh_farm_open_bal_PreparedBy" for="x_PreparedBy" class="<?= $Page->LeftColumnClass ?>"><?= $Page->PreparedBy->caption() ?><?= $Page->PreparedBy->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->PreparedBy->cellAttributes() ?>>
<span id="el_farm_open_bal_PreparedBy">
<input type="<?= $Page->PreparedBy->getInputTextType() ?>" name="x_PreparedBy" id="x_PreparedBy" data-table="farm_open_bal" data-field="x_PreparedBy" value="<?= $Page->PreparedBy->EditValue ?>" size="30" maxlength="255" placeholder="<?= HtmlEncode($Page->PreparedBy->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->PreparedBy->formatPattern()) ?>"<?= $Page->PreparedBy->editAttributes() ?> aria-describedby="x_PreparedBy_help">
<?= $Page->PreparedBy->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->PreparedBy->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->AuthorisedBy->Visible) { // AuthorisedBy ?>
    <div id="r_AuthorisedBy"<?= $Page->AuthorisedBy->rowAttributes() ?>>
        <label id="elh_farm_open_bal_AuthorisedBy" for="x_AuthorisedBy" class="<?= $Page->LeftColumnClass ?>"><?= $Page->AuthorisedBy->caption() ?><?= $Page->AuthorisedBy->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div<?= $Page->AuthorisedBy->cellAttributes() ?>>
<span id="el_farm_open_bal_AuthorisedBy">
<input type="<?= $Page->AuthorisedBy->getInputTextType() ?>" name="x_AuthorisedBy" id="x_AuthorisedBy" data-table="farm_open_bal" data-field="x_AuthorisedBy" value="<?= $Page->AuthorisedBy->EditValue ?>" size="30" maxlength="255" placeholder="<?= HtmlEncode($Page->AuthorisedBy->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->AuthorisedBy->formatPattern()) ?>"<?= $Page->AuthorisedBy->editAttributes() ?> aria-describedby="x_AuthorisedBy_help">
<?= $Page->AuthorisedBy->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->AuthorisedBy->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
</div><!-- /page* -->
<?= $Page->IsModal ? '<template class="ew-modal-buttons">' : '<div class="row ew-buttons">' ?><!-- buttons .row -->
    <div class="<?= $Page->OffsetColumnClass ?>"><!-- buttons offset -->
<button class="btn btn-primary ew-btn" name="btn-action" id="btn-action" type="submit" form="ffarm_open_baledit"><?= $Language->phrase("SaveBtn") ?></button>
<?php if (IsJsonResponse()) { ?>
<button class="btn btn-default ew-btn" name="btn-cancel" id="btn-cancel" type="button" data-bs-dismiss="modal"><?= $Language->phrase("CancelBtn") ?></button>
<?php } else { ?>
<button class="btn btn-default ew-btn" name="btn-cancel" id="btn-cancel" type="button" form="ffarm_open_baledit" data-href="<?= HtmlEncode(GetUrl($Page->getReturnUrl())) ?>"><?= $Language->phrase("CancelBtn") ?></button>
<?php } ?>
    </div><!-- /buttons offset -->
<?= $Page->IsModal ? "</template>" : "</div>" ?><!-- /buttons .row -->
</form>
<?php if (!$Page->IsModal) { ?>
<?= $Page->Pager->render() ?>
<?php } ?>
</main>
<?php
$Page->showPageFooter();
echo GetDebugMessage();
?>
<script>
// Field event handlers
loadjs.ready("head", function() {
    ew.addEventHandlers("farm_open_bal");
});
</script>
<script>
loadjs.ready("load", function () {
    // Write your table-specific startup script here, no need to add script tags.
});
</script>
