<?php

namespace PHPMaker2024\cidp24;

// Page object
$FarmSeedDeliveredSearch = &$Page;
?>
<script>
var currentTable = <?= JsonEncode($Page->toClientVar()) ?>;
ew.deepAssign(ew.vars, { tables: { farm_seed_delivered: currentTable } });
var currentPageID = ew.PAGE_ID = "search";
var currentForm;
var ffarm_seed_deliveredsearch, currentSearchForm, currentAdvancedSearchForm;
loadjs.ready(["wrapper", "head"], function () {
    let $ = jQuery,
        fields = currentTable.fields;

    // Form object for search
    let form = new ew.FormBuilder()
        .setId("ffarm_seed_deliveredsearch")
        .setPageId("search")
<?php if ($Page->IsModal && $Page->UseAjaxActions) { ?>
        .setSubmitWithFetch(true)
<?php } ?>

        // Add fields
        .addFields([
            ["ProvinceCode", [], fields.ProvinceCode.isInvalid],
            ["DistrictCode", [], fields.DistrictCode.isInvalid],
            ["CampCode", [], fields.CampCode.isInvalid],
            ["VillageCode", [], fields.VillageCode.isInvalid],
            ["NRC", [], fields.NRC.isInvalid],
            ["FarmerNo", [ew.Validators.integer], fields.FarmerNo.isInvalid],
            ["FarmNo", [ew.Validators.integer], fields.FarmNo.isInvalid],
            ["TransDeliveryNo", [ew.Validators.integer], fields.TransDeliveryNo.isInvalid],
            ["TreesDelivered", [ew.Validators.float], fields.TreesDelivered.isInvalid],
            ["SeedType", [], fields.SeedType.isInvalid],
            ["SourcesOfSeedlings", [], fields.SourcesOfSeedlings.isInvalid],
            ["DeliveryDate", [ew.Validators.datetime(fields.DeliveryDate.clientFormatPattern)], fields.DeliveryDate.isInvalid],
            ["PreparedBy", [], fields.PreparedBy.isInvalid],
            ["AuthorisedBy", [], fields.AuthorisedBy.isInvalid],
            ["BatchNo", [], fields.BatchNo.isInvalid]
        ])
        // Validate form
        .setValidate(
            async function () {
                if (!this.validateRequired)
                    return true; // Ignore validation
                let fobj = this.getForm();

                // Validate fields
                if (!this.validateFields())
                    return false;

                // Call Form_CustomValidate event
                if (!(await this.customValidate?.(fobj) ?? true)) {
                    this.focus();
                    return false;
                }
                return true;
            }
        )

        // Form_CustomValidate
        .setCustomValidate(
            function (fobj) { // DO NOT CHANGE THIS LINE! (except for adding "async" keyword)!
                    // Your custom validation code here, return false if invalid.
                    return true;
                }
        )

        // Use JavaScript validation or not
        .setValidateRequired(ew.CLIENT_VALIDATE)

        // Dynamic selection lists
        .setLists({
            "ProvinceCode": <?= $Page->ProvinceCode->toClientList($Page) ?>,
            "DistrictCode": <?= $Page->DistrictCode->toClientList($Page) ?>,
            "CampCode": <?= $Page->CampCode->toClientList($Page) ?>,
            "VillageCode": <?= $Page->VillageCode->toClientList($Page) ?>,
            "NRC": <?= $Page->NRC->toClientList($Page) ?>,
            "SeedType": <?= $Page->SeedType->toClientList($Page) ?>,
            "SourcesOfSeedlings": <?= $Page->SourcesOfSeedlings->toClientList($Page) ?>,
        })
        .build();
    window[form.id] = form;
<?php if ($Page->IsModal) { ?>
    currentAdvancedSearchForm = form;
<?php } else { ?>
    currentForm = form;
<?php } ?>
    loadjs.done(form.id);
});
</script>
<script>
loadjs.ready("head", function () {
    // Write your table-specific client script here, no need to add script tags.
});
</script>
<?php $Page->showPageHeader(); ?>
<?php
$Page->showMessage();
?>
<form name="ffarm_seed_deliveredsearch" id="ffarm_seed_deliveredsearch" class="<?= $Page->FormClassName ?>" action="<?= CurrentPageUrl(false) ?>" method="post" autocomplete="off">
<?php if (Config("CHECK_TOKEN")) { ?>
<input type="hidden" name="<?= $TokenNameKey ?>" value="<?= $TokenName ?>"><!-- CSRF token name -->
<input type="hidden" name="<?= $TokenValueKey ?>" value="<?= $TokenValue ?>"><!-- CSRF token value -->
<?php } ?>
<input type="hidden" name="t" value="farm_seed_delivered">
<input type="hidden" name="action" id="action" value="search">
<?php if ($Page->IsModal) { ?>
<input type="hidden" name="modal" value="1">
<?php } ?>
<div class="ew-search-div"><!-- page* -->
<?php if ($Page->ProvinceCode->Visible) { // ProvinceCode ?>
    <div id="r_ProvinceCode" class="row"<?= $Page->ProvinceCode->rowAttributes() ?>>
        <label for="x_ProvinceCode" class="<?= $Page->LeftColumnClass ?>"><span id="elh_farm_seed_delivered_ProvinceCode"><?= $Page->ProvinceCode->caption() ?></span>
        <span class="ew-search-operator">
<?= $Language->phrase("=") ?>
<input type="hidden" name="z_ProvinceCode" id="z_ProvinceCode" value="=">
</span>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div<?= $Page->ProvinceCode->cellAttributes() ?>>
                <div class="d-flex align-items-start">
                <span id="el_farm_seed_delivered_ProvinceCode" class="ew-search-field ew-search-field-single">
    <select
        id="x_ProvinceCode"
        name="x_ProvinceCode"
        class="form-select ew-select<?= $Page->ProvinceCode->isInvalidClass() ?>"
        <?php if (!$Page->ProvinceCode->IsNativeSelect) { ?>
        data-select2-id="ffarm_seed_deliveredsearch_x_ProvinceCode"
        <?php } ?>
        data-table="farm_seed_delivered"
        data-field="x_ProvinceCode"
        data-value-separator="<?= $Page->ProvinceCode->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->ProvinceCode->getPlaceHolder()) ?>"
        data-ew-action="update-options"
        <?= $Page->ProvinceCode->editAttributes() ?>>
        <?= $Page->ProvinceCode->selectOptionListHtml("x_ProvinceCode") ?>
    </select>
    <div class="invalid-feedback"><?= $Page->ProvinceCode->getErrorMessage(false) ?></div>
<?= $Page->ProvinceCode->Lookup->getParamTag($Page, "p_x_ProvinceCode") ?>
<?php if (!$Page->ProvinceCode->IsNativeSelect) { ?>
<script>
loadjs.ready("ffarm_seed_deliveredsearch", function() {
    var options = { name: "x_ProvinceCode", selectId: "ffarm_seed_deliveredsearch_x_ProvinceCode" },
        el = document.querySelector("select[data-select2-id='" + options.selectId + "']");
    if (!el)
        return;
    options.closeOnSelect = !options.multiple;
    options.dropdownParent = el.closest("#ew-modal-dialog, #ew-add-opt-dialog");
    if (ffarm_seed_deliveredsearch.lists.ProvinceCode?.lookupOptions.length) {
        options.data = { id: "x_ProvinceCode", form: "ffarm_seed_deliveredsearch" };
    } else {
        options.ajax = { id: "x_ProvinceCode", form: "ffarm_seed_deliveredsearch", limit: ew.LOOKUP_PAGE_SIZE };
    }
    options.minimumResultsForSearch = Infinity;
    options = Object.assign({}, ew.selectOptions, options, ew.vars.tables.farm_seed_delivered.fields.ProvinceCode.selectOptions);
    ew.createSelect(options);
});
</script>
<?php } ?>
</span>
                </div>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->DistrictCode->Visible) { // DistrictCode ?>
    <div id="r_DistrictCode" class="row"<?= $Page->DistrictCode->rowAttributes() ?>>
        <label for="x_DistrictCode" class="<?= $Page->LeftColumnClass ?>"><span id="elh_farm_seed_delivered_DistrictCode"><?= $Page->DistrictCode->caption() ?></span>
        <span class="ew-search-operator">
<?= $Language->phrase("=") ?>
<input type="hidden" name="z_DistrictCode" id="z_DistrictCode" value="=">
</span>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div<?= $Page->DistrictCode->cellAttributes() ?>>
                <div class="d-flex align-items-start">
                <span id="el_farm_seed_delivered_DistrictCode" class="ew-search-field ew-search-field-single">
    <select
        id="x_DistrictCode"
        name="x_DistrictCode"
        class="form-select ew-select<?= $Page->DistrictCode->isInvalidClass() ?>"
        <?php if (!$Page->DistrictCode->IsNativeSelect) { ?>
        data-select2-id="ffarm_seed_deliveredsearch_x_DistrictCode"
        <?php } ?>
        data-table="farm_seed_delivered"
        data-field="x_DistrictCode"
        data-value-separator="<?= $Page->DistrictCode->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->DistrictCode->getPlaceHolder()) ?>"
        data-ew-action="update-options"
        <?= $Page->DistrictCode->editAttributes() ?>>
        <?= $Page->DistrictCode->selectOptionListHtml("x_DistrictCode") ?>
    </select>
    <div class="invalid-feedback"><?= $Page->DistrictCode->getErrorMessage(false) ?></div>
<?= $Page->DistrictCode->Lookup->getParamTag($Page, "p_x_DistrictCode") ?>
<?php if (!$Page->DistrictCode->IsNativeSelect) { ?>
<script>
loadjs.ready("ffarm_seed_deliveredsearch", function() {
    var options = { name: "x_DistrictCode", selectId: "ffarm_seed_deliveredsearch_x_DistrictCode" },
        el = document.querySelector("select[data-select2-id='" + options.selectId + "']");
    if (!el)
        return;
    options.closeOnSelect = !options.multiple;
    options.dropdownParent = el.closest("#ew-modal-dialog, #ew-add-opt-dialog");
    if (ffarm_seed_deliveredsearch.lists.DistrictCode?.lookupOptions.length) {
        options.data = { id: "x_DistrictCode", form: "ffarm_seed_deliveredsearch" };
    } else {
        options.ajax = { id: "x_DistrictCode", form: "ffarm_seed_deliveredsearch", limit: ew.LOOKUP_PAGE_SIZE };
    }
    options.minimumResultsForSearch = Infinity;
    options = Object.assign({}, ew.selectOptions, options, ew.vars.tables.farm_seed_delivered.fields.DistrictCode.selectOptions);
    ew.createSelect(options);
});
</script>
<?php } ?>
</span>
                </div>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->CampCode->Visible) { // CampCode ?>
    <div id="r_CampCode" class="row"<?= $Page->CampCode->rowAttributes() ?>>
        <label for="x_CampCode" class="<?= $Page->LeftColumnClass ?>"><span id="elh_farm_seed_delivered_CampCode"><?= $Page->CampCode->caption() ?></span>
        <span class="ew-search-operator">
<?= $Language->phrase("=") ?>
<input type="hidden" name="z_CampCode" id="z_CampCode" value="=">
</span>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div<?= $Page->CampCode->cellAttributes() ?>>
                <div class="d-flex align-items-start">
                <span id="el_farm_seed_delivered_CampCode" class="ew-search-field ew-search-field-single">
    <select
        id="x_CampCode"
        name="x_CampCode"
        class="form-select ew-select<?= $Page->CampCode->isInvalidClass() ?>"
        <?php if (!$Page->CampCode->IsNativeSelect) { ?>
        data-select2-id="ffarm_seed_deliveredsearch_x_CampCode"
        <?php } ?>
        data-table="farm_seed_delivered"
        data-field="x_CampCode"
        data-value-separator="<?= $Page->CampCode->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->CampCode->getPlaceHolder()) ?>"
        data-ew-action="update-options"
        <?= $Page->CampCode->editAttributes() ?>>
        <?= $Page->CampCode->selectOptionListHtml("x_CampCode") ?>
    </select>
    <div class="invalid-feedback"><?= $Page->CampCode->getErrorMessage(false) ?></div>
<?= $Page->CampCode->Lookup->getParamTag($Page, "p_x_CampCode") ?>
<?php if (!$Page->CampCode->IsNativeSelect) { ?>
<script>
loadjs.ready("ffarm_seed_deliveredsearch", function() {
    var options = { name: "x_CampCode", selectId: "ffarm_seed_deliveredsearch_x_CampCode" },
        el = document.querySelector("select[data-select2-id='" + options.selectId + "']");
    if (!el)
        return;
    options.closeOnSelect = !options.multiple;
    options.dropdownParent = el.closest("#ew-modal-dialog, #ew-add-opt-dialog");
    if (ffarm_seed_deliveredsearch.lists.CampCode?.lookupOptions.length) {
        options.data = { id: "x_CampCode", form: "ffarm_seed_deliveredsearch" };
    } else {
        options.ajax = { id: "x_CampCode", form: "ffarm_seed_deliveredsearch", limit: ew.LOOKUP_PAGE_SIZE };
    }
    options.minimumResultsForSearch = Infinity;
    options = Object.assign({}, ew.selectOptions, options, ew.vars.tables.farm_seed_delivered.fields.CampCode.selectOptions);
    ew.createSelect(options);
});
</script>
<?php } ?>
</span>
                </div>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->VillageCode->Visible) { // VillageCode ?>
    <div id="r_VillageCode" class="row"<?= $Page->VillageCode->rowAttributes() ?>>
        <label for="x_VillageCode" class="<?= $Page->LeftColumnClass ?>"><span id="elh_farm_seed_delivered_VillageCode"><?= $Page->VillageCode->caption() ?></span>
        <span class="ew-search-operator">
<?= $Language->phrase("=") ?>
<input type="hidden" name="z_VillageCode" id="z_VillageCode" value="=">
</span>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div<?= $Page->VillageCode->cellAttributes() ?>>
                <div class="d-flex align-items-start">
                <span id="el_farm_seed_delivered_VillageCode" class="ew-search-field ew-search-field-single">
    <select
        id="x_VillageCode"
        name="x_VillageCode"
        class="form-select ew-select<?= $Page->VillageCode->isInvalidClass() ?>"
        <?php if (!$Page->VillageCode->IsNativeSelect) { ?>
        data-select2-id="ffarm_seed_deliveredsearch_x_VillageCode"
        <?php } ?>
        data-table="farm_seed_delivered"
        data-field="x_VillageCode"
        data-value-separator="<?= $Page->VillageCode->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->VillageCode->getPlaceHolder()) ?>"
        <?= $Page->VillageCode->editAttributes() ?>>
        <?= $Page->VillageCode->selectOptionListHtml("x_VillageCode") ?>
    </select>
    <div class="invalid-feedback"><?= $Page->VillageCode->getErrorMessage(false) ?></div>
<?= $Page->VillageCode->Lookup->getParamTag($Page, "p_x_VillageCode") ?>
<?php if (!$Page->VillageCode->IsNativeSelect) { ?>
<script>
loadjs.ready("ffarm_seed_deliveredsearch", function() {
    var options = { name: "x_VillageCode", selectId: "ffarm_seed_deliveredsearch_x_VillageCode" },
        el = document.querySelector("select[data-select2-id='" + options.selectId + "']");
    if (!el)
        return;
    options.closeOnSelect = !options.multiple;
    options.dropdownParent = el.closest("#ew-modal-dialog, #ew-add-opt-dialog");
    if (ffarm_seed_deliveredsearch.lists.VillageCode?.lookupOptions.length) {
        options.data = { id: "x_VillageCode", form: "ffarm_seed_deliveredsearch" };
    } else {
        options.ajax = { id: "x_VillageCode", form: "ffarm_seed_deliveredsearch", limit: ew.LOOKUP_PAGE_SIZE };
    }
    options.minimumResultsForSearch = Infinity;
    options = Object.assign({}, ew.selectOptions, options, ew.vars.tables.farm_seed_delivered.fields.VillageCode.selectOptions);
    ew.createSelect(options);
});
</script>
<?php } ?>
</span>
                </div>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->NRC->Visible) { // NRC ?>
    <div id="r_NRC" class="row"<?= $Page->NRC->rowAttributes() ?>>
        <label class="<?= $Page->LeftColumnClass ?>"><span id="elh_farm_seed_delivered_NRC"><?= $Page->NRC->caption() ?></span>
        <span class="ew-search-operator">
<?= $Language->phrase("LIKE") ?>
<input type="hidden" name="z_NRC" id="z_NRC" value="LIKE">
</span>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div<?= $Page->NRC->cellAttributes() ?>>
                <div class="d-flex align-items-start">
                <span id="el_farm_seed_delivered_NRC" class="ew-search-field ew-search-field-single">
<?php
if (IsRTL()) {
    $Page->NRC->EditAttrs["dir"] = "rtl";
}
?>
<span id="as_x_NRC" class="ew-auto-suggest">
    <input type="<?= $Page->NRC->getInputTextType() ?>" class="form-control" name="sv_x_NRC" id="sv_x_NRC" value="<?= RemoveHtml($Page->NRC->EditValue) ?>" autocomplete="off" size="30" maxlength="255" placeholder="<?= HtmlEncode($Page->NRC->getPlaceHolder()) ?>" data-placeholder="<?= HtmlEncode($Page->NRC->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->NRC->formatPattern()) ?>"<?= $Page->NRC->editAttributes() ?>>
</span>
<selection-list hidden class="form-control" data-table="farm_seed_delivered" data-field="x_NRC" data-input="sv_x_NRC" data-value-separator="<?= $Page->NRC->displayValueSeparatorAttribute() ?>" name="x_NRC" id="x_NRC" value="<?= HtmlEncode($Page->NRC->AdvancedSearch->SearchValue) ?>"></selection-list>
<div class="invalid-feedback"><?= $Page->NRC->getErrorMessage(false) ?></div>
<script>
loadjs.ready("ffarm_seed_deliveredsearch", function() {
    ffarm_seed_deliveredsearch.createAutoSuggest(Object.assign({"id":"x_NRC","forceSelect":false}, { lookupAllDisplayFields: <?= $Page->NRC->Lookup->LookupAllDisplayFields ? "true" : "false" ?> }, ew.vars.tables.farm_seed_delivered.fields.NRC.autoSuggestOptions));
});
</script>
<?= $Page->NRC->Lookup->getParamTag($Page, "p_x_NRC") ?>
</span>
                </div>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->FarmerNo->Visible) { // FarmerNo ?>
    <div id="r_FarmerNo" class="row"<?= $Page->FarmerNo->rowAttributes() ?>>
        <label for="x_FarmerNo" class="<?= $Page->LeftColumnClass ?>"><span id="elh_farm_seed_delivered_FarmerNo"><?= $Page->FarmerNo->caption() ?></span>
        <span class="ew-search-operator">
<?= $Language->phrase("=") ?>
<input type="hidden" name="z_FarmerNo" id="z_FarmerNo" value="=">
</span>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div<?= $Page->FarmerNo->cellAttributes() ?>>
                <div class="d-flex align-items-start">
                <span id="el_farm_seed_delivered_FarmerNo" class="ew-search-field ew-search-field-single">
<input type="<?= $Page->FarmerNo->getInputTextType() ?>" name="x_FarmerNo" id="x_FarmerNo" data-table="farm_seed_delivered" data-field="x_FarmerNo" value="<?= $Page->FarmerNo->EditValue ?>" size="30" placeholder="<?= HtmlEncode($Page->FarmerNo->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->FarmerNo->formatPattern()) ?>"<?= $Page->FarmerNo->editAttributes() ?>>
<div class="invalid-feedback"><?= $Page->FarmerNo->getErrorMessage(false) ?></div>
</span>
                </div>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->FarmNo->Visible) { // FarmNo ?>
    <div id="r_FarmNo" class="row"<?= $Page->FarmNo->rowAttributes() ?>>
        <label for="x_FarmNo" class="<?= $Page->LeftColumnClass ?>"><span id="elh_farm_seed_delivered_FarmNo"><?= $Page->FarmNo->caption() ?></span>
        <span class="ew-search-operator">
<?= $Language->phrase("=") ?>
<input type="hidden" name="z_FarmNo" id="z_FarmNo" value="=">
</span>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div<?= $Page->FarmNo->cellAttributes() ?>>
                <div class="d-flex align-items-start">
                <span id="el_farm_seed_delivered_FarmNo" class="ew-search-field ew-search-field-single">
<input type="<?= $Page->FarmNo->getInputTextType() ?>" name="x_FarmNo" id="x_FarmNo" data-table="farm_seed_delivered" data-field="x_FarmNo" value="<?= $Page->FarmNo->EditValue ?>" size="30" placeholder="<?= HtmlEncode($Page->FarmNo->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->FarmNo->formatPattern()) ?>"<?= $Page->FarmNo->editAttributes() ?>>
<div class="invalid-feedback"><?= $Page->FarmNo->getErrorMessage(false) ?></div>
</span>
                </div>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->TransDeliveryNo->Visible) { // TransDeliveryNo ?>
    <div id="r_TransDeliveryNo" class="row"<?= $Page->TransDeliveryNo->rowAttributes() ?>>
        <label for="x_TransDeliveryNo" class="<?= $Page->LeftColumnClass ?>"><span id="elh_farm_seed_delivered_TransDeliveryNo"><?= $Page->TransDeliveryNo->caption() ?></span>
        <span class="ew-search-operator">
<?= $Language->phrase("=") ?>
<input type="hidden" name="z_TransDeliveryNo" id="z_TransDeliveryNo" value="=">
</span>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div<?= $Page->TransDeliveryNo->cellAttributes() ?>>
                <div class="d-flex align-items-start">
                <span id="el_farm_seed_delivered_TransDeliveryNo" class="ew-search-field ew-search-field-single">
<input type="<?= $Page->TransDeliveryNo->getInputTextType() ?>" name="x_TransDeliveryNo" id="x_TransDeliveryNo" data-table="farm_seed_delivered" data-field="x_TransDeliveryNo" value="<?= $Page->TransDeliveryNo->EditValue ?>" placeholder="<?= HtmlEncode($Page->TransDeliveryNo->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->TransDeliveryNo->formatPattern()) ?>"<?= $Page->TransDeliveryNo->editAttributes() ?>>
<div class="invalid-feedback"><?= $Page->TransDeliveryNo->getErrorMessage(false) ?></div>
</span>
                </div>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->TreesDelivered->Visible) { // TreesDelivered ?>
    <div id="r_TreesDelivered" class="row"<?= $Page->TreesDelivered->rowAttributes() ?>>
        <label for="x_TreesDelivered" class="<?= $Page->LeftColumnClass ?>"><span id="elh_farm_seed_delivered_TreesDelivered"><?= $Page->TreesDelivered->caption() ?></span>
        <span class="ew-search-operator">
<?= $Language->phrase("=") ?>
<input type="hidden" name="z_TreesDelivered" id="z_TreesDelivered" value="=">
</span>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div<?= $Page->TreesDelivered->cellAttributes() ?>>
                <div class="d-flex align-items-start">
                <span id="el_farm_seed_delivered_TreesDelivered" class="ew-search-field ew-search-field-single">
<input type="<?= $Page->TreesDelivered->getInputTextType() ?>" name="x_TreesDelivered" id="x_TreesDelivered" data-table="farm_seed_delivered" data-field="x_TreesDelivered" value="<?= $Page->TreesDelivered->EditValue ?>" size="30" placeholder="<?= HtmlEncode($Page->TreesDelivered->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->TreesDelivered->formatPattern()) ?>"<?= $Page->TreesDelivered->editAttributes() ?>>
<div class="invalid-feedback"><?= $Page->TreesDelivered->getErrorMessage(false) ?></div>
</span>
                </div>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->SeedType->Visible) { // SeedType ?>
    <div id="r_SeedType" class="row"<?= $Page->SeedType->rowAttributes() ?>>
        <label for="x_SeedType" class="<?= $Page->LeftColumnClass ?>"><span id="elh_farm_seed_delivered_SeedType"><?= $Page->SeedType->caption() ?></span>
        <span class="ew-search-operator">
<?= $Language->phrase("=") ?>
<input type="hidden" name="z_SeedType" id="z_SeedType" value="=">
</span>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div<?= $Page->SeedType->cellAttributes() ?>>
                <div class="d-flex align-items-start">
                <span id="el_farm_seed_delivered_SeedType" class="ew-search-field ew-search-field-single">
    <select
        id="x_SeedType"
        name="x_SeedType"
        class="form-select ew-select<?= $Page->SeedType->isInvalidClass() ?>"
        <?php if (!$Page->SeedType->IsNativeSelect) { ?>
        data-select2-id="ffarm_seed_deliveredsearch_x_SeedType"
        <?php } ?>
        data-table="farm_seed_delivered"
        data-field="x_SeedType"
        data-value-separator="<?= $Page->SeedType->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->SeedType->getPlaceHolder()) ?>"
        <?= $Page->SeedType->editAttributes() ?>>
        <?= $Page->SeedType->selectOptionListHtml("x_SeedType") ?>
    </select>
    <div class="invalid-feedback"><?= $Page->SeedType->getErrorMessage(false) ?></div>
<?= $Page->SeedType->Lookup->getParamTag($Page, "p_x_SeedType") ?>
<?php if (!$Page->SeedType->IsNativeSelect) { ?>
<script>
loadjs.ready("ffarm_seed_deliveredsearch", function() {
    var options = { name: "x_SeedType", selectId: "ffarm_seed_deliveredsearch_x_SeedType" },
        el = document.querySelector("select[data-select2-id='" + options.selectId + "']");
    if (!el)
        return;
    options.closeOnSelect = !options.multiple;
    options.dropdownParent = el.closest("#ew-modal-dialog, #ew-add-opt-dialog");
    if (ffarm_seed_deliveredsearch.lists.SeedType?.lookupOptions.length) {
        options.data = { id: "x_SeedType", form: "ffarm_seed_deliveredsearch" };
    } else {
        options.ajax = { id: "x_SeedType", form: "ffarm_seed_deliveredsearch", limit: ew.LOOKUP_PAGE_SIZE };
    }
    options.minimumResultsForSearch = Infinity;
    options = Object.assign({}, ew.selectOptions, options, ew.vars.tables.farm_seed_delivered.fields.SeedType.selectOptions);
    ew.createSelect(options);
});
</script>
<?php } ?>
</span>
                </div>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->SourcesOfSeedlings->Visible) { // SourcesOfSeedlings ?>
    <div id="r_SourcesOfSeedlings" class="row"<?= $Page->SourcesOfSeedlings->rowAttributes() ?>>
        <label for="x_SourcesOfSeedlings" class="<?= $Page->LeftColumnClass ?>"><span id="elh_farm_seed_delivered_SourcesOfSeedlings"><?= $Page->SourcesOfSeedlings->caption() ?></span>
        <span class="ew-search-operator">
<?= $Language->phrase("=") ?>
<input type="hidden" name="z_SourcesOfSeedlings" id="z_SourcesOfSeedlings" value="=">
</span>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div<?= $Page->SourcesOfSeedlings->cellAttributes() ?>>
                <div class="d-flex align-items-start">
                <span id="el_farm_seed_delivered_SourcesOfSeedlings" class="ew-search-field ew-search-field-single">
    <select
        id="x_SourcesOfSeedlings"
        name="x_SourcesOfSeedlings"
        class="form-select ew-select<?= $Page->SourcesOfSeedlings->isInvalidClass() ?>"
        <?php if (!$Page->SourcesOfSeedlings->IsNativeSelect) { ?>
        data-select2-id="ffarm_seed_deliveredsearch_x_SourcesOfSeedlings"
        <?php } ?>
        data-table="farm_seed_delivered"
        data-field="x_SourcesOfSeedlings"
        data-value-separator="<?= $Page->SourcesOfSeedlings->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->SourcesOfSeedlings->getPlaceHolder()) ?>"
        <?= $Page->SourcesOfSeedlings->editAttributes() ?>>
        <?= $Page->SourcesOfSeedlings->selectOptionListHtml("x_SourcesOfSeedlings") ?>
    </select>
    <div class="invalid-feedback"><?= $Page->SourcesOfSeedlings->getErrorMessage(false) ?></div>
<?= $Page->SourcesOfSeedlings->Lookup->getParamTag($Page, "p_x_SourcesOfSeedlings") ?>
<?php if (!$Page->SourcesOfSeedlings->IsNativeSelect) { ?>
<script>
loadjs.ready("ffarm_seed_deliveredsearch", function() {
    var options = { name: "x_SourcesOfSeedlings", selectId: "ffarm_seed_deliveredsearch_x_SourcesOfSeedlings" },
        el = document.querySelector("select[data-select2-id='" + options.selectId + "']");
    if (!el)
        return;
    options.closeOnSelect = !options.multiple;
    options.dropdownParent = el.closest("#ew-modal-dialog, #ew-add-opt-dialog");
    if (ffarm_seed_deliveredsearch.lists.SourcesOfSeedlings?.lookupOptions.length) {
        options.data = { id: "x_SourcesOfSeedlings", form: "ffarm_seed_deliveredsearch" };
    } else {
        options.ajax = { id: "x_SourcesOfSeedlings", form: "ffarm_seed_deliveredsearch", limit: ew.LOOKUP_PAGE_SIZE };
    }
    options.minimumResultsForSearch = Infinity;
    options = Object.assign({}, ew.selectOptions, options, ew.vars.tables.farm_seed_delivered.fields.SourcesOfSeedlings.selectOptions);
    ew.createSelect(options);
});
</script>
<?php } ?>
</span>
                </div>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->DeliveryDate->Visible) { // DeliveryDate ?>
    <div id="r_DeliveryDate" class="row"<?= $Page->DeliveryDate->rowAttributes() ?>>
        <label for="x_DeliveryDate" class="<?= $Page->LeftColumnClass ?>"><span id="elh_farm_seed_delivered_DeliveryDate"><?= $Page->DeliveryDate->caption() ?></span>
        <span class="ew-search-operator">
<?= $Language->phrase("=") ?>
<input type="hidden" name="z_DeliveryDate" id="z_DeliveryDate" value="=">
</span>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div<?= $Page->DeliveryDate->cellAttributes() ?>>
                <div class="d-flex align-items-start">
                <span id="el_farm_seed_delivered_DeliveryDate" class="ew-search-field ew-search-field-single">
<input type="<?= $Page->DeliveryDate->getInputTextType() ?>" name="x_DeliveryDate" id="x_DeliveryDate" data-table="farm_seed_delivered" data-field="x_DeliveryDate" value="<?= $Page->DeliveryDate->EditValue ?>" placeholder="<?= HtmlEncode($Page->DeliveryDate->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->DeliveryDate->formatPattern()) ?>"<?= $Page->DeliveryDate->editAttributes() ?>>
<div class="invalid-feedback"><?= $Page->DeliveryDate->getErrorMessage(false) ?></div>
<?php if (!$Page->DeliveryDate->ReadOnly && !$Page->DeliveryDate->Disabled && !isset($Page->DeliveryDate->EditAttrs["readonly"]) && !isset($Page->DeliveryDate->EditAttrs["disabled"])) { ?>
<script>
loadjs.ready(["ffarm_seed_deliveredsearch", "datetimepicker"], function () {
    let format = "<?= DateFormat(0) ?>",
        options = {
            localization: {
                locale: ew.LANGUAGE_ID + "-u-nu-" + ew.getNumberingSystem(),
                hourCycle: format.match(/H/) ? "h24" : "h12",
                format,
                ...ew.language.phrase("datetimepicker")
            },
            display: {
                icons: {
                    previous: ew.IS_RTL ? "fa-solid fa-chevron-right" : "fa-solid fa-chevron-left",
                    next: ew.IS_RTL ? "fa-solid fa-chevron-left" : "fa-solid fa-chevron-right"
                },
                components: {
                    hours: !!format.match(/h/i),
                    minutes: !!format.match(/m/),
                    seconds: !!format.match(/s/i)
                },
                theme: ew.getPreferredTheme()
            }
        };
    ew.createDateTimePicker("ffarm_seed_deliveredsearch", "x_DeliveryDate", ew.deepAssign({"useCurrent":false,"display":{"sideBySide":false}}, options));
});
</script>
<?php } ?>
</span>
                </div>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->PreparedBy->Visible) { // PreparedBy ?>
    <div id="r_PreparedBy" class="row"<?= $Page->PreparedBy->rowAttributes() ?>>
        <label for="x_PreparedBy" class="<?= $Page->LeftColumnClass ?>"><span id="elh_farm_seed_delivered_PreparedBy"><?= $Page->PreparedBy->caption() ?></span>
        <span class="ew-search-operator">
<?= $Language->phrase("LIKE") ?>
<input type="hidden" name="z_PreparedBy" id="z_PreparedBy" value="LIKE">
</span>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div<?= $Page->PreparedBy->cellAttributes() ?>>
                <div class="d-flex align-items-start">
                <span id="el_farm_seed_delivered_PreparedBy" class="ew-search-field ew-search-field-single">
<input type="<?= $Page->PreparedBy->getInputTextType() ?>" name="x_PreparedBy" id="x_PreparedBy" data-table="farm_seed_delivered" data-field="x_PreparedBy" value="<?= $Page->PreparedBy->EditValue ?>" size="30" maxlength="255" placeholder="<?= HtmlEncode($Page->PreparedBy->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->PreparedBy->formatPattern()) ?>"<?= $Page->PreparedBy->editAttributes() ?>>
<div class="invalid-feedback"><?= $Page->PreparedBy->getErrorMessage(false) ?></div>
</span>
                </div>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->AuthorisedBy->Visible) { // AuthorisedBy ?>
    <div id="r_AuthorisedBy" class="row"<?= $Page->AuthorisedBy->rowAttributes() ?>>
        <label for="x_AuthorisedBy" class="<?= $Page->LeftColumnClass ?>"><span id="elh_farm_seed_delivered_AuthorisedBy"><?= $Page->AuthorisedBy->caption() ?></span>
        <span class="ew-search-operator">
<?= $Language->phrase("LIKE") ?>
<input type="hidden" name="z_AuthorisedBy" id="z_AuthorisedBy" value="LIKE">
</span>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div<?= $Page->AuthorisedBy->cellAttributes() ?>>
                <div class="d-flex align-items-start">
                <span id="el_farm_seed_delivered_AuthorisedBy" class="ew-search-field ew-search-field-single">
<input type="<?= $Page->AuthorisedBy->getInputTextType() ?>" name="x_AuthorisedBy" id="x_AuthorisedBy" data-table="farm_seed_delivered" data-field="x_AuthorisedBy" value="<?= $Page->AuthorisedBy->EditValue ?>" size="30" maxlength="255" placeholder="<?= HtmlEncode($Page->AuthorisedBy->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->AuthorisedBy->formatPattern()) ?>"<?= $Page->AuthorisedBy->editAttributes() ?>>
<div class="invalid-feedback"><?= $Page->AuthorisedBy->getErrorMessage(false) ?></div>
</span>
                </div>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->BatchNo->Visible) { // BatchNo ?>
    <div id="r_BatchNo" class="row"<?= $Page->BatchNo->rowAttributes() ?>>
        <label for="x_BatchNo" class="<?= $Page->LeftColumnClass ?>"><span id="elh_farm_seed_delivered_BatchNo"><?= $Page->BatchNo->caption() ?></span>
        <span class="ew-search-operator">
<?= $Language->phrase("LIKE") ?>
<input type="hidden" name="z_BatchNo" id="z_BatchNo" value="LIKE">
</span>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div<?= $Page->BatchNo->cellAttributes() ?>>
                <div class="d-flex align-items-start">
                <span id="el_farm_seed_delivered_BatchNo" class="ew-search-field ew-search-field-single">
<input type="<?= $Page->BatchNo->getInputTextType() ?>" name="x_BatchNo" id="x_BatchNo" data-table="farm_seed_delivered" data-field="x_BatchNo" value="<?= $Page->BatchNo->EditValue ?>" size="30" maxlength="25" placeholder="<?= HtmlEncode($Page->BatchNo->getPlaceHolder()) ?>" data-format-pattern="<?= HtmlEncode($Page->BatchNo->formatPattern()) ?>"<?= $Page->BatchNo->editAttributes() ?>>
<div class="invalid-feedback"><?= $Page->BatchNo->getErrorMessage(false) ?></div>
</span>
                </div>
            </div>
        </div>
    </div>
<?php } ?>
</div><!-- /page* -->
<?= $Page->IsModal ? '<template class="ew-modal-buttons">' : '<div class="row ew-buttons">' ?><!-- buttons .row -->
    <div class="<?= $Page->OffsetColumnClass ?>"><!-- buttons offset -->
        <button class="btn btn-primary ew-btn" name="btn-action" id="btn-action" type="submit" form="ffarm_seed_deliveredsearch"><?= $Language->phrase("Search") ?></button>
        <?php if ($Page->IsModal) { ?>
        <button class="btn btn-default ew-btn" name="btn-cancel" id="btn-cancel" type="button" form="ffarm_seed_deliveredsearch"><?= $Language->phrase("Cancel") ?></button>
        <?php } else { ?>
        <button class="btn btn-default ew-btn" name="btn-reset" id="btn-reset" type="button" form="ffarm_seed_deliveredsearch" data-ew-action="reload"><?= $Language->phrase("Reset") ?></button>
        <?php } ?>
    </div><!-- /buttons offset -->
<?= $Page->IsModal ? "</template>" : "</div>" ?><!-- /buttons .row -->
</form>
<?php
$Page->showPageFooter();
echo GetDebugMessage();
?>
<script>
// Field event handlers
loadjs.ready("head", function() {
    ew.addEventHandlers("farm_seed_delivered");
});
</script>
<script>
loadjs.ready("load", function () {
    // Write your table-specific startup script here, no need to add script tags.
});
</script>
